/*===========================================================================*/
/*   (Reduce/walk.scm)                                                       */
/*   Bigloo (2.6e)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Oct 19 12:13:41 CEST 2004       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.95 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6e -unsafev -no-hello -O2 -rm -unsafe -s -indent Reduce/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_feffectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_readz00;
   obj_t BgL_writez00;
} *BgL_feffectz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castzd2nullzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_castzd2nullzd2_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;


BGL_IMPORT double BGl_roundflz00zz__r4_numbers_6_5_flonumz00(double);
static obj_t BGl_methodzd2initzd2zzreduce_walkz00();
BGL_IMPORT obj_t open_input_string(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
extern obj_t BGl_za2optimzd2dataflowzf3za2z21zzengine_paramz00;
extern obj_t BGl_reducezd2conditionalz12zc0zzreduce_condz00(obj_t);
extern obj_t BGl_za2optimzd2reducezd2betazf3za2zf3zzengine_paramz00;
extern obj_t BGl_reducezd21occz12zc0zzreduce_1occz00(obj_t);
extern obj_t BGl_reducezd2typezd2checkz12z12zzreduce_typecz00(obj_t);
static obj_t BGl_cnstzd2initzd2zzreduce_walkz00();
extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
BGL_IMPORT obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
static obj_t BGl_importedzd2moduleszd2initz00zzreduce_walkz00();
extern obj_t BGl_reducezd2betaz12zc0zzreduce_betaz00(obj_t);
BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
static obj_t BGl__reducezd2walkz12zc0zzreduce_walkz00(obj_t, obj_t, obj_t);
extern obj_t BGl_reducezd2csez12zc0zzreduce_csez00(obj_t);
BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzreduce_walkz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_copyz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_csez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_condz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_typecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_1occz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzreduce_betaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_removez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_reducezd2walkz12zc0zzreduce_walkz00(obj_t, obj_t);
extern obj_t BGl_za2optimza2z00zzengine_paramz00;
extern obj_t BGl_removezd2varzd2zzast_removez00(obj_t, obj_t);
BGL_IMPORT obj_t display_string(obj_t, obj_t);
extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_reducezd2copyz12zc0zzreduce_copyz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzreduce_walkz00 = BUNSPEC;
static obj_t BGl_libraryzd2moduleszd2initz00zzreduce_walkz00();
static obj_t __cnst[ 2 ] ;


DEFINE_STRING( BGl_string3271z00zzreduce_walkz00, BgL_bgl_string3271za700za7za7reduce_walkza7003299z00, "reduce pass-started ", 20 );
DEFINE_STRING( BGl_string3270z00zzreduce_walkz00, BgL_bgl_string3270za700za7za7reduce_walkza7003300z00, "reduce_walk", 11 );
DEFINE_STRING( BGl_string3269z00zzreduce_walkz00, BgL_bgl_string3269za700za7za7reduce_walkza7003301z00, "Reduction", 9 );
DEFINE_STRING( BGl_string3268z00zzreduce_walkz00, BgL_bgl_string3268za700za7za7reduce_walkza7003302z00, "failure during postlude hook", 28 );
DEFINE_STRING( BGl_string3267z00zzreduce_walkz00, BgL_bgl_string3267za700za7za7reduce_walkza7003303z00, " occured, ending ...", 20 );
DEFINE_STRING( BGl_string3266z00zzreduce_walkz00, BgL_bgl_string3266za700za7za7reduce_walkza7003304z00, "", 0 );
DEFINE_STRING( BGl_string3265z00zzreduce_walkz00, BgL_bgl_string3265za700za7za7reduce_walkza7003305z00, "s", 1 );
DEFINE_STRING( BGl_string3264z00zzreduce_walkz00, BgL_bgl_string3264za700za7za7reduce_walkza7003306z00, " error", 6 );
DEFINE_STRING( BGl_string3263z00zzreduce_walkz00, BgL_bgl_string3263za700za7za7reduce_walkza7003307z00, "failure during prelude hook", 27 );
DEFINE_STRING( BGl_string3262z00zzreduce_walkz00, BgL_bgl_string3262za700za7za7reduce_walkza7003308z00, "   . ", 5 );
DEFINE_STRING( BGl_string3261z00zzreduce_walkz00, BgL_bgl_string3261za700za7za7reduce_walkza7003309z00, "Reduction (trivial)", 19 );
DEFINE_EXPORT_PROCEDURE( BGl_reducezd2walkz12zd2envz12zzreduce_walkz00, BgL_bgl__reduceza7d2walkza712za7c0za7za7reduce_walkza7003310z00, va_generic_entry, BGl__reducezd2walkz12zc0zzreduce_walkz00, -2 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzreduce_walkz00(long BgL_checksumz00_1182, char * BgL_fromz00_1183)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzreduce_walkz00))
{ 
BGl_requirezd2initializa7ationz75zzreduce_walkz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzreduce_walkz00(); 
BGl_cnstzd2initzd2zzreduce_walkz00(); 
BGl_importedzd2moduleszd2initz00zzreduce_walkz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "reduce_walk"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "reduce_walk"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
{ /* ./Reduce/walk.scm 15 */
obj_t BgL_cportz00_1175;
BgL_cportz00_1175 = 
open_input_string(BGl_string3271z00zzreduce_walkz00); 
{ 
long BgL_iz00_1176;
BgL_iz00_1176 = ((long)1); 
BgL_loopz00_1177:
if(
(BgL_iz00_1176==((long)-1)))
{ /* ./Reduce/walk.scm 15 */
return BUNSPEC;}  else 
{ /* ./Reduce/walk.scm 15 */
{ /* ./Reduce/walk.scm 15 */
obj_t BgL_arg3275z00_1179;
{ /* ./Reduce/walk.scm 15 */
obj_t BgL_list3278z00_1180;
BgL_list3278z00_1180 = 
MAKE_PAIR(BgL_cportz00_1175, BNIL); 
BgL_arg3275z00_1179 = 
BGl_readz00zz__readerz00(BgL_list3278z00_1180); } 
{ /* ./Reduce/walk.scm 15 */
int BgL_auxz00_1200;
BgL_auxz00_1200 = 
(int)(BgL_iz00_1176); 
CNST_TABLE_SET(BgL_auxz00_1200, BgL_arg3275z00_1179); } } 
{ /* ./Reduce/walk.scm 15 */
int BgL_auxz00_1181;
BgL_auxz00_1181 = 
(int)(
(BgL_iz00_1176-((long)1))); 
{ 
long BgL_iz00_1205;
BgL_iz00_1205 = 
(long)(BgL_auxz00_1181); 
BgL_iz00_1176 = BgL_iz00_1205; 
goto BgL_loopz00_1177;} } } } } } 
}



/* reduce-walk! */
BGL_EXPORTED_DEF obj_t BGl_reducezd2walkz12zc0zzreduce_walkz00(obj_t BgL_globalsz00_1, obj_t BgL_typezd2unsafezd2_2)
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 35 */
{ /* ./Reduce/walk.scm 37 */
bool_t BgL_testz00_1207;
if(
PAIRP(BgL_typezd2unsafezd2_2))
{ /* ./Reduce/walk.scm 37 */
obj_t BgL_pairz00_1121;
BgL_pairz00_1121 = BgL_typezd2unsafezd2_2; 
BgL_testz00_1207 = 
CBOOL(
CAR(BgL_pairz00_1121)); }  else 
{ /* ./Reduce/walk.scm 37 */
BgL_testz00_1207 = ((bool_t)0)
; } 
if(BgL_testz00_1207)
{ /* ./Reduce/walk.scm 37 */
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_list2708z00_673;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2711z00_675;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2715z00_677;
BgL_arg2715z00_677 = 
MAKE_PAIR(
BCHAR(((unsigned char)'\n')), BNIL); 
BgL_arg2711z00_675 = 
MAKE_PAIR(BGl_string3261z00zzreduce_walkz00, BgL_arg2715z00_677); } 
BgL_list2708z00_673 = 
MAKE_PAIR(BGl_string3262z00zzreduce_walkz00, BgL_arg2711z00_675); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list2708z00_673); } 
BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = 
BINT(((long)0)); 
BGl_za2currentzd2passza2zd2zzengine_passz00 = BGl_string3261z00zzreduce_walkz00; 
{ 
obj_t BgL_hooksz00_678;obj_t BgL_hnamesz00_679;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2719z00_681;
BgL_arg2719z00_681 = BNIL; 
BgL_hooksz00_678 = BgL_arg2719z00_681; 
BgL_hnamesz00_679 = BNIL; 
BgL_loopz00_680:
if(
NULLP(BgL_hooksz00_678))
{ /* ./Reduce/walk.scm 38 */
CNST_TABLE_REF(((long)0)); }  else 
{ /* ./Reduce/walk.scm 38 */
bool_t BgL_testz00_1222;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_fun2740z00_691;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_pairz00_1125;
BgL_pairz00_1125 = BgL_hooksz00_678; 
BgL_fun2740z00_691 = 
CAR(BgL_pairz00_1125); } 
BgL_testz00_1222 = 
CBOOL(
PROCEDURE_ENTRY(BgL_fun2740z00_691)(BgL_fun2740z00_691, BEOA)); } 
if(BgL_testz00_1222)
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2727z00_686;obj_t BgL_arg2728z00_687;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_pairz00_1126;
BgL_pairz00_1126 = BgL_hooksz00_678; 
BgL_arg2727z00_686 = 
CDR(BgL_pairz00_1126); } 
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_pairz00_1127;
BgL_pairz00_1127 = BgL_hnamesz00_679; 
BgL_arg2728z00_687 = 
CDR(BgL_pairz00_1127); } 
{ 
obj_t BgL_hnamesz00_1230;obj_t BgL_hooksz00_1229;
BgL_hooksz00_1229 = BgL_arg2727z00_686; 
BgL_hnamesz00_1230 = BgL_arg2728z00_687; 
BgL_hnamesz00_679 = BgL_hnamesz00_1230; 
BgL_hooksz00_678 = BgL_hooksz00_1229; 
goto BgL_loopz00_680;} }  else 
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_arg2735z00_690;
{ /* ./Reduce/walk.scm 38 */
obj_t BgL_pairz00_1128;
BgL_pairz00_1128 = BgL_hnamesz00_679; 
BgL_arg2735z00_690 = 
CAR(BgL_pairz00_1128); } 
BGl_internalzd2errorzd2zztools_errorz00(BGl_string3261z00zzreduce_walkz00, BGl_string3263z00zzreduce_walkz00, BgL_arg2735z00_690); } } } } 
BGl_reducezd21occz12zc0zzreduce_1occz00(BgL_globalsz00_1); 
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_valuez00_692;
BgL_valuez00_692 = 
BGl_removezd2varzd2zzast_removez00(
CNST_TABLE_REF(((long)1)), BgL_globalsz00_1); 
{ /* ./Reduce/walk.scm 40 */
bool_t BgL_testz00_1236;
{ /* ./Reduce/walk.scm 40 */
long BgL_n1z00_1129;
BgL_n1z00_1129 = 
(long)CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00); 
BgL_testz00_1236 = 
(BgL_n1z00_1129>((long)0)); } 
if(BgL_testz00_1236)
{ /* ./Reduce/walk.scm 40 */
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_port2704z00_694;
BgL_port2704z00_694 = 
BGL_CURRENT_ERROR_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, BgL_port2704z00_694); 
display_string(BGl_string3264z00zzreduce_walkz00, BgL_port2704z00_694); 
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_arg2748z00_695;
{ /* ./Reduce/walk.scm 40 */
bool_t BgL_testz00_1242;
{ /* ./Reduce/walk.scm 40 */
bool_t BgL_testz00_1243;
{ /* ./Reduce/walk.scm 40 */
bool_t BgL_res3216z00_1137;
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_objz00_1131;
BgL_objz00_1131 = BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00; 
if(
INTEGERP(BgL_objz00_1131))
{ /* ./Reduce/walk.scm 40 */
BgL_res3216z00_1137 = ((bool_t)1); }  else 
{ /* ./Reduce/walk.scm 40 */
if(
REALP(BgL_objz00_1131))
{ /* ./Reduce/walk.scm 40 */
double BgL_arg1448z00_1134;
BgL_arg1448z00_1134 = 
BGl_roundflz00zz__r4_numbers_6_5_flonumz00(
REAL_TO_DOUBLE(BgL_objz00_1131)); 
BgL_res3216z00_1137 = 
(
REAL_TO_DOUBLE(BgL_objz00_1131)==BgL_arg1448z00_1134); }  else 
{ /* ./Reduce/walk.scm 40 */
BgL_res3216z00_1137 = ((bool_t)0); } } } 
BgL_testz00_1243 = BgL_res3216z00_1137; } 
if(BgL_testz00_1243)
{ /* ./Reduce/walk.scm 40 */
BgL_testz00_1242 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, 
BINT(((long)1)))
; }  else 
{ /* ./Reduce/walk.scm 40 */
BgL_testz00_1242 = ((bool_t)0)
; } } 
if(BgL_testz00_1242)
{ /* ./Reduce/walk.scm 40 */
BgL_arg2748z00_695 = BGl_string3265z00zzreduce_walkz00; }  else 
{ /* ./Reduce/walk.scm 40 */
BgL_arg2748z00_695 = BGl_string3266z00zzreduce_walkz00; } } 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2748z00_695, BgL_port2704z00_694); } 
display_string(BGl_string3267z00zzreduce_walkz00, BgL_port2704z00_694); 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2704z00_694); } 
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_list2758z00_698;
BgL_list2758z00_698 = 
MAKE_PAIR(
BINT(((long)-1)), BNIL); 
return 
BGl_exitz00zz__errorz00(BgL_list2758z00_698);} }  else 
{ 
obj_t BgL_hooksz00_699;obj_t BgL_hnamesz00_700;
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_arg2761z00_702;
BgL_arg2761z00_702 = BNIL; 
BgL_hooksz00_699 = BgL_arg2761z00_702; 
BgL_hnamesz00_700 = BNIL; 
BgL_loopz00_701:
if(
NULLP(BgL_hooksz00_699))
{ /* ./Reduce/walk.scm 40 */
return BgL_valuez00_692;}  else 
{ /* ./Reduce/walk.scm 40 */
bool_t BgL_testz00_1262;
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_fun2781z00_711;
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_pairz00_1142;
BgL_pairz00_1142 = BgL_hooksz00_699; 
BgL_fun2781z00_711 = 
CAR(BgL_pairz00_1142); } 
BgL_testz00_1262 = 
CBOOL(
PROCEDURE_ENTRY(BgL_fun2781z00_711)(BgL_fun2781z00_711, BEOA)); } 
if(BgL_testz00_1262)
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_arg2769z00_707;obj_t BgL_arg2770z00_708;
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_pairz00_1143;
BgL_pairz00_1143 = BgL_hooksz00_699; 
BgL_arg2769z00_707 = 
CDR(BgL_pairz00_1143); } 
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_pairz00_1144;
BgL_pairz00_1144 = BgL_hnamesz00_700; 
BgL_arg2770z00_708 = 
CDR(BgL_pairz00_1144); } 
{ 
obj_t BgL_hnamesz00_1270;obj_t BgL_hooksz00_1269;
BgL_hooksz00_1269 = BgL_arg2769z00_707; 
BgL_hnamesz00_1270 = BgL_arg2770z00_708; 
BgL_hnamesz00_700 = BgL_hnamesz00_1270; 
BgL_hooksz00_699 = BgL_hooksz00_1269; 
goto BgL_loopz00_701;} }  else 
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_arg2776z00_710;
{ /* ./Reduce/walk.scm 40 */
obj_t BgL_pairz00_1145;
BgL_pairz00_1145 = BgL_hnamesz00_700; 
BgL_arg2776z00_710 = 
CAR(BgL_pairz00_1145); } 
return 
BGl_internalzd2errorzd2zztools_errorz00(BGl_za2currentzd2passza2zd2zzengine_passz00, BGl_string3268z00zzreduce_walkz00, BgL_arg2776z00_710);} } } } } } }  else 
{ /* ./Reduce/walk.scm 37 */
if(
CBOOL(BGl_za2optimzd2dataflowzf3za2z21zzengine_paramz00))
{ /* ./Reduce/walk.scm 41 */
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_list2787z00_712;
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_arg2790z00_714;
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_arg2794z00_716;
BgL_arg2794z00_716 = 
MAKE_PAIR(
BCHAR(((unsigned char)'\n')), BNIL); 
BgL_arg2790z00_714 = 
MAKE_PAIR(BGl_string3269z00zzreduce_walkz00, BgL_arg2794z00_716); } 
BgL_list2787z00_712 = 
MAKE_PAIR(BGl_string3262z00zzreduce_walkz00, BgL_arg2790z00_714); } 
BGl_verbosez00zztools_speekz00(
BINT(((long)1)), BgL_list2787z00_712); } 
BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = 
BINT(((long)0)); 
BGl_za2currentzd2passza2zd2zzengine_passz00 = BGl_string3269z00zzreduce_walkz00; 
{ 
obj_t BgL_hooksz00_717;obj_t BgL_hnamesz00_718;
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_arg2798z00_720;
BgL_arg2798z00_720 = BNIL; 
BgL_hooksz00_717 = BgL_arg2798z00_720; 
BgL_hnamesz00_718 = BNIL; 
BgL_loopz00_719:
if(
NULLP(BgL_hooksz00_717))
{ /* ./Reduce/walk.scm 42 */
CNST_TABLE_REF(((long)0)); }  else 
{ /* ./Reduce/walk.scm 42 */
bool_t BgL_testz00_1285;
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_fun2819z00_730;
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_pairz00_1149;
BgL_pairz00_1149 = BgL_hooksz00_717; 
BgL_fun2819z00_730 = 
CAR(BgL_pairz00_1149); } 
BgL_testz00_1285 = 
CBOOL(
PROCEDURE_ENTRY(BgL_fun2819z00_730)(BgL_fun2819z00_730, BEOA)); } 
if(BgL_testz00_1285)
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_arg2806z00_725;obj_t BgL_arg2807z00_726;
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_pairz00_1150;
BgL_pairz00_1150 = BgL_hooksz00_717; 
BgL_arg2806z00_725 = 
CDR(BgL_pairz00_1150); } 
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_pairz00_1151;
BgL_pairz00_1151 = BgL_hnamesz00_718; 
BgL_arg2807z00_726 = 
CDR(BgL_pairz00_1151); } 
{ 
obj_t BgL_hnamesz00_1293;obj_t BgL_hooksz00_1292;
BgL_hooksz00_1292 = BgL_arg2806z00_725; 
BgL_hnamesz00_1293 = BgL_arg2807z00_726; 
BgL_hnamesz00_718 = BgL_hnamesz00_1293; 
BgL_hooksz00_717 = BgL_hooksz00_1292; 
goto BgL_loopz00_719;} }  else 
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_arg2814z00_729;
{ /* ./Reduce/walk.scm 42 */
obj_t BgL_pairz00_1152;
BgL_pairz00_1152 = BgL_hnamesz00_718; 
BgL_arg2814z00_729 = 
CAR(BgL_pairz00_1152); } 
BGl_internalzd2errorzd2zztools_errorz00(BGl_string3269z00zzreduce_walkz00, BGl_string3263z00zzreduce_walkz00, BgL_arg2814z00_729); } } } } 
BGl_reducezd2copyz12zc0zzreduce_copyz00(BgL_globalsz00_1); 
{ /* ./Reduce/walk.scm 44 */
bool_t BgL_testz00_1297;
{ /* ./Reduce/walk.scm 44 */
long BgL_n1z00_1153;
BgL_n1z00_1153 = 
(long)CINT(BGl_za2optimza2z00zzengine_paramz00); 
BgL_testz00_1297 = 
(BgL_n1z00_1153>=((long)2)); } 
if(BgL_testz00_1297)
{ /* ./Reduce/walk.scm 44 */
BGl_reducezd2csez12zc0zzreduce_csez00(BgL_globalsz00_1); }  else 
{ /* ./Reduce/walk.scm 44 */BUNSPEC; } } 
BGl_reducezd2typezd2checkz12z12zzreduce_typecz00(BgL_globalsz00_1); 
BGl_reducezd2copyz12zc0zzreduce_copyz00(BgL_globalsz00_1); 
BGl_reducezd2conditionalz12zc0zzreduce_condz00(BgL_globalsz00_1); 
BGl_reducezd21occz12zc0zzreduce_1occz00(BgL_globalsz00_1); 
if(
CBOOL(BGl_za2optimzd2reducezd2betazf3za2zf3zzengine_paramz00))
{ /* ./Reduce/walk.scm 50 */
BGl_reducezd2betaz12zc0zzreduce_betaz00(BgL_globalsz00_1); }  else 
{ /* ./Reduce/walk.scm 50 */BUNSPEC; } 
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_valuez00_732;
BgL_valuez00_732 = 
BGl_removezd2varzd2zzast_removez00(
CNST_TABLE_REF(((long)1)), BgL_globalsz00_1); 
{ /* ./Reduce/walk.scm 52 */
bool_t BgL_testz00_1310;
{ /* ./Reduce/walk.scm 52 */
long BgL_n1z00_1155;
BgL_n1z00_1155 = 
(long)CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00); 
BgL_testz00_1310 = 
(BgL_n1z00_1155>((long)0)); } 
if(BgL_testz00_1310)
{ /* ./Reduce/walk.scm 52 */
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_port2705z00_734;
BgL_port2705z00_734 = 
BGL_CURRENT_ERROR_PORT(); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, BgL_port2705z00_734); 
display_string(BGl_string3264z00zzreduce_walkz00, BgL_port2705z00_734); 
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_arg2835z00_735;
{ /* ./Reduce/walk.scm 52 */
bool_t BgL_testz00_1316;
{ /* ./Reduce/walk.scm 52 */
bool_t BgL_testz00_1317;
{ /* ./Reduce/walk.scm 52 */
bool_t BgL_res3219z00_1163;
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_objz00_1157;
BgL_objz00_1157 = BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00; 
if(
INTEGERP(BgL_objz00_1157))
{ /* ./Reduce/walk.scm 52 */
BgL_res3219z00_1163 = ((bool_t)1); }  else 
{ /* ./Reduce/walk.scm 52 */
if(
REALP(BgL_objz00_1157))
{ /* ./Reduce/walk.scm 52 */
double BgL_arg1448z00_1160;
BgL_arg1448z00_1160 = 
BGl_roundflz00zz__r4_numbers_6_5_flonumz00(
REAL_TO_DOUBLE(BgL_objz00_1157)); 
BgL_res3219z00_1163 = 
(
REAL_TO_DOUBLE(BgL_objz00_1157)==BgL_arg1448z00_1160); }  else 
{ /* ./Reduce/walk.scm 52 */
BgL_res3219z00_1163 = ((bool_t)0); } } } 
BgL_testz00_1317 = BgL_res3219z00_1163; } 
if(BgL_testz00_1317)
{ /* ./Reduce/walk.scm 52 */
BgL_testz00_1316 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00, 
BINT(((long)1)))
; }  else 
{ /* ./Reduce/walk.scm 52 */
BgL_testz00_1316 = ((bool_t)0)
; } } 
if(BgL_testz00_1316)
{ /* ./Reduce/walk.scm 52 */
BgL_arg2835z00_735 = BGl_string3265z00zzreduce_walkz00; }  else 
{ /* ./Reduce/walk.scm 52 */
BgL_arg2835z00_735 = BGl_string3266z00zzreduce_walkz00; } } 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg2835z00_735, BgL_port2705z00_734); } 
display_string(BGl_string3267z00zzreduce_walkz00, BgL_port2705z00_734); 
WRITE_CHAR(((unsigned char)'\n'), BgL_port2705z00_734); } 
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_list2845z00_738;
BgL_list2845z00_738 = 
MAKE_PAIR(
BINT(((long)-1)), BNIL); 
return 
BGl_exitz00zz__errorz00(BgL_list2845z00_738);} }  else 
{ 
obj_t BgL_hooksz00_739;obj_t BgL_hnamesz00_740;
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_arg2848z00_742;
BgL_arg2848z00_742 = BNIL; 
BgL_hooksz00_739 = BgL_arg2848z00_742; 
BgL_hnamesz00_740 = BNIL; 
BgL_loopz00_741:
if(
NULLP(BgL_hooksz00_739))
{ /* ./Reduce/walk.scm 52 */
return BgL_valuez00_732;}  else 
{ /* ./Reduce/walk.scm 52 */
bool_t BgL_testz00_1336;
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_fun2868z00_751;
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_pairz00_1168;
BgL_pairz00_1168 = BgL_hooksz00_739; 
BgL_fun2868z00_751 = 
CAR(BgL_pairz00_1168); } 
BgL_testz00_1336 = 
CBOOL(
PROCEDURE_ENTRY(BgL_fun2868z00_751)(BgL_fun2868z00_751, BEOA)); } 
if(BgL_testz00_1336)
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_arg2856z00_747;obj_t BgL_arg2857z00_748;
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_pairz00_1169;
BgL_pairz00_1169 = BgL_hooksz00_739; 
BgL_arg2856z00_747 = 
CDR(BgL_pairz00_1169); } 
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_pairz00_1170;
BgL_pairz00_1170 = BgL_hnamesz00_740; 
BgL_arg2857z00_748 = 
CDR(BgL_pairz00_1170); } 
{ 
obj_t BgL_hnamesz00_1344;obj_t BgL_hooksz00_1343;
BgL_hooksz00_1343 = BgL_arg2856z00_747; 
BgL_hnamesz00_1344 = BgL_arg2857z00_748; 
BgL_hnamesz00_740 = BgL_hnamesz00_1344; 
BgL_hooksz00_739 = BgL_hooksz00_1343; 
goto BgL_loopz00_741;} }  else 
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_arg2863z00_750;
{ /* ./Reduce/walk.scm 52 */
obj_t BgL_pairz00_1171;
BgL_pairz00_1171 = BgL_hnamesz00_740; 
BgL_arg2863z00_750 = 
CAR(BgL_pairz00_1171); } 
return 
BGl_internalzd2errorzd2zztools_errorz00(BGl_za2currentzd2passza2zd2zzengine_passz00, BGl_string3268z00zzreduce_walkz00, BgL_arg2863z00_750);} } } } } } }  else 
{ /* ./Reduce/walk.scm 41 */
return BgL_globalsz00_1;} } } } 
}



/* _reduce-walk! */
obj_t BGl__reducezd2walkz12zc0zzreduce_walkz00(obj_t BgL_envz00_1172, obj_t BgL_globalsz00_1173, obj_t BgL_typezd2unsafezd2_1174)
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 35 */
return 
BGl_reducezd2walkz12zc0zzreduce_walkz00(BgL_globalsz00_1173, BgL_typezd2unsafezd2_1174);} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzreduce_walkz00()
{ AN_OBJECT;
{ /* ./Reduce/walk.scm 15 */
BGl_modulezd2initializa7ationz75zztools_speekz00(((long)23537), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zztools_errorz00(((long)25566), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzengine_passz00(((long)10268), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30833), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)2473), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)44246), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_copyz00(((long)31712), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_csez00(((long)15139), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_condz00(((long)24814), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_typecz00(((long)31464), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_1occz00(((long)64130), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
BGl_modulezd2initializa7ationz75zzreduce_betaz00(((long)32822), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00)); 
return 
BGl_modulezd2initializa7ationz75zzast_removez00(((long)12493), 
BSTRING_TO_STRING(BGl_string3270z00zzreduce_walkz00));} 
}

