/*===========================================================================*/
/*   (Jvm/compiler.scm)                                                      */
/*   Bigloo (2.6e)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Oct 19 12:13:41 CEST 2004       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.95 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6e -unsafev -no-hello -O2 -rm -unsafe -s -indent Jvm/compiler.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_feffectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_readz00;
   obj_t BgL_writez00;
} *BgL_feffectz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_argszd2typezd2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castzd2nullzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_effectz00;
} *BgL_castzd2nullzd2_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;

typedef struct BgL_tclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   struct BgL_globalz00_bgl * BgL_holderz00;
   obj_t BgL_wideningz00;
   long BgL_depthz00;
   bool_t BgL_finalzf3zf3;
   obj_t BgL_constructorz00;
   obj_t BgL_virtualzd2slotszd2numberz00;
   bool_t BgL_abstractzf3zf3;
   obj_t BgL_widezd2typezd2;
} *BgL_tclassz00_bglt;

typedef struct BgL_jclassz00_bgl {
   obj_t BgL_itszd2superzd2;
   obj_t BgL_slotsz00;
   obj_t BgL_packagez00;
} *BgL_jclassz00_bglt;

typedef struct BgL_wclassz00_bgl {
   obj_t BgL_itszd2classzd2;
} *BgL_wclassz00_bglt;

typedef struct BgL_jarrayz00_bgl {
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_jarrayz00_bglt;

typedef struct BgL_envz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_declarationsz00;
   obj_t BgL_declaredtypez00;
   obj_t BgL_declaredclassz00;
   obj_t BgL_declaredmodulez00;
   obj_t BgL_currentzd2modulezd2;
   obj_t BgL_declaredfieldsz00;
   obj_t BgL_declaredglobalz00;
   obj_t BgL_libdeclaredz00;
   obj_t BgL_proceduresz00;
   obj_t BgL_clinitzd2codezd2;
   obj_t BgL_currentzd2methodzd2;
   obj_t BgL_vcountz00;
   obj_t BgL_localsz00;
   obj_t BgL_freelocalsz00;
   obj_t BgL_maplocalsz00;
   obj_t BgL_stackz00;
   obj_t BgL_codez00;
} *BgL_envz00_bglt;


static obj_t BGl_check_type_vectorz00zzjvm_compilerz00(BgL_envz00_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2ifzd2zzjvm_compilerz00(BgL_conditionalz00_bglt, BgL_envz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2boxzd2refz00zzjvm_compilerz00(BgL_boxzd2refzd2_bglt, BgL_envz00_bglt);
static obj_t BGl_methodzd2initzd2zzjvm_compilerz00();
BGL_EXPORTED_DECL obj_t BGl_compilerzd2boxzd2setz12z12zzjvm_compilerz00(BgL_boxzd2setz12zc0_bglt, BgL_envz00_bglt);
extern obj_t BGl_specialzd2inlinezd2callzf3zf3zzjvm_inlinez00;
BGL_EXPORTED_DECL obj_t BGl_compilerzd2funcallzd2zzjvm_compilerz00(BgL_funcallz00_bglt, BgL_envz00_bglt);
BGL_IMPORT obj_t open_input_string(obj_t);
static obj_t BGl__compilerzd2apply5429zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
static obj_t BGl_setzd2typezd2zzjvm_compilerz00(obj_t, obj_t);
extern obj_t BGl_nodez00zzast_nodez00;
extern obj_t BGl_sfunz00zzast_varz00;
static obj_t BGl_howzd2tozd2callz00zzjvm_compilerz00(BgL_envz00_bglt, BgL_variablez00_bglt, obj_t);
extern obj_t BGl__newarrayz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl__compilerzd2boxzd2ref5462z00zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__instanceofz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
extern obj_t BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_selectzd2intzd2zzjvm_compilerz00(BgL_envz00_bglt, obj_t, obj_t, obj_t, BgL_selectz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2labelszd2zzjvm_compilerz00(BgL_letzd2funzd2_bglt, BgL_envz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2getfieldzd2zzjvm_compilerz00(BgL_getfieldz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_compilezd2tailzd2zzjvm_tailz00(BgL_nodez00_bglt, BgL_envz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2pragmazd2zzjvm_compilerz00(BgL_pragmaz00_bglt, BgL_envz00_bglt);
extern obj_t BGl__arraylengthz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl__compilerzd2boxzd2setz125464z12zzjvm_compilerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2makezd2boxz00zzjvm_compilerz00(BgL_makezd2boxzd2_bglt, BgL_envz00_bglt);
BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl__compilerzd2if5421zd2zzjvm_compilerz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__aconst_nullz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl__compilerzd2labels5425zd2zzjvm_compilerz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_compilezd2typezd2zzjvm_envz00(obj_t, BgL_envz00_bglt);
extern obj_t BGl_getzd2linezd2numberz00zzjvm_externz00(BgL_nodez00_bglt);
extern obj_t BGl_envzd2alloczd2localz00zzjvm_envz00(BgL_envz00_bglt, obj_t);
static obj_t BGl__compilerzd2app5427zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2vset5445zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl_debugzd2declarezd2varzd2fromzd2zzjvm_externz00(BgL_envz00_bglt, BgL_localz00_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern obj_t BGl_globalz00zzast_varz00;
BGL_EXPORTED_DECL obj_t BGl_compilerzd2failzd2zzjvm_compilerz00(BgL_failz00_bglt, BgL_envz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2atomzd2zzjvm_compilerz00(obj_t, BgL_envz00_bglt);
extern BgL_typez00_bglt BGl_typeofz00zztype_typeofz00(BgL_nodez00_bglt);
static obj_t BGl__compilerzd2select5423zd2zzjvm_compilerz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2body5409zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
static obj_t BGl_specialzd2callzf3z21zzjvm_compilerz00(BgL_variablez00_bglt, obj_t, BgL_envz00_bglt);
extern obj_t BGl_envzd2declarezd2localz00zzjvm_envz00(BgL_envz00_bglt, BgL_localz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2castzd2zzjvm_compilerz00(BgL_castz00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl__compilerzd2castzd2nullz00zzjvm_compilerz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2pragma5433zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__putfieldz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_compilezd2procedurezd2entryz00zzjvm_compilerz00(BgL_globalz00_bglt, long, BgL_envz00_bglt);
static obj_t BGl__compilerzd2cast5452zd2zzjvm_compilerz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__aloadz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_varz00zzast_nodez00;
extern obj_t BGl__loadz00zzjvm_instrz00(BgL_envz00_bglt, BgL_localz00_bglt);
static obj_t BGl_cnstzd2initzd2zzjvm_compilerz00();
static obj_t BGl__compilerzd2vlength5447zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__newz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl__compilerzd2let5415zd2zzjvm_compilerz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t display_fixnum(obj_t, obj_t);
static obj_t BGl_typezd2argszd2zzjvm_compilerz00(BgL_variablez00_bglt, BgL_envz00_bglt);
extern obj_t BGl_debugzd2forzd2declarezd2varzf3z21zzjvm_externz00(BgL_envz00_bglt);
BGL_IMPORT obj_t BGl_displayzd22zd2zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_compilezd2typezd2nowideningz00zzjvm_envz00(obj_t, BgL_envz00_bglt);
extern obj_t BGl_envzd2newzd2getsetz00zzjvm_envz00(BgL_envz00_bglt, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzjvm_compilerz00();
BGL_EXPORTED_DECL obj_t BGl_compilerzd2castzd2nullz00zzjvm_compilerz00(BgL_castzd2nullzd2_bglt, BgL_envz00_bglt);
extern obj_t BGl_createzd2stringzd2zzjvm_instrz00(obj_t, obj_t);
static obj_t BGl__compilerzd2makezd2box5460z00zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__store_namez00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_envzd2newzd2procedurez00zzjvm_envz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_envzd2setzd2namez12z12zzjvm_envz00(BgL_envz00_bglt, BgL_localz00_bglt, obj_t);
extern obj_t BGl_compilezd2effectzd2zzjvm_effectz00(BgL_nodez00_bglt, BgL_envz00_bglt);
extern obj_t BGl__astorez00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2vsetzd2zzjvm_compilerz00(BgL_vsetz12z12_bglt, BgL_envz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2selectzd2zzjvm_compilerz00(BgL_selectz00_bglt, BgL_envz00_bglt, obj_t);
extern obj_t BGl__checkcastz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__load_namez00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl__switchz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2valloczd2zzjvm_compilerz00(BgL_vallocz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_variablez00zzast_varz00;
extern obj_t BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2valloc5441zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__storez00zzjvm_instrz00(BgL_envz00_bglt, BgL_localz00_bglt);
static obj_t BGl_toplevelzd2initzd2zzjvm_compilerz00();
extern obj_t BGl_jclassz00zzobject_classz00;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzjvm_compilerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzforeign_jtypez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_lispz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_externz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_instrz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_inlinez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_tailz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_exprz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_effectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzjvm_predicatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl__athrowz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl__compilerzd2vref5443zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2appzd2zzjvm_compilerz00(BgL_appz00_bglt, BgL_envz00_bglt);
static obj_t BGl__compilerzd2setexit5454zd2zzjvm_compilerz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2jumpzd2exit5456z00zzjvm_compilerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2vrefzd2zzjvm_compilerz00(BgL_vrefz00_bglt, BgL_envz00_bglt);
extern obj_t BGl__putstaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_za2longislongza2z00zzjvm_envz00;
BGL_EXPORTED_DECL obj_t BGl_compilerzd2vlengthzd2zzjvm_compilerz00(BgL_vlengthz00_bglt, BgL_envz00_bglt);
static obj_t BGl__compilerzd2funcall5431zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2setq5417zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2setqzd2zzjvm_compilerz00(BgL_setqz00_bglt, BgL_envz00_bglt);
static obj_t BGl__compilerzd2new5439zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__getstatic2z00zzjvm_instrz00(BgL_envz00_bglt, BgL_globalz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2newzd2zzjvm_compilerz00(BgL_newz00_bglt, BgL_envz00_bglt);
BGL_IMPORT obj_t bgl_reverse(obj_t);
static obj_t BGl__compilerzd2getfield5435zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2applyzd2zzjvm_compilerz00(BgL_appzd2lyzd2_bglt, BgL_envz00_bglt);
extern obj_t BGl_inlinezd2callzf3z21zzjvm_inlinez00;
extern obj_t BGl_shapez00zztools_shapez00(obj_t);
static obj_t BGl_getzd2typezd2zzjvm_compilerz00(obj_t);
extern obj_t BGl__invokespecial_initz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_envzd2freezd2localz00zzjvm_envz00(BgL_envz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2jumpzd2exitz00zzjvm_compilerz00(BgL_jumpzd2exzd2itz00_bglt, BgL_envz00_bglt);
extern obj_t BGl__dupz00zzjvm_instrz00(BgL_envz00_bglt);
extern obj_t BGl_cfunz00zzast_varz00;
extern obj_t BGl__getfieldz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
static obj_t BGl__compilerzd2setfield5437zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2setfieldzd2zzjvm_compilerz00(BgL_setfieldz00_bglt, BgL_envz00_bglt);
extern obj_t BGl_envzd2declarezd2fieldz00zzjvm_envz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2var5413zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__l2iz00zzjvm_instrz00(BgL_envz00_bglt);
static obj_t BGl__compilerzd2atom5411zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
static obj_t BGl_check_typez00zzjvm_compilerz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl__getstaticz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2letzd2zzjvm_compilerz00(BgL_letzd2varzd2_bglt, BgL_envz00_bglt, obj_t);
BGL_IMPORT obj_t display_string(obj_t, obj_t);
static obj_t BGl__compilerzd2sequence5419zd2zzjvm_compilerz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl__pushz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_localz00zzast_varz00;
BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2sequencezd2zzjvm_compilerz00(BgL_sequencez00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_compilezd2labelzd2callz00zzjvm_compilerz00(BgL_variablez00_bglt, obj_t, BgL_envz00_bglt);
BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
extern obj_t BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_bglt, BgL_globalz00_bglt);
extern obj_t BGl_compilezd2predicatezd2zzjvm_predicatez00(BgL_nodez00_bglt, obj_t, obj_t, BgL_envz00_bglt);
static obj_t BGl_za2labels2savedza2z00zzjvm_compilerz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_compilerzd2isazd2zzjvm_compilerz00(BgL_isaz00_bglt, BgL_envz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2setexitzd2zzjvm_compilerz00(BgL_setzd2exzd2itz00_bglt, BgL_envz00_bglt, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzjvm_compilerz00 = BUNSPEC;
static obj_t BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_bglt, obj_t, obj_t);
extern obj_t BGl_debugzd2declarezd2varz00zzjvm_externz00(BgL_envz00_bglt, BgL_localz00_bglt, obj_t);
extern obj_t BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__gotoz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl_compilezd2exprzd2zzjvm_exprz00(BgL_nodez00_bglt, BgL_envz00_bglt);
extern obj_t BGl_envzd2declarezd2newzd2localzd2zzjvm_envz00(BgL_envz00_bglt, BgL_localz00_bglt);
extern obj_t BGl_envzd2declarezd2initz00zzjvm_envz00(obj_t, obj_t);
static obj_t BGl_za2labdoneza2z00zzjvm_compilerz00 = BUNSPEC;
extern obj_t BGl__linez00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
static obj_t BGl_za2lab2labelsza2z00zzjvm_compilerz00 = BUNSPEC;
static obj_t BGl_libraryzd2moduleszd2initz00zzjvm_compilerz00();
extern obj_t BGl__labelz00zzjvm_instrz00(BgL_envz00_bglt, obj_t);
extern obj_t BGl__invokeinterfacez00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl_za2purifyza2z00zzengine_paramz00;
BGL_EXPORTED_DECL obj_t BGl_compilerzd2varzd2zzjvm_compilerz00(BgL_varz00_bglt, BgL_envz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_compilerzd2bodyzd2zzjvm_compilerz00(BgL_nodez00_bglt, BgL_envz00_bglt);
static obj_t BGl__compilerzd2fail5458zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
static obj_t BGl__compilerzd2isa5449zd2zzjvm_compilerz00(obj_t, obj_t, obj_t);
extern obj_t BGl__handlerz00zzjvm_instrz00(BgL_envz00_bglt, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 76 ] ;


DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2varzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2var5413za7d2za7za7jvm_compilerza7005916za7, BGl__compilerzd2var5413zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2sequencezd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2sequence5419za7d2za7za7jvm_compilerza7005917za7, BGl__compilerzd2sequence5419zd2zzjvm_compilerz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2setfieldzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2setfield5437za7d2za7za7jvm_compilerza7005918za7, BGl__compilerzd2setfield5437zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2setexitzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2setexit5454za7d2za7za7jvm_compilerza7005919za7, BGl__compilerzd2setexit5454zd2zzjvm_compilerz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2funcallzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2funcall5431za7d2za7za7jvm_compilerza7005920za7, BGl__compilerzd2funcall5431zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2castzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2cast5452za7d2za7za7jvm_compilerza7005921za7, BGl__compilerzd2cast5452zd2zzjvm_compilerz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2bodyzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2body5409za7d2za7za7jvm_compilerza7005922za7, BGl__compilerzd2body5409zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2valloczd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2valloc5441za7d2za7za7jvm_compilerza7005923za7, BGl__compilerzd2valloc5441zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2jumpzd2exitzd2envzd2zzjvm_compilerz00, BgL_bgl__compilerza7d2jumpza7d2exit5456za700za7za7jvm_compilerza7005924z00, BGl__compilerzd2jumpzd2exit5456z00zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2vsetzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2vset5445za7d2za7za7jvm_compilerza7005925za7, BGl__compilerzd2vset5445zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2isazd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2isa5449za7d2za7za7jvm_compilerza7005926za7, BGl__compilerzd2isa5449zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2vlengthzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2vlength5447za7d2za7za7jvm_compilerza7005927za7, BGl__compilerzd2vlength5447zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2boxzd2refzd2envzd2zzjvm_compilerz00, BgL_bgl__compilerza7d2boxza7d2ref5462za700za7za7jvm_compilerza7005928z00, BGl__compilerzd2boxzd2ref5462z00zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2makezd2boxzd2envzd2zzjvm_compilerz00, BgL_bgl__compilerza7d2makeza7d2box5460za700za7za7jvm_compilerza7005929z00, BGl__compilerzd2makezd2box5460z00zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2ifzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2if5421za7d2za7za7jvm_compilerza7005930za7, BGl__compilerzd2if5421zd2zzjvm_compilerz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2castzd2nullzd2envzd2zzjvm_compilerz00, BgL_bgl__compilerza7d2castza7d2nullza700za7za7jvm_compilerza7005931z00, BGl__compilerzd2castzd2nullz00zzjvm_compilerz00, 0L, 2 );
DEFINE_STRING( BGl_string5886z00zzjvm_compilerz00, BgL_bgl_string5886za700za7za7jvm_compilerza7005932z00, "j_cell ccar init_cell cell fail jumpexit debug_handler j_exit j_bexception setexit ptr_alg (ad ad ad ad ad) funcall4 (ad ad ad ad) funcall3 (ad ad ad) funcall2 funcall1 funcall0 cons ad (ad ad) apply j_procedure __evmeaning_address cnst-table-set! constants cnst-table-ref make-l-procedure procenv jobject procarity procindex (ad) init0 make-va-procedure make-fx-procedure native final abstract static done reg1 from_body entry_labels long else unknown \077\077? bucs2_value void (ad char) init_bucs2 j_bucs2 (jobject bucs2) unspecified (jobject t_unspecified) key (jobject t_key) rest (jobject t_rest) optional (jobject t_optional) eof (jobject t_eof) byte int boolean nil (jobject t_nil) (boolean int long elong llong float double) ok (node-type-set! e ty) (tprint up \" wrong type \" (list tdown (quote ->) tup)) vector begin ", 821 );
DEFINE_STRING( BGl_string5885z00zzjvm_compilerz00, BgL_bgl_string5885za700za7za7jvm_compilerza7005933z00, "jvm_compiler", 12 );
DEFINE_STRING( BGl_string5884z00zzjvm_compilerz00, BgL_bgl_string5884za700za7za7jvm_compilerza7005934z00, "HD", 2 );
DEFINE_STRING( BGl_string5883z00zzjvm_compilerz00, BgL_bgl_string5883za700za7za7jvm_compilerza7005935z00, "HE", 2 );
DEFINE_STRING( BGl_string5882z00zzjvm_compilerz00, BgL_bgl_string5882za700za7za7jvm_compilerza7005936z00, "HB", 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2selectzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2select5423za7d2za7za7jvm_compilerza7005937za7, BGl__compilerzd2select5423zd2zzjvm_compilerz00, 0L, 3 );
DEFINE_STRING( BGl_string5881z00zzjvm_compilerz00, BgL_bgl_string5881za700za7za7jvm_compilerza7005938z00, "ya pas en jvm", 13 );
DEFINE_STRING( BGl_string5880z00zzjvm_compilerz00, BgL_bgl_string5880za700za7za7jvm_compilerza7005939z00, "pragma", 6 );
DEFINE_STRING( BGl_string5879z00zzjvm_compilerz00, BgL_bgl_string5879za700za7za7jvm_compilerza7005940z00, "PTR_ALIGNMENT", 13 );
DEFINE_STRING( BGl_string5878z00zzjvm_compilerz00, BgL_bgl_string5878za700za7za7jvm_compilerza7005941z00, "not a variable", 14 );
DEFINE_STRING( BGl_string5877z00zzjvm_compilerz00, BgL_bgl_string5877za700za7za7jvm_compilerza7005942z00, "not a global", 12 );
DEFINE_STRING( BGl_string5876z00zzjvm_compilerz00, BgL_bgl_string5876za700za7za7jvm_compilerza7005943z00, "Jvm/EVMEANING_ADDRESS", 21 );
DEFINE_STRING( BGl_string5875z00zzjvm_compilerz00, BgL_bgl_string5875za700za7za7jvm_compilerza7005944z00, "<init>", 6 );
DEFINE_STRING( BGl_string5874z00zzjvm_compilerz00, BgL_bgl_string5874za700za7za7jvm_compilerza7005945z00, "F", 1 );
DEFINE_STRING( BGl_string5873z00zzjvm_compilerz00, BgL_bgl_string5873za700za7za7jvm_compilerza7005946z00, "bad item", 8 );
DEFINE_STRING( BGl_string5872z00zzjvm_compilerz00, BgL_bgl_string5872za700za7za7jvm_compilerza7005947z00, "not yet", 7 );
DEFINE_STRING( BGl_string5871z00zzjvm_compilerz00, BgL_bgl_string5871za700za7za7jvm_compilerza7005948z00, "select", 6 );
DEFINE_STRING( BGl_string5870z00zzjvm_compilerz00, BgL_bgl_string5870za700za7za7jvm_compilerza7005949z00, "L", 1 );
DEFINE_STRING( BGl_string5869z00zzjvm_compilerz00, BgL_bgl_string5869za700za7za7jvm_compilerza7005950z00, "T", 1 );
DEFINE_STRING( BGl_string5868z00zzjvm_compilerz00, BgL_bgl_string5868za700za7za7jvm_compilerza7005951z00, "bad atom value", 14 );
DEFINE_STRING( BGl_string5867z00zzjvm_compilerz00, BgL_bgl_string5867za700za7za7jvm_compilerza7005952z00, "compile", 7 );
DEFINE_STRING( BGl_string5866z00zzjvm_compilerz00, BgL_bgl_string5866za700za7za7jvm_compilerza7005953z00, "set-type", 8 );
DEFINE_STRING( BGl_string5865z00zzjvm_compilerz00, BgL_bgl_string5865za700za7za7jvm_compilerza7005954z00, "unknown node", 12 );
DEFINE_STRING( BGl_string5864z00zzjvm_compilerz00, BgL_bgl_string5864za700za7za7jvm_compilerza7005955z00, "type", 4 );
DEFINE_STRING( BGl_string5863z00zzjvm_compilerz00, BgL_bgl_string5863za700za7za7jvm_compilerza7005956z00, " must be ", 9 );
DEFINE_STRING( BGl_string5862z00zzjvm_compilerz00, BgL_bgl_string5862za700za7za7jvm_compilerza7005957z00, " must in ", 9 );
DEFINE_STRING( BGl_string5861z00zzjvm_compilerz00, BgL_bgl_string5861za700za7za7jvm_compilerza7005958z00, " bad type ", 10 );
DEFINE_STRING( BGl_string5860z00zzjvm_compilerz00, BgL_bgl_string5860za700za7za7jvm_compilerza7005959z00, ":", 1 );
DEFINE_STRING( BGl_string5859z00zzjvm_compilerz00, BgL_bgl_string5859za700za7za7jvm_compilerza7005960z00, ",", 1 );
DEFINE_STRING( BGl_string5858z00zzjvm_compilerz00, BgL_bgl_string5858za700za7za7jvm_compilerza7005961z00, "./Jvm/compiler.scm", 18 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2failzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2fail5458za7d2za7za7jvm_compilerza7005962za7, BGl__compilerzd2fail5458zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2appzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2app5427za7d2za7za7jvm_compilerza7005963za7, BGl__compilerzd2app5427zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2pragmazd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2pragma5433za7d2za7za7jvm_compilerza7005964za7, BGl__compilerzd2pragma5433zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2getfieldzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2getfield5435za7d2za7za7jvm_compilerza7005965za7, BGl__compilerzd2getfield5435zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2letzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2let5415za7d2za7za7jvm_compilerza7005966za7, BGl__compilerzd2let5415zd2zzjvm_compilerz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2atomzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2atom5411za7d2za7za7jvm_compilerza7005967za7, BGl__compilerzd2atom5411zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2newzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2new5439za7d2za7za7jvm_compilerza7005968za7, BGl__compilerzd2new5439zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2setqzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2setq5417za7d2za7za7jvm_compilerza7005969za7, BGl__compilerzd2setq5417zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2applyzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2apply5429za7d2za7za7jvm_compilerza7005970za7, BGl__compilerzd2apply5429zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2labelszd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2labels5425za7d2za7za7jvm_compilerza7005971za7, BGl__compilerzd2labels5425zd2zzjvm_compilerz00, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2vrefzd2envz00zzjvm_compilerz00, BgL_bgl__compilerza7d2vref5443za7d2za7za7jvm_compilerza7005972za7, BGl__compilerzd2vref5443zd2zzjvm_compilerz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_compilerzd2boxzd2setz12zd2envzc0zzjvm_compilerz00, BgL_bgl__compilerza7d2boxza7d2setza7125464za712za7za7jvm_compilerza7005973za7, BGl__compilerzd2boxzd2setz125464z12zzjvm_compilerz00, 0L, 2 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzjvm_compilerz00(long BgL_checksumz00_2618, char * BgL_fromz00_2619)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzjvm_compilerz00))
{ 
BGl_requirezd2initializa7ationz75zzjvm_compilerz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzjvm_compilerz00(); 
BGl_cnstzd2initzd2zzjvm_compilerz00(); 
BGl_importedzd2moduleszd2initz00zzjvm_compilerz00(); 
BGl_toplevelzd2initzd2zzjvm_compilerz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzjvm_compilerz00()
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 8 */
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "jvm_compiler"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "jvm_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "jvm_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "jvm_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "jvm_compiler"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "jvm_compiler"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzjvm_compilerz00()
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 8 */
{ /* ./Jvm/compiler.scm 8 */
obj_t BgL_cportz00_2605;
BgL_cportz00_2605 = 
open_input_string(BGl_string5886z00zzjvm_compilerz00); 
{ 
long BgL_iz00_2606;
BgL_iz00_2606 = ((long)75); 
BgL_loopz00_2607:
if(
(BgL_iz00_2606==((long)-1)))
{ /* ./Jvm/compiler.scm 8 */
return BUNSPEC;}  else 
{ /* ./Jvm/compiler.scm 8 */
{ /* ./Jvm/compiler.scm 8 */
obj_t BgL_arg5890z00_2609;
{ /* ./Jvm/compiler.scm 8 */
obj_t BgL_list5893z00_2610;
BgL_list5893z00_2610 = 
MAKE_PAIR(BgL_cportz00_2605, BNIL); 
BgL_arg5890z00_2609 = 
BGl_readz00zz__readerz00(BgL_list5893z00_2610); } 
{ /* ./Jvm/compiler.scm 8 */
int BgL_auxz00_2638;
BgL_auxz00_2638 = 
(int)(BgL_iz00_2606); 
CNST_TABLE_SET(BgL_auxz00_2638, BgL_arg5890z00_2609); } } 
{ /* ./Jvm/compiler.scm 8 */
int BgL_auxz00_2611;
BgL_auxz00_2611 = 
(int)(
(BgL_iz00_2606-((long)1))); 
{ 
long BgL_iz00_2643;
BgL_iz00_2643 = 
(long)(BgL_auxz00_2611); 
BgL_iz00_2606 = BgL_iz00_2643; 
goto BgL_loopz00_2607;} } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzjvm_compilerz00()
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 8 */
BGl_za2labdoneza2z00zzjvm_compilerz00 = BNIL; 
BGl_za2lab2labelsza2z00zzjvm_compilerz00 = BNIL; 
return ( 
BGl_za2labels2savedza2z00zzjvm_compilerz00 = BNIL, BUNSPEC) ;} 
}



/* compiler-body */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2bodyzd2zzjvm_compilerz00(BgL_nodez00_bglt BgL_ez00_1, BgL_envz00_bglt BgL_envz00_2)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 46 */
BGl_za2labdoneza2z00zzjvm_compilerz00 = BNIL; 
BGl_za2lab2labelsza2z00zzjvm_compilerz00 = BNIL; 
BGl_za2labels2savedza2z00zzjvm_compilerz00 = BNIL; 
BGl__labelz00zzjvm_instrz00(BgL_envz00_2, 
CNST_TABLE_REF(((long)0))); 
return 
BGl_compilezd2tailzd2zzjvm_tailz00(BgL_ez00_1, BgL_envz00_2);} 
}



/* _compiler-body5409 */
obj_t BGl__compilerzd2body5409zd2zzjvm_compilerz00(obj_t BgL_envz00_2511, obj_t BgL_ez00_2512, obj_t BgL_envz00_2513)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 46 */
return 
BGl_compilerzd2bodyzd2zzjvm_compilerz00(
(BgL_nodez00_bglt)(BgL_ez00_2512), 
(BgL_envz00_bglt)(BgL_envz00_2513));} 
}



/* check_type */
obj_t BGl_check_typez00zzjvm_compilerz00(BgL_envz00_bglt BgL_envz00_5, obj_t BgL_ez00_6, obj_t BgL_tyz00_7)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 62 */
{ /* ./Jvm/compiler.scm 63 */
obj_t BgL_rtyz00_899;
{ /* ./Jvm/compiler.scm 63 */
BgL_typez00_bglt BgL_arg3310z00_907;
BgL_arg3310z00_907 = 
BGl_typeofz00zztype_typeofz00(
(BgL_nodez00_bglt)(BgL_ez00_6)); 
BgL_rtyz00_899 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg3310z00_907), BgL_envz00_5); } 
if(
PAIRP(BgL_tyz00_7))
{ /* ./Jvm/compiler.scm 64 */
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_rtyz00_899, BgL_tyz00_7)))
{ /* ./Jvm/compiler.scm 65 */
return BFALSE;}  else 
{ /* ./Jvm/compiler.scm 66 */
obj_t BgL_port3128z00_902;
BgL_port3128z00_902 = 
BGL_CURRENT_OUTPUT_PORT(); 
display_string(BGl_string5858z00zzjvm_compilerz00, BgL_port3128z00_902); 
display_string(BGl_string5859z00zzjvm_compilerz00, BgL_port3128z00_902); 
display_fixnum(
BINT(((long)66)), BgL_port3128z00_902); 
display_string(BGl_string5860z00zzjvm_compilerz00, BgL_port3128z00_902); 
{ /* ./Jvm/compiler.scm 66 */
obj_t BgL_arg3282z00_903;
BgL_arg3282z00_903 = 
BGl_shapez00zztools_shapez00(BgL_ez00_6); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg3282z00_903, BgL_port3128z00_902); } 
display_string(BGl_string5861z00zzjvm_compilerz00, BgL_port3128z00_902); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_rtyz00_899, BgL_port3128z00_902); 
display_string(BGl_string5862z00zzjvm_compilerz00, BgL_port3128z00_902); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_tyz00_7, BgL_port3128z00_902); 
return 
WRITE_CHAR(((unsigned char)'\n'), BgL_port3128z00_902);} }  else 
{ /* ./Jvm/compiler.scm 64 */
if(
(BgL_rtyz00_899==BgL_tyz00_7))
{ /* ./Jvm/compiler.scm 67 */
return BFALSE;}  else 
{ /* ./Jvm/compiler.scm 68 */
obj_t BgL_port3129z00_905;
BgL_port3129z00_905 = 
BGL_CURRENT_OUTPUT_PORT(); 
display_string(BGl_string5858z00zzjvm_compilerz00, BgL_port3129z00_905); 
display_string(BGl_string5859z00zzjvm_compilerz00, BgL_port3129z00_905); 
display_fixnum(
BINT(((long)68)), BgL_port3129z00_905); 
display_string(BGl_string5860z00zzjvm_compilerz00, BgL_port3129z00_905); 
{ /* ./Jvm/compiler.scm 68 */
obj_t BgL_arg3298z00_906;
BgL_arg3298z00_906 = 
BGl_shapez00zztools_shapez00(BgL_ez00_6); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg3298z00_906, BgL_port3129z00_905); } 
display_string(BGl_string5861z00zzjvm_compilerz00, BgL_port3129z00_905); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_rtyz00_899, BgL_port3129z00_905); 
display_string(BGl_string5863z00zzjvm_compilerz00, BgL_port3129z00_905); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_tyz00_7, BgL_port3129z00_905); 
return 
WRITE_CHAR(((unsigned char)'\n'), BgL_port3129z00_905);} } } } 
}



/* check_type_vector */
obj_t BGl_check_type_vectorz00zzjvm_compilerz00(BgL_envz00_bglt BgL_envz00_8, obj_t BgL_ez00_9, obj_t BgL_tyz00_10)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 70 */
{ /* ./Jvm/compiler.scm 71 */
obj_t BgL_rtyz00_908;
{ /* ./Jvm/compiler.scm 71 */
BgL_typez00_bglt BgL_arg3361z00_923;
BgL_arg3361z00_923 = 
BGl_typeofz00zztype_typeofz00(
(BgL_nodez00_bglt)(BgL_ez00_9)); 
BgL_rtyz00_908 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg3361z00_923), BgL_envz00_8); } 
{ /* ./Jvm/compiler.scm 72 */
bool_t BgL_testz00_2692;
if(
PAIRP(BgL_rtyz00_908))
{ /* ./Jvm/compiler.scm 72 */
obj_t BgL_auxz00_2695;
{ /* ./Jvm/compiler.scm 72 */
obj_t BgL_pairz00_2024;
BgL_pairz00_2024 = BgL_rtyz00_908; 
BgL_auxz00_2695 = 
CAR(BgL_pairz00_2024); } 
BgL_testz00_2692 = 
(BgL_auxz00_2695==
CNST_TABLE_REF(((long)1))); }  else 
{ /* ./Jvm/compiler.scm 72 */
BgL_testz00_2692 = ((bool_t)0)
; } 
if(BgL_testz00_2692)
{ /* ./Jvm/compiler.scm 72 */BFALSE; }  else 
{ /* ./Jvm/compiler.scm 73 */
obj_t BgL_port3130z00_910;
BgL_port3130z00_910 = 
BGL_CURRENT_OUTPUT_PORT(); 
display_string(BGl_string5858z00zzjvm_compilerz00, BgL_port3130z00_910); 
display_string(BGl_string5859z00zzjvm_compilerz00, BgL_port3130z00_910); 
display_fixnum(
BINT(((long)73)), BgL_port3130z00_910); 
display_string(BGl_string5860z00zzjvm_compilerz00, BgL_port3130z00_910); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_ez00_9, BgL_port3130z00_910); 
display_string(BGl_string5861z00zzjvm_compilerz00, BgL_port3130z00_910); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_rtyz00_908, BgL_port3130z00_910); 
display_string(BGl_string5863z00zzjvm_compilerz00, BgL_port3130z00_910); 
{ /* ./Jvm/compiler.scm 73 */
obj_t BgL_arg3323z00_911;
{ /* ./Jvm/compiler.scm 73 */
obj_t BgL_arg3326z00_912;obj_t BgL_arg3327z00_913;
BgL_arg3326z00_912 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg3327z00_913 = 
MAKE_PAIR(BgL_tyz00_10, BNIL); 
BgL_arg3323z00_911 = 
MAKE_PAIR(BgL_arg3326z00_912, BgL_arg3327z00_913); } 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg3323z00_911, BgL_port3130z00_910); } 
WRITE_CHAR(((unsigned char)'\n'), BgL_port3130z00_910); } } 
{ /* ./Jvm/compiler.scm 74 */
obj_t BgL_etyz00_917;
{ /* ./Jvm/compiler.scm 74 */
obj_t BgL_pairz00_2026;
BgL_pairz00_2026 = BgL_rtyz00_908; 
{ /* ./Jvm/compiler.scm 74 */
obj_t BgL_pairz00_2029;
BgL_pairz00_2029 = 
CDR(BgL_pairz00_2026); 
BgL_etyz00_917 = 
CAR(BgL_pairz00_2029); } } 
if(
(BgL_etyz00_917==BgL_tyz00_10))
{ /* ./Jvm/compiler.scm 75 */
return BFALSE;}  else 
{ /* ./Jvm/compiler.scm 76 */
obj_t BgL_port3131z00_919;
BgL_port3131z00_919 = 
BGL_CURRENT_OUTPUT_PORT(); 
display_string(BGl_string5858z00zzjvm_compilerz00, BgL_port3131z00_919); 
display_string(BGl_string5859z00zzjvm_compilerz00, BgL_port3131z00_919); 
display_fixnum(
BINT(((long)76)), BgL_port3131z00_919); 
display_string(BGl_string5860z00zzjvm_compilerz00, BgL_port3131z00_919); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_ez00_9, BgL_port3131z00_919); 
display_string(BGl_string5861z00zzjvm_compilerz00, BgL_port3131z00_919); 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_rtyz00_908, BgL_port3131z00_919); 
display_string(BGl_string5863z00zzjvm_compilerz00, BgL_port3131z00_919); 
{ /* ./Jvm/compiler.scm 76 */
obj_t BgL_arg3349z00_920;
{ /* ./Jvm/compiler.scm 76 */
obj_t BgL_arg3352z00_921;obj_t BgL_arg3353z00_922;
BgL_arg3352z00_921 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg3353z00_922 = 
MAKE_PAIR(BgL_tyz00_10, BNIL); 
BgL_arg3349z00_920 = 
MAKE_PAIR(BgL_arg3352z00_921, BgL_arg3353z00_922); } 
BGl_displayzd22zd2zz__r4_output_6_10_3z00(BgL_arg3349z00_920, BgL_port3131z00_919); } 
return 
WRITE_CHAR(((unsigned char)'\n'), BgL_port3131z00_919);} } } } 
}



/* same-type */
obj_t BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_bglt BgL_envz00_11, obj_t BgL_downz00_12, obj_t BgL_upz00_13)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 78 */
{ /* ./Jvm/compiler.scm 79 */
obj_t BgL_tdownz00_924;obj_t BgL_tupz00_925;
BgL_tdownz00_924 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_downz00_12, BgL_envz00_11); 
BgL_tupz00_925 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_upz00_13, BgL_envz00_11); 
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_tdownz00_924, BgL_tupz00_925))
{ /* ./Jvm/compiler.scm 80 */
return BFALSE;}  else 
{ /* ./Jvm/compiler.scm 80 */
CNST_TABLE_REF(((long)2)); 
{ /* ./Jvm/compiler.scm 82 */
obj_t BgL_arg3366z00_927;
BgL_arg3366z00_927 = 
BGl_getzd2typezd2zzjvm_compilerz00(BgL_upz00_13); 
return 
BGl_setzd2typezd2zzjvm_compilerz00(BgL_downz00_12, BgL_arg3366z00_927);} } } } 
}



/* get-type */
obj_t BGl_getzd2typezd2zzjvm_compilerz00(obj_t BgL_ez00_17)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 89 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_ez00_17, BGl_nodez00zzast_nodez00))
{ /* ./Jvm/compiler.scm 90 */
BgL_typez00_bglt BgL_auxz00_2742;
BgL_auxz00_2742 = 
BGl_typeofz00zztype_typeofz00(
(BgL_nodez00_bglt)(BgL_ez00_17)); 
return 
(obj_t)(BgL_auxz00_2742);}  else 
{ /* ./Jvm/compiler.scm 90 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_ez00_17, BGl_variablez00zzast_varz00))
{ /* ./Jvm/compiler.scm 91 */
BgL_variablez00_bglt BgL_obj1097z00_2033;
BgL_obj1097z00_2033 = 
(BgL_variablez00_bglt)(BgL_ez00_17); 
{ /* ./Jvm/compiler.scm 91 */
BgL_typez00_bglt BgL_auxz00_2749;
BgL_auxz00_2749 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1097z00_2033))->BgL_typez00); 
return 
(obj_t)(BgL_auxz00_2749);} }  else 
{ /* ./Jvm/compiler.scm 91 */
FAILURE(BGl_string5864z00zzjvm_compilerz00,BGl_string5865z00zzjvm_compilerz00,BgL_ez00_17);} } } 
}



/* set-type */
obj_t BGl_setzd2typezd2zzjvm_compilerz00(obj_t BgL_ez00_18, obj_t BgL_tyz00_19)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 94 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_ez00_18, BGl_nodez00zzast_nodez00))
{ /* ./Jvm/compiler.scm 95 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* ./Jvm/compiler.scm 95 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_ez00_18, BGl_variablez00zzast_varz00))
{ /* ./Jvm/compiler.scm 96 */
BgL_variablez00_bglt BgL_obj1099z00_2039;BgL_typez00_bglt BgL_val1098z00_2040;
BgL_obj1099z00_2039 = 
(BgL_variablez00_bglt)(BgL_ez00_18); 
BgL_val1098z00_2040 = 
(BgL_typez00_bglt)(BgL_tyz00_19); 
return 
((((BgL_variablez00_bglt)CREF(BgL_obj1099z00_2039))->BgL_typez00) = ((BgL_typez00_bglt)BgL_val1098z00_2040), BUNSPEC);}  else 
{ /* ./Jvm/compiler.scm 96 */
FAILURE(BGl_string5866z00zzjvm_compilerz00,BGl_string5865z00zzjvm_compilerz00,BgL_ez00_18);} } } 
}



/* compiler-atom */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2atomzd2zzjvm_compilerz00(obj_t BgL_ez00_20, BgL_envz00_bglt BgL_envz00_21)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 100 */
{ /* ./Jvm/compiler.scm 101 */
obj_t BgL_nz00_2046;
BgL_nz00_2046 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_20)); 
if(
CBOOL(BgL_nz00_2046))
{ /* ./Jvm/compiler.scm 101 */
BGl__linez00zzjvm_instrz00(BgL_envz00_21, BgL_nz00_2046); }  else 
{ /* ./Jvm/compiler.scm 101 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 104 */
bool_t BgL_testz00_2768;
{ /* ./Jvm/compiler.scm 104 */
obj_t BgL_arg3557z00_993;
{ /* ./Jvm/compiler.scm 104 */
BgL_atomz00_bglt BgL_obj1604z00_2047;
BgL_obj1604z00_2047 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_arg3557z00_993 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2047))->BgL_valuez00); } 
if(
INTEGERP(BgL_arg3557z00_993))
{ /* ./Jvm/compiler.scm 104 */
BgL_testz00_2768 = ((bool_t)1)
; }  else 
{ /* ./Jvm/compiler.scm 104 */
if(
REALP(BgL_arg3557z00_993))
{ /* ./Jvm/compiler.scm 104 */
BgL_testz00_2768 = ((bool_t)1)
; }  else 
{ /* ./Jvm/compiler.scm 104 */
if(
ELONGP(BgL_arg3557z00_993))
{ /* ./Jvm/compiler.scm 104 */
BgL_testz00_2768 = ((bool_t)1)
; }  else 
{ /* ./Jvm/compiler.scm 104 */
BgL_testz00_2768 = 
LLONGP(BgL_arg3557z00_993)
; } } } } 
if(BgL_testz00_2768)
{ /* ./Jvm/compiler.scm 104 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)5))); 
{ /* ./Jvm/compiler.scm 106 */
obj_t BgL_arg3414z00_943;obj_t BgL_arg3415z00_944;
{ /* ./Jvm/compiler.scm 106 */
BgL_typez00_bglt BgL_arg3418z00_945;
BgL_arg3418z00_945 = 
BGl_typeofz00zztype_typeofz00(
(BgL_nodez00_bglt)(BgL_ez00_20)); 
BgL_arg3414z00_943 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg3418z00_945), BgL_envz00_21); } 
{ /* ./Jvm/compiler.scm 106 */
BgL_atomz00_bglt BgL_obj1604z00_2057;
BgL_obj1604z00_2057 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_arg3415z00_944 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2057))->BgL_valuez00); } 
return 
BGl__pushz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3414z00_943, BgL_arg3415z00_944);} }  else 
{ /* ./Jvm/compiler.scm 107 */
bool_t BgL_testz00_2787;
{ /* ./Jvm/compiler.scm 107 */
obj_t BgL_auxz00_2788;
{ /* ./Jvm/compiler.scm 107 */
BgL_atomz00_bglt BgL_obj1604z00_2058;
BgL_obj1604z00_2058 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2788 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2058))->BgL_valuez00); } 
BgL_testz00_2787 = 
NULLP(BgL_auxz00_2788); } 
if(BgL_testz00_2787)
{ /* ./Jvm/compiler.scm 107 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)6))); 
{ /* ./Jvm/compiler.scm 109 */
obj_t BgL_arg3425z00_947;
BgL_arg3425z00_947 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)7))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3425z00_947);} }  else 
{ /* ./Jvm/compiler.scm 110 */
bool_t BgL_testz00_2797;
{ /* ./Jvm/compiler.scm 110 */
obj_t BgL_auxz00_2798;
{ /* ./Jvm/compiler.scm 110 */
BgL_atomz00_bglt BgL_obj1604z00_2060;
BgL_obj1604z00_2060 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2798 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2060))->BgL_valuez00); } 
BgL_testz00_2797 = 
BOOLEANP(BgL_auxz00_2798); } 
if(BgL_testz00_2797)
{ /* ./Jvm/compiler.scm 110 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)8))); 
{ /* ./Jvm/compiler.scm 112 */
obj_t BgL_arg3431z00_949;long BgL_arg3432z00_950;
BgL_arg3431z00_949 = 
CNST_TABLE_REF(((long)9)); 
{ /* ./Jvm/compiler.scm 112 */
bool_t BgL_testz00_2805;
{ /* ./Jvm/compiler.scm 112 */
BgL_atomz00_bglt BgL_obj1604z00_2062;
BgL_obj1604z00_2062 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_testz00_2805 = 
CBOOL(
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2062))->BgL_valuez00)); } 
if(BgL_testz00_2805)
{ /* ./Jvm/compiler.scm 112 */
BgL_arg3432z00_950 = ((long)1); }  else 
{ /* ./Jvm/compiler.scm 112 */
BgL_arg3432z00_950 = ((long)0); } } 
return 
BGl__pushz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3431z00_949, 
BINT(BgL_arg3432z00_950));} }  else 
{ /* ./Jvm/compiler.scm 113 */
bool_t BgL_testz00_2811;
{ /* ./Jvm/compiler.scm 113 */
obj_t BgL_auxz00_2812;
{ /* ./Jvm/compiler.scm 113 */
BgL_atomz00_bglt BgL_obj1604z00_2063;
BgL_obj1604z00_2063 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2812 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2063))->BgL_valuez00); } 
BgL_testz00_2811 = 
CHARP(BgL_auxz00_2812); } 
if(BgL_testz00_2811)
{ /* ./Jvm/compiler.scm 113 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)9))); 
{ /* ./Jvm/compiler.scm 115 */
obj_t BgL_arg3439z00_953;long BgL_arg3440z00_954;
BgL_arg3439z00_953 = 
CNST_TABLE_REF(((long)9)); 
{ /* ./Jvm/compiler.scm 115 */
unsigned char BgL_auxz00_2819;
{ /* ./Jvm/compiler.scm 115 */
BgL_atomz00_bglt BgL_obj1604z00_2065;
BgL_obj1604z00_2065 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2819 = 
(unsigned char)CCHAR(
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2065))->BgL_valuez00)); } 
BgL_arg3440z00_954 = 
(BgL_auxz00_2819); } 
return 
BGl__pushz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3439z00_953, 
BINT(BgL_arg3440z00_954));} }  else 
{ /* ./Jvm/compiler.scm 116 */
bool_t BgL_testz00_2826;
{ /* ./Jvm/compiler.scm 116 */
obj_t BgL_auxz00_2827;
{ /* ./Jvm/compiler.scm 116 */
BgL_atomz00_bglt BgL_obj1604z00_2067;
BgL_obj1604z00_2067 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2827 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2067))->BgL_valuez00); } 
BgL_testz00_2826 = 
STRINGP(BgL_auxz00_2827); } 
if(BgL_testz00_2826)
{ /* ./Jvm/compiler.scm 116 */
BGl_check_type_vectorz00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)10))); 
{ /* ./Jvm/compiler.scm 119 */
obj_t BgL_arg3449z00_957;
{ /* ./Jvm/compiler.scm 119 */
BgL_atomz00_bglt BgL_obj1604z00_2069;
BgL_obj1604z00_2069 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_arg3449z00_957 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2069))->BgL_valuez00); } 
return 
BGl_createzd2stringzd2zzjvm_instrz00(
(obj_t)(BgL_envz00_21), BgL_arg3449z00_957);} }  else 
{ /* ./Jvm/compiler.scm 120 */
bool_t BgL_testz00_2837;
{ /* ./Jvm/compiler.scm 120 */
obj_t BgL_arg3537z00_988;
{ /* ./Jvm/compiler.scm 120 */
BgL_atomz00_bglt BgL_obj1604z00_2070;
BgL_obj1604z00_2070 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_arg3537z00_988 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2070))->BgL_valuez00); } 
BgL_testz00_2837 = 
EOF_OBJECTP(BgL_arg3537z00_988); } 
if(BgL_testz00_2837)
{ /* ./Jvm/compiler.scm 120 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)11))); 
{ /* ./Jvm/compiler.scm 122 */
obj_t BgL_arg3455z00_959;
BgL_arg3455z00_959 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)12))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3455z00_959);} }  else 
{ /* ./Jvm/compiler.scm 123 */
bool_t BgL_testz00_2846;
{ /* ./Jvm/compiler.scm 123 */
obj_t BgL_auxz00_2847;
{ /* ./Jvm/compiler.scm 123 */
BgL_atomz00_bglt BgL_obj1604z00_2072;
BgL_obj1604z00_2072 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2847 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2072))->BgL_valuez00); } 
BgL_testz00_2846 = 
(BgL_auxz00_2847==BCNST(258)); } 
if(BgL_testz00_2846)
{ /* ./Jvm/compiler.scm 123 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)13))); 
{ /* ./Jvm/compiler.scm 125 */
obj_t BgL_arg3461z00_961;
BgL_arg3461z00_961 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)14))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3461z00_961);} }  else 
{ /* ./Jvm/compiler.scm 126 */
bool_t BgL_testz00_2856;
{ /* ./Jvm/compiler.scm 126 */
obj_t BgL_auxz00_2857;
{ /* ./Jvm/compiler.scm 126 */
BgL_atomz00_bglt BgL_obj1604z00_2073;
BgL_obj1604z00_2073 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2857 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2073))->BgL_valuez00); } 
BgL_testz00_2856 = 
(BgL_auxz00_2857==BCNST(259)); } 
if(BgL_testz00_2856)
{ /* ./Jvm/compiler.scm 126 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)15))); 
{ /* ./Jvm/compiler.scm 128 */
obj_t BgL_arg3467z00_963;
BgL_arg3467z00_963 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)16))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3467z00_963);} }  else 
{ /* ./Jvm/compiler.scm 129 */
bool_t BgL_testz00_2866;
{ /* ./Jvm/compiler.scm 129 */
obj_t BgL_auxz00_2867;
{ /* ./Jvm/compiler.scm 129 */
BgL_atomz00_bglt BgL_obj1604z00_2074;
BgL_obj1604z00_2074 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2867 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2074))->BgL_valuez00); } 
BgL_testz00_2866 = 
(BgL_auxz00_2867==BCNST(262)); } 
if(BgL_testz00_2866)
{ /* ./Jvm/compiler.scm 129 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)17))); 
{ /* ./Jvm/compiler.scm 131 */
obj_t BgL_arg3473z00_965;
BgL_arg3473z00_965 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)18))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3473z00_965);} }  else 
{ /* ./Jvm/compiler.scm 132 */
bool_t BgL_testz00_2876;
{ /* ./Jvm/compiler.scm 132 */
obj_t BgL_auxz00_2877;
{ /* ./Jvm/compiler.scm 132 */
BgL_atomz00_bglt BgL_obj1604z00_2075;
BgL_obj1604z00_2075 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2877 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2075))->BgL_valuez00); } 
BgL_testz00_2876 = 
(BgL_auxz00_2877==BUNSPEC); } 
if(BgL_testz00_2876)
{ /* ./Jvm/compiler.scm 132 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)19))); 
{ /* ./Jvm/compiler.scm 134 */
obj_t BgL_arg3479z00_967;
BgL_arg3479z00_967 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)20))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3479z00_967);} }  else 
{ /* ./Jvm/compiler.scm 135 */
bool_t BgL_testz00_2886;
{ /* ./Jvm/compiler.scm 135 */
obj_t BgL_auxz00_2887;
{ /* ./Jvm/compiler.scm 135 */
BgL_atomz00_bglt BgL_obj1604z00_2076;
BgL_obj1604z00_2076 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_auxz00_2887 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2076))->BgL_valuez00); } 
BgL_testz00_2886 = 
UCS2P(BgL_auxz00_2887); } 
if(BgL_testz00_2886)
{ /* ./Jvm/compiler.scm 135 */
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_21, BgL_ez00_20, 
CNST_TABLE_REF(((long)21))); 
{ /* ./Jvm/compiler.scm 138 */
obj_t BgL_arg3485z00_969;
BgL_arg3485z00_969 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)22))); 
BGl__newz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3485z00_969); } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_21); 
{ /* ./Jvm/compiler.scm 140 */
obj_t BgL_arg3490z00_970;int BgL_arg3491z00_971;
BgL_arg3490z00_970 = 
CNST_TABLE_REF(((long)9)); 
{ /* ./Jvm/compiler.scm 140 */
obj_t BgL_arg3494z00_972;
{ /* ./Jvm/compiler.scm 140 */
BgL_atomz00_bglt BgL_obj1604z00_2078;
BgL_obj1604z00_2078 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_arg3494z00_972 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2078))->BgL_valuez00); } 
{ /* ./Jvm/compiler.scm 140 */
ucs2_t BgL_ucs2z00_2079;
BgL_ucs2z00_2079 = 
CUCS2(BgL_arg3494z00_972); 
{ /* ./Jvm/compiler.scm 140 */
obj_t BgL_auxz00_2901;
BgL_auxz00_2901 = 
BUCS2(BgL_ucs2z00_2079); 
BgL_arg3491z00_971 = 
CUCS2(BgL_auxz00_2901); } } } 
BGl__pushz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3490z00_970, 
BINT(BgL_arg3491z00_971)); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 142 */
obj_t BgL_arg3498z00_973;obj_t BgL_arg3499z00_974;obj_t BgL_arg3500z00_975;
BgL_arg3498z00_973 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)23))); 
BgL_arg3499z00_974 = 
CNST_TABLE_REF(((long)24)); 
BgL_arg3500z00_975 = 
CNST_TABLE_REF(((long)25)); 
return 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3498z00_973, BgL_arg3499z00_974, BgL_arg3500z00_975);}  else 
{ /* ./Jvm/compiler.scm 143 */
obj_t BgL_arg3504z00_976;
BgL_arg3504z00_976 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_21, 
CNST_TABLE_REF(((long)26))); 
return 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_21, BgL_arg3504z00_976);} }  else 
{ /* ./Jvm/compiler.scm 144 */
obj_t BgL_arg3510z00_979;
{ /* ./Jvm/compiler.scm 144 */
BgL_atomz00_bglt BgL_obj1604z00_2080;
BgL_obj1604z00_2080 = 
(BgL_atomz00_bglt)(BgL_ez00_20); 
BgL_arg3510z00_979 = 
(((BgL_atomz00_bglt)CREF(BgL_obj1604z00_2080))->BgL_valuez00); } 
FAILURE(BGl_string5867z00zzjvm_compilerz00,BGl_string5868z00zzjvm_compilerz00,BgL_arg3510z00_979);} } } } } } } } } } } } } 
}



/* _compiler-atom5411 */
obj_t BGl__compilerzd2atom5411zd2zzjvm_compilerz00(obj_t BgL_envz00_2514, obj_t BgL_ez00_2515, obj_t BgL_envz00_2516)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 100 */
return 
BGl_compilerzd2atomzd2zzjvm_compilerz00(BgL_ez00_2515, 
(BgL_envz00_bglt)(BgL_envz00_2516));} 
}



/* compiler-var */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2varzd2zzjvm_compilerz00(BgL_varz00_bglt BgL_ez00_22, BgL_envz00_bglt BgL_envz00_23)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 147 */
{ /* ./Jvm/compiler.scm 148 */
obj_t BgL_nz00_2086;
BgL_nz00_2086 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_22)); 
if(
CBOOL(BgL_nz00_2086))
{ /* ./Jvm/compiler.scm 148 */
BGl__linez00zzjvm_instrz00(BgL_envz00_23, BgL_nz00_2086); }  else 
{ /* ./Jvm/compiler.scm 148 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 149 */
BgL_variablez00_bglt BgL_varz00_994;
BgL_varz00_994 = 
(((BgL_varz00_bglt)CREF(BgL_ez00_22))->BgL_variablez00); 
{ /* ./Jvm/compiler.scm 151 */
bool_t BgL_testz00_2928;
{ /* ./Jvm/compiler.scm 151 */
obj_t BgL_obj1240z00_2088;
BgL_obj1240z00_2088 = 
(obj_t)(BgL_varz00_994); 
BgL_testz00_2928 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1240z00_2088, BGl_globalz00zzast_varz00); } 
if(BgL_testz00_2928)
{ /* ./Jvm/compiler.scm 152 */
BgL_valuez00_bglt BgL_valuez00_996;
BgL_valuez00_996 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_994))->BgL_valuez00); 
{ /* ./Jvm/compiler.scm 153 */
bool_t BgL_testz00_2932;
{ /* ./Jvm/compiler.scm 153 */
obj_t BgL_obj1425z00_2090;
BgL_obj1425z00_2090 = 
(obj_t)(BgL_valuez00_996); 
BgL_testz00_2932 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1425z00_2090, BGl_sfunz00zzast_varz00); } 
if(BgL_testz00_2932)
{ /* ./Jvm/compiler.scm 154 */
long BgL_arg3564z00_998;
{ /* ./Jvm/compiler.scm 154 */
BgL_funz00_bglt BgL_obj1301z00_2091;
BgL_obj1301z00_2091 = 
(BgL_funz00_bglt)(BgL_valuez00_996); 
BgL_arg3564z00_998 = 
(((BgL_funz00_bglt)CREF(BgL_obj1301z00_2091))->BgL_arityz00); } 
return 
BGl_compilezd2procedurezd2entryz00zzjvm_compilerz00(
(BgL_globalz00_bglt)(BgL_varz00_994), BgL_arg3564z00_998, BgL_envz00_23);}  else 
{ /* ./Jvm/compiler.scm 153 */
return 
BGl__getstatic2z00zzjvm_instrz00(BgL_envz00_23, 
(BgL_globalz00_bglt)(BgL_varz00_994));} } }  else 
{ /* ./Jvm/compiler.scm 151 */
return 
BGl__loadz00zzjvm_instrz00(BgL_envz00_23, 
(BgL_localz00_bglt)(BgL_varz00_994));} } } } 
}



/* _compiler-var5413 */
obj_t BGl__compilerzd2var5413zd2zzjvm_compilerz00(obj_t BgL_envz00_2517, obj_t BgL_ez00_2518, obj_t BgL_envz00_2519)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 147 */
return 
BGl_compilerzd2varzd2zzjvm_compilerz00(
(BgL_varz00_bglt)(BgL_ez00_2518), 
(BgL_envz00_bglt)(BgL_envz00_2519));} 
}



/* compile-procedure-entry */
obj_t BGl_compilezd2procedurezd2entryz00zzjvm_compilerz00(BgL_globalz00_bglt BgL_varz00_24, long BgL_arityz00_25, BgL_envz00_bglt BgL_envz00_26)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 158 */
{ /* ./Jvm/compiler.scm 159 */
long BgL_xz00_999;
if(
(BgL_arityz00_25>=((long)0)))
{ /* ./Jvm/compiler.scm 159 */
BgL_xz00_999 = 
(BgL_arityz00_25-((long)1)); }  else 
{ /* ./Jvm/compiler.scm 159 */
BgL_xz00_999 = 
(BgL_arityz00_25+((long)1)); } 
{ /* ./Jvm/compiler.scm 160 */
obj_t BgL_indexz00_1000;
{ /* ./Jvm/compiler.scm 160 */
obj_t BgL_arg3575z00_1001;
BgL_arg3575z00_1001 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_26, BgL_varz00_24); 
BgL_indexz00_1000 = 
BGl_envzd2newzd2procedurez00zzjvm_envz00(BgL_envz00_26, 
BINT(BgL_xz00_999), BgL_arg3575z00_1001); } 
return 
BGl__pushz00zzjvm_instrz00(BgL_envz00_26, 
CNST_TABLE_REF(((long)9)), BgL_indexz00_1000);} } } 
}



/* compiler-let */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2letzd2zzjvm_compilerz00(BgL_letzd2varzd2_bglt BgL_ez00_27, BgL_envz00_bglt BgL_envz00_28, obj_t BgL_compilerz00_29)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 164 */
{ /* ./Jvm/compiler.scm 165 */
obj_t BgL_nz00_2094;
BgL_nz00_2094 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_27)); 
if(
CBOOL(BgL_nz00_2094))
{ /* ./Jvm/compiler.scm 165 */
BGl__linez00zzjvm_instrz00(BgL_envz00_28, BgL_nz00_2094); }  else 
{ /* ./Jvm/compiler.scm 165 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 167 */
obj_t BgL_debugzf3zf3_1004;
BgL_debugzf3zf3_1004 = 
BGl_debugzd2forzd2declarezd2varzf3z21zzjvm_externz00(BgL_envz00_28); 
{ /* ./Jvm/compiler.scm 168 */
obj_t BgL_elabz00_1005;
if(
CBOOL(BgL_debugzf3zf3_1004))
{ /* ./Jvm/compiler.scm 168 */
BgL_elabz00_1005 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5869z00zzjvm_compilerz00, BEOA); }  else 
{ /* ./Jvm/compiler.scm 168 */
BgL_elabz00_1005 = 
CNST_TABLE_REF(((long)27)); } 
{ 
obj_t BgL_l3137z00_1006;
{ /* ./Jvm/compiler.scm 169 */
obj_t BgL_arg3584z00_1008;
BgL_arg3584z00_1008 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_ez00_27))->BgL_bindingsz00); 
BgL_l3137z00_1006 = BgL_arg3584z00_1008; 
BgL_forzd2each3138zd2_1007:
if(
PAIRP(BgL_l3137z00_1006))
{ /* ./Jvm/compiler.scm 169 */
{ /* ./Jvm/compiler.scm 170 */
obj_t BgL_bz00_1010;
{ /* ./Jvm/compiler.scm 170 */
obj_t BgL_pairz00_2097;
BgL_pairz00_2097 = BgL_l3137z00_1006; 
BgL_bz00_1010 = 
CAR(BgL_pairz00_2097); } 
{ /* ./Jvm/compiler.scm 170 */
obj_t BgL_varz00_1011;obj_t BgL_valz00_1012;
{ /* ./Jvm/compiler.scm 170 */
obj_t BgL_pairz00_2098;
BgL_pairz00_2098 = BgL_bz00_1010; 
BgL_varz00_1011 = 
CAR(BgL_pairz00_2098); } 
{ /* ./Jvm/compiler.scm 170 */
obj_t BgL_pairz00_2099;
BgL_pairz00_2099 = BgL_bz00_1010; 
BgL_valz00_1012 = 
CDR(BgL_pairz00_2099); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_valz00_1012), BgL_envz00_28); 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_28, BgL_valz00_1012, BgL_varz00_1011); 
BGl_envzd2declarezd2localz00zzjvm_envz00(BgL_envz00_28, 
(BgL_localz00_bglt)(BgL_varz00_1011)); 
BGl_debugzd2declarezd2varz00zzjvm_externz00(BgL_envz00_28, 
(BgL_localz00_bglt)(BgL_varz00_1011), BgL_elabz00_1005); 
BGl__storez00zzjvm_instrz00(BgL_envz00_28, 
(BgL_localz00_bglt)(BgL_varz00_1011)); } } 
{ /* ./Jvm/compiler.scm 169 */
obj_t BgL_arg3597z00_1013;
{ /* ./Jvm/compiler.scm 169 */
obj_t BgL_pairz00_2100;
BgL_pairz00_2100 = BgL_l3137z00_1006; 
BgL_arg3597z00_1013 = 
CDR(BgL_pairz00_2100); } 
{ 
obj_t BgL_l3137z00_2983;
BgL_l3137z00_2983 = BgL_arg3597z00_1013; 
BgL_l3137z00_1006 = BgL_l3137z00_2983; 
goto BgL_forzd2each3138zd2_1007;} } }  else 
{ /* ./Jvm/compiler.scm 169 */((bool_t)1); } } } 
{ /* ./Jvm/compiler.scm 177 */
BgL_nodez00_bglt BgL_arg3602z00_1014;
BgL_arg3602z00_1014 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_ez00_27))->BgL_bodyz00); 
PROCEDURE_ENTRY(BgL_compilerz00_29)(BgL_compilerz00_29, 
(obj_t)(BgL_arg3602z00_1014), 
(obj_t)(BgL_envz00_28), BEOA); } 
if(
CBOOL(BgL_debugzf3zf3_1004))
{ /* ./Jvm/compiler.scm 178 */
BGl__labelz00zzjvm_instrz00(BgL_envz00_28, BgL_elabz00_1005); }  else 
{ /* ./Jvm/compiler.scm 178 */BFALSE; } 
{ /* ./Jvm/compiler.scm 179 */
BgL_nodez00_bglt BgL_arg3607z00_1015;
BgL_arg3607z00_1015 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_ez00_27))->BgL_bodyz00); 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_28, 
(obj_t)(BgL_arg3607z00_1015), 
(obj_t)(BgL_ez00_27)); } 
{ 
obj_t BgL_l3139z00_1016;
{ /* ./Jvm/compiler.scm 180 */
obj_t BgL_arg3611z00_1018;
BgL_arg3611z00_1018 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_ez00_27))->BgL_bindingsz00); 
{ /* ./Jvm/compiler.scm 180 */
bool_t BgL_auxz00_2997;
BgL_l3139z00_1016 = BgL_arg3611z00_1018; 
BgL_forzd2each3140zd2_1017:
if(
PAIRP(BgL_l3139z00_1016))
{ /* ./Jvm/compiler.scm 180 */
{ /* ./Jvm/compiler.scm 181 */
obj_t BgL_bz00_1020;
{ /* ./Jvm/compiler.scm 181 */
obj_t BgL_pairz00_2105;
BgL_pairz00_2105 = BgL_l3139z00_1016; 
BgL_bz00_1020 = 
CAR(BgL_pairz00_2105); } 
{ /* ./Jvm/compiler.scm 181 */
obj_t BgL_arg3616z00_1021;
{ /* ./Jvm/compiler.scm 181 */
obj_t BgL_arg3619z00_1022;
{ /* ./Jvm/compiler.scm 181 */
obj_t BgL_pairz00_2106;
BgL_pairz00_2106 = BgL_bz00_1020; 
BgL_arg3619z00_1022 = 
CAR(BgL_pairz00_2106); } 
BgL_arg3616z00_1021 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_arg3619z00_1022, BgL_envz00_28); } 
BGl_envzd2freezd2localz00zzjvm_envz00(BgL_envz00_28, BgL_arg3616z00_1021); } } 
{ /* ./Jvm/compiler.scm 180 */
obj_t BgL_arg3624z00_1023;
{ /* ./Jvm/compiler.scm 180 */
obj_t BgL_pairz00_2107;
BgL_pairz00_2107 = BgL_l3139z00_1016; 
BgL_arg3624z00_1023 = 
CDR(BgL_pairz00_2107); } 
{ 
obj_t BgL_l3139z00_3005;
BgL_l3139z00_3005 = BgL_arg3624z00_1023; 
BgL_l3139z00_1016 = BgL_l3139z00_3005; 
goto BgL_forzd2each3140zd2_1017;} } }  else 
{ /* ./Jvm/compiler.scm 180 */
BgL_auxz00_2997 = ((bool_t)1)
; } 
return 
BBOOL(BgL_auxz00_2997);} } } } } } 
}



/* _compiler-let5415 */
obj_t BGl__compilerzd2let5415zd2zzjvm_compilerz00(obj_t BgL_envz00_2520, obj_t BgL_ez00_2521, obj_t BgL_envz00_2522, obj_t BgL_compilerz00_2523)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 164 */
return 
BGl_compilerzd2letzd2zzjvm_compilerz00(
(BgL_letzd2varzd2_bglt)(BgL_ez00_2521), 
(BgL_envz00_bglt)(BgL_envz00_2522), BgL_compilerz00_2523);} 
}



/* compiler-setq */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2setqzd2zzjvm_compilerz00(BgL_setqz00_bglt BgL_ez00_30, BgL_envz00_bglt BgL_envz00_31)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 185 */
{ /* ./Jvm/compiler.scm 186 */
obj_t BgL_nz00_2110;
BgL_nz00_2110 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_30)); 
if(
CBOOL(BgL_nz00_2110))
{ /* ./Jvm/compiler.scm 186 */
BGl__linez00zzjvm_instrz00(BgL_envz00_31, BgL_nz00_2110); }  else 
{ /* ./Jvm/compiler.scm 186 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 188 */
BgL_nodez00_bglt BgL_arg3632z00_1025;
BgL_arg3632z00_1025 = 
(((BgL_setqz00_bglt)CREF(BgL_ez00_30))->BgL_valuez00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg3632z00_1025, BgL_envz00_31); } 
{ /* ./Jvm/compiler.scm 189 */
BgL_nodez00_bglt BgL_arg3636z00_1026;BgL_varz00_bglt BgL_arg3637z00_1027;
BgL_arg3636z00_1026 = 
(((BgL_setqz00_bglt)CREF(BgL_ez00_30))->BgL_valuez00); 
BgL_arg3637z00_1027 = 
(((BgL_setqz00_bglt)CREF(BgL_ez00_30))->BgL_varz00); 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_31, 
(obj_t)(BgL_arg3636z00_1026), 
(obj_t)(BgL_arg3637z00_1027)); } 
{ /* ./Jvm/compiler.scm 190 */
BgL_variablez00_bglt BgL_variablez00_1028;
{ /* ./Jvm/compiler.scm 190 */
BgL_varz00_bglt BgL_obj1625z00_2115;
BgL_obj1625z00_2115 = 
(((BgL_setqz00_bglt)CREF(BgL_ez00_30))->BgL_varz00); 
BgL_variablez00_1028 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2115))->BgL_variablez00); } 
{ /* ./Jvm/compiler.scm 191 */
bool_t BgL_testz00_3025;
{ /* ./Jvm/compiler.scm 191 */
obj_t BgL_obj1240z00_2116;
BgL_obj1240z00_2116 = 
(obj_t)(BgL_variablez00_1028); 
BgL_testz00_3025 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1240z00_2116, BGl_globalz00zzast_varz00); } 
if(BgL_testz00_3025)
{ /* ./Jvm/compiler.scm 191 */
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 193 */
obj_t BgL_arg3643z00_1030;
BgL_arg3643z00_1030 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_variablez00_1028), BgL_envz00_31); 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_31, BgL_arg3643z00_1030); }  else 
{ /* ./Jvm/compiler.scm 193 */BFALSE; } 
{ /* ./Jvm/compiler.scm 194 */
obj_t BgL_arg3648z00_1031;
BgL_arg3648z00_1031 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_31, 
(BgL_globalz00_bglt)(BgL_variablez00_1028)); 
return 
BGl__putstaticz00zzjvm_instrz00(BgL_envz00_31, BgL_arg3648z00_1031);} }  else 
{ /* ./Jvm/compiler.scm 191 */
return 
BGl__storez00zzjvm_instrz00(BgL_envz00_31, 
(BgL_localz00_bglt)(BgL_variablez00_1028));} } } } 
}



/* _compiler-setq5417 */
obj_t BGl__compilerzd2setq5417zd2zzjvm_compilerz00(obj_t BgL_envz00_2524, obj_t BgL_ez00_2525, obj_t BgL_envz00_2526)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 185 */
return 
BGl_compilerzd2setqzd2zzjvm_compilerz00(
(BgL_setqz00_bglt)(BgL_ez00_2525), 
(BgL_envz00_bglt)(BgL_envz00_2526));} 
}



/* compiler-sequence */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2sequencezd2zzjvm_compilerz00(BgL_sequencez00_bglt BgL_ez00_32, BgL_envz00_bglt BgL_envz00_33, obj_t BgL_compilerz00_34)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 198 */
{ /* ./Jvm/compiler.scm 199 */
obj_t BgL_nz00_2119;
BgL_nz00_2119 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_32)); 
if(
CBOOL(BgL_nz00_2119))
{ /* ./Jvm/compiler.scm 199 */
BGl__linez00zzjvm_instrz00(BgL_envz00_33, BgL_nz00_2119); }  else 
{ /* ./Jvm/compiler.scm 199 */
CNST_TABLE_REF(((long)4)); } } 
{ 
obj_t BgL_lz00_1038;obj_t BgL_nextz00_1039;
{ /* ./Jvm/compiler.scm 208 */
obj_t BgL_arg3659z00_1035;obj_t BgL_arg3660z00_1036;
BgL_arg3659z00_1035 = 
(((BgL_sequencez00_bglt)CREF(BgL_ez00_32))->BgL_nodesz00); 
{ /* ./Jvm/compiler.scm 208 */
obj_t BgL_pairz00_2122;
BgL_pairz00_2122 = 
(((BgL_sequencez00_bglt)CREF(BgL_ez00_32))->BgL_nodesz00); 
BgL_arg3660z00_1036 = 
CDR(BgL_pairz00_2122); } 
BgL_lz00_1038 = BgL_arg3659z00_1035; 
BgL_nextz00_1039 = BgL_arg3660z00_1036; 
BgL_zc3anonymousza33667ze3z83_1040:
if(
NULLP(BgL_nextz00_1039))
{ /* ./Jvm/compiler.scm 202 */
{ /* ./Jvm/compiler.scm 204 */
obj_t BgL_arg3670z00_1042;
{ /* ./Jvm/compiler.scm 204 */
obj_t BgL_pairz00_2124;
BgL_pairz00_2124 = BgL_lz00_1038; 
BgL_arg3670z00_1042 = 
CAR(BgL_pairz00_2124); } 
PROCEDURE_ENTRY(BgL_compilerz00_34)(BgL_compilerz00_34, BgL_arg3670z00_1042, 
(obj_t)(BgL_envz00_33), BEOA); } 
{ /* ./Jvm/compiler.scm 205 */
obj_t BgL_arg3674z00_1043;
{ /* ./Jvm/compiler.scm 205 */
obj_t BgL_pairz00_2125;
BgL_pairz00_2125 = BgL_lz00_1038; 
BgL_arg3674z00_1043 = 
CAR(BgL_pairz00_2125); } 
return 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_33, BgL_arg3674z00_1043, 
(obj_t)(BgL_ez00_32));} }  else 
{ /* ./Jvm/compiler.scm 202 */
{ /* ./Jvm/compiler.scm 206 */
obj_t BgL_arg3678z00_1044;
{ /* ./Jvm/compiler.scm 206 */
obj_t BgL_pairz00_2126;
BgL_pairz00_2126 = BgL_lz00_1038; 
BgL_arg3678z00_1044 = 
CAR(BgL_pairz00_2126); } 
BGl_compilezd2effectzd2zzjvm_effectz00(
(BgL_nodez00_bglt)(BgL_arg3678z00_1044), BgL_envz00_33); } 
{ /* ./Jvm/compiler.scm 207 */
obj_t BgL_arg3682z00_1045;
{ /* ./Jvm/compiler.scm 207 */
obj_t BgL_pairz00_2127;
BgL_pairz00_2127 = BgL_nextz00_1039; 
BgL_arg3682z00_1045 = 
CDR(BgL_pairz00_2127); } 
{ 
obj_t BgL_nextz00_3064;obj_t BgL_lz00_3063;
BgL_lz00_3063 = BgL_nextz00_1039; 
BgL_nextz00_3064 = BgL_arg3682z00_1045; 
BgL_nextz00_1039 = BgL_nextz00_3064; 
BgL_lz00_1038 = BgL_lz00_3063; 
goto BgL_zc3anonymousza33667ze3z83_1040;} } } } } } 
}



/* _compiler-sequence5419 */
obj_t BGl__compilerzd2sequence5419zd2zzjvm_compilerz00(obj_t BgL_envz00_2527, obj_t BgL_ez00_2528, obj_t BgL_envz00_2529, obj_t BgL_compilerz00_2530)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 198 */
return 
BGl_compilerzd2sequencezd2zzjvm_compilerz00(
(BgL_sequencez00_bglt)(BgL_ez00_2528), 
(BgL_envz00_bglt)(BgL_envz00_2529), BgL_compilerz00_2530);} 
}



/* compiler-if */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2ifzd2zzjvm_compilerz00(BgL_conditionalz00_bglt BgL_ez00_35, BgL_envz00_bglt BgL_envz00_36, obj_t BgL_compilerz00_37)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 211 */
{ /* ./Jvm/compiler.scm 212 */
obj_t BgL_nz00_2130;
BgL_nz00_2130 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_35)); 
if(
CBOOL(BgL_nz00_2130))
{ /* ./Jvm/compiler.scm 212 */
BGl__linez00zzjvm_instrz00(BgL_envz00_36, BgL_nz00_2130); }  else 
{ /* ./Jvm/compiler.scm 212 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 214 */
obj_t BgL_ltruez00_1048;obj_t BgL_lfalsez00_1049;obj_t BgL_lcontz00_1050;
BgL_ltruez00_1048 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5870z00zzjvm_compilerz00, BEOA); 
BgL_lfalsez00_1049 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5870z00zzjvm_compilerz00, BEOA); 
BgL_lcontz00_1050 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5870z00zzjvm_compilerz00, BEOA); 
{ /* ./Jvm/compiler.scm 215 */
BgL_nodez00_bglt BgL_arg3688z00_1051;
BgL_arg3688z00_1051 = 
(((BgL_conditionalz00_bglt)CREF(BgL_ez00_35))->BgL_testz00); 
BGl_compilezd2predicatezd2zzjvm_predicatez00(BgL_arg3688z00_1051, BgL_ltruez00_1048, BgL_lfalsez00_1049, BgL_envz00_36); } 
{ /* ./Jvm/compiler.scm 218 */
obj_t BgL_stackz00_1052;
BgL_stackz00_1052 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_36))->BgL_stackz00); 
BGl__labelz00zzjvm_instrz00(BgL_envz00_36, BgL_ltruez00_1048); 
{ /* ./Jvm/compiler.scm 220 */
BgL_nodez00_bglt BgL_arg3693z00_1053;
BgL_arg3693z00_1053 = 
(((BgL_conditionalz00_bglt)CREF(BgL_ez00_35))->BgL_truez00); 
PROCEDURE_ENTRY(BgL_compilerz00_37)(BgL_compilerz00_37, 
(obj_t)(BgL_arg3693z00_1053), 
(obj_t)(BgL_envz00_36), BEOA); } 
{ /* ./Jvm/compiler.scm 221 */
BgL_nodez00_bglt BgL_arg3697z00_1054;
BgL_arg3697z00_1054 = 
(((BgL_conditionalz00_bglt)CREF(BgL_ez00_35))->BgL_truez00); 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_36, 
(obj_t)(BgL_arg3697z00_1054), 
(obj_t)(BgL_ez00_35)); } 
{ /* ./Jvm/compiler.scm 222 */
obj_t BgL_rstackz00_1055;
BgL_rstackz00_1055 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_36))->BgL_stackz00); 
BGl__gotoz00zzjvm_instrz00(BgL_envz00_36, BgL_lcontz00_1050); 
{ /* ./Jvm/compiler.scm 224 */
BgL_envz00_bglt BgL_obj3069z00_2136;obj_t BgL_val3068z00_2137;
BgL_obj3069z00_2136 = BgL_envz00_36; 
BgL_val3068z00_2137 = BgL_stackz00_1052; 
((((BgL_envz00_bglt)CREF(BgL_obj3069z00_2136))->BgL_stackz00) = ((obj_t)BgL_val3068z00_2137), BUNSPEC); } 
BGl__labelz00zzjvm_instrz00(BgL_envz00_36, BgL_lfalsez00_1049); 
{ /* ./Jvm/compiler.scm 226 */
BgL_nodez00_bglt BgL_arg3704z00_1056;
BgL_arg3704z00_1056 = 
(((BgL_conditionalz00_bglt)CREF(BgL_ez00_35))->BgL_falsez00); 
PROCEDURE_ENTRY(BgL_compilerz00_37)(BgL_compilerz00_37, 
(obj_t)(BgL_arg3704z00_1056), 
(obj_t)(BgL_envz00_36), BEOA); } 
{ /* ./Jvm/compiler.scm 227 */
BgL_nodez00_bglt BgL_arg3708z00_1057;
BgL_arg3708z00_1057 = 
(((BgL_conditionalz00_bglt)CREF(BgL_ez00_35))->BgL_falsez00); 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_36, 
(obj_t)(BgL_arg3708z00_1057), 
(obj_t)(BgL_ez00_35)); } 
{ /* ./Jvm/compiler.scm 228 */
obj_t BgL_rrstackz00_1058;
BgL_rrstackz00_1058 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_36))->BgL_stackz00); 
{ /* ./Jvm/compiler.scm 229 */
bool_t BgL_testz00_3107;
if(
NULLP(BgL_rrstackz00_1058))
{ /* ./Jvm/compiler.scm 229 */
BgL_testz00_3107 = ((bool_t)0)
; }  else 
{ /* ./Jvm/compiler.scm 229 */
obj_t BgL_auxz00_3110;
{ /* ./Jvm/compiler.scm 229 */
obj_t BgL_pairz00_2142;
BgL_pairz00_2142 = BgL_rrstackz00_1058; 
BgL_auxz00_3110 = 
CAR(BgL_pairz00_2142); } 
BgL_testz00_3107 = 
(BgL_auxz00_3110==
CNST_TABLE_REF(((long)28))); } 
if(BgL_testz00_3107)
{ /* ./Jvm/compiler.scm 230 */
BgL_envz00_bglt BgL_obj3069z00_2143;obj_t BgL_val3068z00_2144;
BgL_obj3069z00_2143 = BgL_envz00_36; 
BgL_val3068z00_2144 = BgL_rstackz00_1055; 
((((BgL_envz00_bglt)CREF(BgL_obj3069z00_2143))->BgL_stackz00) = ((obj_t)BgL_val3068z00_2144), BUNSPEC); }  else 
{ /* ./Jvm/compiler.scm 229 */BFALSE; } } 
return 
BGl__labelz00zzjvm_instrz00(BgL_envz00_36, BgL_lcontz00_1050);} } } } } 
}



/* _compiler-if5421 */
obj_t BGl__compilerzd2if5421zd2zzjvm_compilerz00(obj_t BgL_envz00_2531, obj_t BgL_ez00_2532, obj_t BgL_envz00_2533, obj_t BgL_compilerz00_2534)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 211 */
return 
BGl_compilerzd2ifzd2zzjvm_compilerz00(
(BgL_conditionalz00_bglt)(BgL_ez00_2532), 
(BgL_envz00_bglt)(BgL_envz00_2533), BgL_compilerz00_2534);} 
}



/* compiler-select */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2selectzd2zzjvm_compilerz00(BgL_selectz00_bglt BgL_ez00_38, BgL_envz00_bglt BgL_envz00_39, obj_t BgL_compilerz00_40)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 234 */
{ /* ./Jvm/compiler.scm 235 */
obj_t BgL_nz00_2147;
BgL_nz00_2147 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_38)); 
if(
CBOOL(BgL_nz00_2147))
{ /* ./Jvm/compiler.scm 235 */
BGl__linez00zzjvm_instrz00(BgL_envz00_39, BgL_nz00_2147); }  else 
{ /* ./Jvm/compiler.scm 235 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 239 */
BgL_nodez00_bglt BgL_arg3729z00_1065;
BgL_arg3729z00_1065 = 
(((BgL_selectz00_bglt)CREF(BgL_ez00_38))->BgL_testz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg3729z00_1065, BgL_envz00_39); } 
{ /* ./Jvm/compiler.scm 240 */
BgL_nodez00_bglt BgL_arg3733z00_1066;obj_t BgL_arg3734z00_1067;
BgL_arg3733z00_1066 = 
(((BgL_selectz00_bglt)CREF(BgL_ez00_38))->BgL_testz00); 
BgL_arg3734z00_1067 = 
CNST_TABLE_REF(((long)9)); 
BGl_check_typez00zzjvm_compilerz00(BgL_envz00_39, 
(obj_t)(BgL_arg3733z00_1066), BgL_arg3734z00_1067); } 
{ /* ./Jvm/compiler.scm 241 */
bool_t BgL_testz00_3131;
{ 
obj_t BgL_l3150z00_1076;
BgL_l3150z00_1076 = 
(((BgL_selectz00_bglt)CREF(BgL_ez00_38))->BgL_clausesz00); 
BgL_every3151z00_1077:
if(
NULLP(BgL_l3150z00_1076))
{ /* ./Jvm/compiler.scm 241 */
BgL_testz00_3131 = ((bool_t)1)
; }  else 
{ /* ./Jvm/compiler.scm 241 */
bool_t BgL_testz00_3134;
{ /* ./Jvm/compiler.scm 241 */
obj_t BgL_cz00_1082;
{ /* ./Jvm/compiler.scm 241 */
obj_t BgL_pairz00_2152;
BgL_pairz00_2152 = BgL_l3150z00_1076; 
BgL_cz00_1082 = 
CAR(BgL_pairz00_2152); } 
{ /* ./Jvm/compiler.scm 241 */
bool_t BgL__ortest_3152z00_1083;
{ /* ./Jvm/compiler.scm 241 */
obj_t BgL_auxz00_3136;
{ /* ./Jvm/compiler.scm 241 */
obj_t BgL_pairz00_2153;
BgL_pairz00_2153 = BgL_cz00_1082; 
BgL_auxz00_3136 = 
CAR(BgL_pairz00_2153); } 
BgL__ortest_3152z00_1083 = 
(BgL_auxz00_3136==
CNST_TABLE_REF(((long)29))); } 
if(BgL__ortest_3152z00_1083)
{ /* ./Jvm/compiler.scm 241 */
BgL_testz00_3134 = BgL__ortest_3152z00_1083
; }  else 
{ 
obj_t BgL_l3153z00_1084;
{ /* ./Jvm/compiler.scm 242 */
obj_t BgL_pairz00_2154;
BgL_pairz00_2154 = BgL_cz00_1082; 
BgL_l3153z00_1084 = 
CAR(BgL_pairz00_2154); } 
BgL_every3154z00_1085:
if(
NULLP(BgL_l3153z00_1084))
{ /* ./Jvm/compiler.scm 242 */
BgL_testz00_3134 = ((bool_t)1)
; }  else 
{ /* ./Jvm/compiler.scm 242 */
bool_t BgL_testz00_3143;
{ /* ./Jvm/compiler.scm 242 */
obj_t BgL_nz00_2157;
{ /* ./Jvm/compiler.scm 242 */
obj_t BgL_pairz00_2156;
BgL_pairz00_2156 = BgL_l3153z00_1084; 
BgL_nz00_2157 = 
CAR(BgL_pairz00_2156); } 
{ /* ./Jvm/compiler.scm 242 */
bool_t BgL__ortest_3147z00_2158;
BgL__ortest_3147z00_2158 = 
INTEGERP(BgL_nz00_2157); 
if(BgL__ortest_3147z00_2158)
{ /* ./Jvm/compiler.scm 242 */
BgL_testz00_3143 = BgL__ortest_3147z00_2158
; }  else 
{ /* ./Jvm/compiler.scm 242 */
BgL_testz00_3143 = 
CHARP(BgL_nz00_2157)
; } } } 
if(BgL_testz00_3143)
{ 
obj_t BgL_l3153z00_3148;
{ /* ./Jvm/compiler.scm 242 */
obj_t BgL_pairz00_2161;
BgL_pairz00_2161 = BgL_l3153z00_1084; 
BgL_l3153z00_3148 = 
CDR(BgL_pairz00_2161); } 
BgL_l3153z00_1084 = BgL_l3153z00_3148; 
goto BgL_every3154z00_1085;}  else 
{ /* ./Jvm/compiler.scm 242 */
BgL_testz00_3134 = ((bool_t)0)
; } } } } } 
if(BgL_testz00_3134)
{ 
obj_t BgL_l3150z00_3151;
{ /* ./Jvm/compiler.scm 241 */
obj_t BgL_pairz00_2162;
BgL_pairz00_2162 = BgL_l3150z00_1076; 
BgL_l3150z00_3151 = 
CDR(BgL_pairz00_2162); } 
BgL_l3150z00_1076 = BgL_l3150z00_3151; 
goto BgL_every3151z00_1077;}  else 
{ /* ./Jvm/compiler.scm 241 */
BgL_testz00_3131 = ((bool_t)0)
; } } } 
if(BgL_testz00_3131)
{ /* ./Jvm/compiler.scm 244 */
obj_t BgL_arg3739z00_1069;obj_t BgL_arg3740z00_1070;
{ /* ./Jvm/compiler.scm 244 */
BgL_typez00_bglt BgL_arg3743z00_1071;
BgL_arg3743z00_1071 = 
(((BgL_selectz00_bglt)CREF(BgL_ez00_38))->BgL_itemzd2typezd2); 
BgL_arg3739z00_1069 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg3743z00_1071), BgL_envz00_39); } 
BgL_arg3740z00_1070 = 
(((BgL_selectz00_bglt)CREF(BgL_ez00_38))->BgL_clausesz00); 
return 
BGl_selectzd2intzd2zzjvm_compilerz00(BgL_envz00_39, BgL_arg3739z00_1069, BgL_arg3740z00_1070, BgL_compilerz00_40, BgL_ez00_38);}  else 
{ /* ./Jvm/compiler.scm 245 */
obj_t BgL_arg3750z00_1074;
{ /* ./Jvm/compiler.scm 245 */
BgL_typez00_bglt BgL_arg3753z00_1075;
BgL_arg3753z00_1075 = 
(((BgL_selectz00_bglt)CREF(BgL_ez00_38))->BgL_itemzd2typezd2); 
BgL_arg3750z00_1074 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg3753z00_1075), BgL_envz00_39); } 
FAILURE(BGl_string5871z00zzjvm_compilerz00,BGl_string5872z00zzjvm_compilerz00,BgL_arg3750z00_1074);} } } 
}



/* _compiler-select5423 */
obj_t BGl__compilerzd2select5423zd2zzjvm_compilerz00(obj_t BgL_envz00_2535, obj_t BgL_ez00_2536, obj_t BgL_envz00_2537, obj_t BgL_compilerz00_2538)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 234 */
return 
BGl_compilerzd2selectzd2zzjvm_compilerz00(
(BgL_selectz00_bglt)(BgL_ez00_2536), 
(BgL_envz00_bglt)(BgL_envz00_2537), BgL_compilerz00_2538);} 
}



/* select-int */
obj_t BGl_selectzd2intzd2zzjvm_compilerz00(BgL_envz00_bglt BgL_envz00_41, obj_t BgL_itemzd2typezd2_42, obj_t BgL_clausesz00_43, obj_t BgL_compz00_44, BgL_selectz00_bglt BgL_ez00_45)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 247 */
{ 
obj_t BgL_nz00_1132;
if(
(BgL_itemzd2typezd2_42==
CNST_TABLE_REF(((long)30))))
{ /* ./Jvm/compiler.scm 252 */
BGl__l2iz00zzjvm_instrz00(BgL_envz00_41); }  else 
{ /* ./Jvm/compiler.scm 252 */BFALSE; } 
{ /* ./Jvm/compiler.scm 253 */
obj_t BgL_ldefz00_1099;obj_t BgL_lcontz00_1100;obj_t BgL_dz00_1101;obj_t BgL_num2labz00_1102;obj_t BgL_lab2nodez00_1103;
BgL_ldefz00_1099 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5870z00zzjvm_compilerz00, BEOA); 
BgL_lcontz00_1100 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5870z00zzjvm_compilerz00, BEOA); 
BgL_dz00_1101 = BFALSE; 
BgL_num2labz00_1102 = BNIL; 
BgL_lab2nodez00_1103 = BNIL; 
{ 
obj_t BgL_l3155z00_1104;
BgL_l3155z00_1104 = BgL_clausesz00_43; 
BgL_forzd2each3156zd2_1105:
if(
PAIRP(BgL_l3155z00_1104))
{ /* ./Jvm/compiler.scm 255 */
{ /* ./Jvm/compiler.scm 257 */
obj_t BgL_cz00_1107;
{ /* ./Jvm/compiler.scm 257 */
obj_t BgL_pairz00_2173;
BgL_pairz00_2173 = BgL_l3155z00_1104; 
BgL_cz00_1107 = 
CAR(BgL_pairz00_2173); } 
{ /* ./Jvm/compiler.scm 257 */
bool_t BgL_testz00_3177;
{ /* ./Jvm/compiler.scm 257 */
obj_t BgL_auxz00_3178;
{ /* ./Jvm/compiler.scm 257 */
obj_t BgL_pairz00_2174;
BgL_pairz00_2174 = BgL_cz00_1107; 
BgL_auxz00_3178 = 
CAR(BgL_pairz00_2174); } 
BgL_testz00_3177 = 
(BgL_auxz00_3178==
CNST_TABLE_REF(((long)29))); } 
if(BgL_testz00_3177)
{ /* ./Jvm/compiler.scm 258 */
obj_t BgL_pairz00_2175;
BgL_pairz00_2175 = BgL_cz00_1107; 
BgL_dz00_1101 = 
CDR(BgL_pairz00_2175); }  else 
{ /* ./Jvm/compiler.scm 259 */
obj_t BgL_labz00_1109;
BgL_labz00_1109 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5870z00zzjvm_compilerz00, BEOA); 
{ 
obj_t BgL_l3157z00_1110;
{ /* ./Jvm/compiler.scm 262 */
obj_t BgL_arg3800z00_1112;
{ /* ./Jvm/compiler.scm 262 */
obj_t BgL_pairz00_2176;
BgL_pairz00_2176 = BgL_cz00_1107; 
BgL_arg3800z00_1112 = 
CAR(BgL_pairz00_2176); } 
BgL_l3157z00_1110 = BgL_arg3800z00_1112; 
BgL_forzd2each3158zd2_1111:
if(
PAIRP(BgL_l3157z00_1110))
{ /* ./Jvm/compiler.scm 260 */
{ /* ./Jvm/compiler.scm 261 */
obj_t BgL_nz00_1114;
{ /* ./Jvm/compiler.scm 261 */
obj_t BgL_pairz00_2178;
BgL_pairz00_2178 = BgL_l3157z00_1110; 
BgL_nz00_1114 = 
CAR(BgL_pairz00_2178); } 
{ /* ./Jvm/compiler.scm 261 */
obj_t BgL_arg3805z00_1115;
{ /* ./Jvm/compiler.scm 261 */
obj_t BgL_arg3808z00_1116;
BgL_nz00_1132 = BgL_nz00_1114; 
if(
INTEGERP(BgL_nz00_1132))
{ /* ./Jvm/compiler.scm 249 */
BgL_arg3808z00_1116 = BgL_nz00_1132; }  else 
{ /* ./Jvm/compiler.scm 249 */
if(
CHARP(BgL_nz00_1132))
{ /* ./Jvm/compiler.scm 250 */
BgL_arg3808z00_1116 = 
BINT(
(
(unsigned char)CCHAR(BgL_nz00_1132))); }  else 
{ /* ./Jvm/compiler.scm 250 */
FAILURE(BGl_string5871z00zzjvm_compilerz00,BGl_string5873z00zzjvm_compilerz00,BgL_nz00_1132);} } 
BgL_arg3805z00_1115 = 
MAKE_PAIR(BgL_arg3808z00_1116, BgL_labz00_1109); } 
BgL_num2labz00_1102 = 
MAKE_PAIR(BgL_arg3805z00_1115, BgL_num2labz00_1102); } } 
{ /* ./Jvm/compiler.scm 260 */
obj_t BgL_arg3813z00_1117;
{ /* ./Jvm/compiler.scm 260 */
obj_t BgL_pairz00_2179;
BgL_pairz00_2179 = BgL_l3157z00_1110; 
BgL_arg3813z00_1117 = 
CDR(BgL_pairz00_2179); } 
{ 
obj_t BgL_l3157z00_3200;
BgL_l3157z00_3200 = BgL_arg3813z00_1117; 
BgL_l3157z00_1110 = BgL_l3157z00_3200; 
goto BgL_forzd2each3158zd2_1111;} } }  else 
{ /* ./Jvm/compiler.scm 260 */((bool_t)1); } } } 
{ /* ./Jvm/compiler.scm 263 */
obj_t BgL_arg3818z00_1118;
{ /* ./Jvm/compiler.scm 263 */
obj_t BgL_arg3821z00_1119;
{ /* ./Jvm/compiler.scm 263 */
obj_t BgL_pairz00_2180;
BgL_pairz00_2180 = BgL_cz00_1107; 
BgL_arg3821z00_1119 = 
CDR(BgL_pairz00_2180); } 
BgL_arg3818z00_1118 = 
MAKE_PAIR(BgL_labz00_1109, BgL_arg3821z00_1119); } 
BgL_lab2nodez00_1103 = 
MAKE_PAIR(BgL_arg3818z00_1118, BgL_lab2nodez00_1103); } } } } 
{ /* ./Jvm/compiler.scm 255 */
obj_t BgL_arg3833z00_1122;
{ /* ./Jvm/compiler.scm 255 */
obj_t BgL_pairz00_2181;
BgL_pairz00_2181 = BgL_l3155z00_1104; 
BgL_arg3833z00_1122 = 
CDR(BgL_pairz00_2181); } 
{ 
obj_t BgL_l3155z00_3205;
BgL_l3155z00_3205 = BgL_arg3833z00_1122; 
BgL_l3155z00_1104 = BgL_l3155z00_3205; 
goto BgL_forzd2each3156zd2_1105;} } }  else 
{ /* ./Jvm/compiler.scm 255 */((bool_t)1); } } 
BGl__switchz00zzjvm_instrz00(BgL_envz00_41, BgL_ldefz00_1099, BgL_num2labz00_1102); 
{ /* ./Jvm/compiler.scm 266 */
obj_t BgL_stackz00_1123;
BgL_stackz00_1123 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_41))->BgL_stackz00); 
{ 
obj_t BgL_l3159z00_1124;
BgL_l3159z00_1124 = BgL_lab2nodez00_1103; 
BgL_forzd2each3160zd2_1125:
if(
PAIRP(BgL_l3159z00_1124))
{ /* ./Jvm/compiler.scm 267 */
{ /* ./Jvm/compiler.scm 268 */
obj_t BgL_slotz00_1127;
{ /* ./Jvm/compiler.scm 268 */
obj_t BgL_pairz00_2184;
BgL_pairz00_2184 = BgL_l3159z00_1124; 
BgL_slotz00_1127 = 
CAR(BgL_pairz00_2184); } 
{ /* ./Jvm/compiler.scm 268 */
obj_t BgL_arg3841z00_1128;
{ /* ./Jvm/compiler.scm 268 */
obj_t BgL_pairz00_2185;
BgL_pairz00_2185 = BgL_slotz00_1127; 
BgL_arg3841z00_1128 = 
CAR(BgL_pairz00_2185); } 
BGl__labelz00zzjvm_instrz00(BgL_envz00_41, BgL_arg3841z00_1128); } 
{ /* ./Jvm/compiler.scm 269 */
BgL_envz00_bglt BgL_obj3069z00_2186;obj_t BgL_val3068z00_2187;
BgL_obj3069z00_2186 = BgL_envz00_41; 
BgL_val3068z00_2187 = BgL_stackz00_1123; 
((((BgL_envz00_bglt)CREF(BgL_obj3069z00_2186))->BgL_stackz00) = ((obj_t)BgL_val3068z00_2187), BUNSPEC); } 
{ /* ./Jvm/compiler.scm 270 */
obj_t BgL_arg3846z00_1129;
{ /* ./Jvm/compiler.scm 270 */
obj_t BgL_pairz00_2188;
BgL_pairz00_2188 = BgL_slotz00_1127; 
BgL_arg3846z00_1129 = 
CDR(BgL_pairz00_2188); } 
PROCEDURE_ENTRY(BgL_compz00_44)(BgL_compz00_44, BgL_arg3846z00_1129, 
(obj_t)(BgL_envz00_41), BEOA); } 
{ /* ./Jvm/compiler.scm 271 */
obj_t BgL_arg3850z00_1130;
{ /* ./Jvm/compiler.scm 271 */
obj_t BgL_pairz00_2189;
BgL_pairz00_2189 = BgL_slotz00_1127; 
BgL_arg3850z00_1130 = 
CDR(BgL_pairz00_2189); } 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_41, BgL_arg3850z00_1130, 
(obj_t)(BgL_ez00_45)); } 
BGl__gotoz00zzjvm_instrz00(BgL_envz00_41, BgL_lcontz00_1100); } 
{ /* ./Jvm/compiler.scm 267 */
obj_t BgL_arg3856z00_1131;
{ /* ./Jvm/compiler.scm 267 */
obj_t BgL_pairz00_2190;
BgL_pairz00_2190 = BgL_l3159z00_1124; 
BgL_arg3856z00_1131 = 
CDR(BgL_pairz00_2190); } 
{ 
obj_t BgL_l3159z00_3223;
BgL_l3159z00_3223 = BgL_arg3856z00_1131; 
BgL_l3159z00_1124 = BgL_l3159z00_3223; 
goto BgL_forzd2each3160zd2_1125;} } }  else 
{ /* ./Jvm/compiler.scm 267 */((bool_t)1); } } 
BGl__labelz00zzjvm_instrz00(BgL_envz00_41, BgL_ldefz00_1099); 
if(
CBOOL(BgL_dz00_1101))
{ /* ./Jvm/compiler.scm 275 */
{ /* ./Jvm/compiler.scm 275 */
BgL_envz00_bglt BgL_obj3069z00_2191;obj_t BgL_val3068z00_2192;
BgL_obj3069z00_2191 = BgL_envz00_41; 
BgL_val3068z00_2192 = BgL_stackz00_1123; 
((((BgL_envz00_bglt)CREF(BgL_obj3069z00_2191))->BgL_stackz00) = ((obj_t)BgL_val3068z00_2192), BUNSPEC); } 
PROCEDURE_ENTRY(BgL_compz00_44)(BgL_compz00_44, BgL_dz00_1101, 
(obj_t)(BgL_envz00_41), BEOA); 
BGl_samezd2typezd2zzjvm_compilerz00(BgL_envz00_41, BgL_dz00_1101, 
(obj_t)(BgL_ez00_45)); }  else 
{ /* ./Jvm/compiler.scm 275 */BFALSE; } 
return 
BGl__labelz00zzjvm_instrz00(BgL_envz00_41, BgL_lcontz00_1100);} } } } 
}



/* compiler-labels */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2labelszd2zzjvm_compilerz00(BgL_letzd2funzd2_bglt BgL_ez00_46, BgL_envz00_bglt BgL_envz00_47, obj_t BgL_compz00_48)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 281 */
{ /* ./Jvm/compiler.scm 282 */
obj_t BgL_nz00_2201;
BgL_nz00_2201 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_46)); 
if(
CBOOL(BgL_nz00_2201))
{ /* ./Jvm/compiler.scm 282 */
BGl__linez00zzjvm_instrz00(BgL_envz00_47, BgL_nz00_2201); }  else 
{ /* ./Jvm/compiler.scm 282 */
CNST_TABLE_REF(((long)4)); } } 
{ 
obj_t BgL_l3163z00_1138;
{ /* ./Jvm/compiler.scm 284 */
obj_t BgL_arg3878z00_1140;
BgL_arg3878z00_1140 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_ez00_46))->BgL_localsz00); 
BgL_l3163z00_1138 = BgL_arg3878z00_1140; 
BgL_forzd2each3164zd2_1139:
if(
PAIRP(BgL_l3163z00_1138))
{ /* ./Jvm/compiler.scm 284 */
{ /* ./Jvm/compiler.scm 286 */
obj_t BgL_vz00_1142;
{ /* ./Jvm/compiler.scm 286 */
obj_t BgL_pairz00_2204;
BgL_pairz00_2204 = BgL_l3163z00_1138; 
BgL_vz00_1142 = 
CAR(BgL_pairz00_2204); } 
BGl_envzd2setzd2namez12z12zzjvm_envz00(BgL_envz00_47, 
(BgL_localz00_bglt)(BgL_vz00_1142), 
CNST_TABLE_REF(((long)31))); 
{ /* ./Jvm/compiler.scm 287 */
obj_t BgL_arg3884z00_1143;
BgL_arg3884z00_1143 = 
MAKE_PAIR(BgL_vz00_1142, 
(obj_t)(BgL_ez00_46)); 
BGl_za2lab2labelsza2z00zzjvm_compilerz00 = 
MAKE_PAIR(BgL_arg3884z00_1143, BGl_za2lab2labelsza2z00zzjvm_compilerz00); } } 
{ /* ./Jvm/compiler.scm 284 */
obj_t BgL_arg3889z00_1144;
{ /* ./Jvm/compiler.scm 284 */
obj_t BgL_pairz00_2205;
BgL_pairz00_2205 = BgL_l3163z00_1138; 
BgL_arg3889z00_1144 = 
CDR(BgL_pairz00_2205); } 
{ 
obj_t BgL_l3163z00_3251;
BgL_l3163z00_3251 = BgL_arg3889z00_1144; 
BgL_l3163z00_1138 = BgL_l3163z00_3251; 
goto BgL_forzd2each3164zd2_1139;} } }  else 
{ /* ./Jvm/compiler.scm 284 */((bool_t)1); } } } 
{ /* ./Jvm/compiler.scm 289 */
obj_t BgL_arg3894z00_1145;
BgL_arg3894z00_1145 = 
MAKE_PAIR(
(obj_t)(BgL_ez00_46), BNIL); 
BGl_za2labels2savedza2z00zzjvm_compilerz00 = 
MAKE_PAIR(BgL_arg3894z00_1145, BGl_za2labels2savedza2z00zzjvm_compilerz00); } 
{ /* ./Jvm/compiler.scm 290 */
BgL_nodez00_bglt BgL_arg3898z00_1146;
BgL_arg3898z00_1146 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_ez00_46))->BgL_bodyz00); 
return 
PROCEDURE_ENTRY(BgL_compz00_48)(BgL_compz00_48, 
(obj_t)(BgL_arg3898z00_1146), 
(obj_t)(BgL_envz00_47), BEOA);} } 
}



/* _compiler-labels5425 */
obj_t BGl__compilerzd2labels5425zd2zzjvm_compilerz00(obj_t BgL_envz00_2539, obj_t BgL_ez00_2540, obj_t BgL_envz00_2541, obj_t BgL_compz00_2542)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 281 */
return 
BGl_compilerzd2labelszd2zzjvm_compilerz00(
(BgL_letzd2funzd2_bglt)(BgL_ez00_2540), 
(BgL_envz00_bglt)(BgL_envz00_2541), BgL_compz00_2542);} 
}



/* compile-label-call */
obj_t BGl_compilezd2labelzd2callz00zzjvm_compilerz00(BgL_variablez00_bglt BgL_localz00_52, obj_t BgL_argsz00_53, BgL_envz00_bglt BgL_envz00_54)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 358 */
{ 
obj_t BgL_l3188z00_1218;
BgL_l3188z00_1218 = BgL_argsz00_53; 
BgL_forzd2each3189zd2_1219:
if(
PAIRP(BgL_l3188z00_1218))
{ /* ./Jvm/compiler.scm 360 */
{ /* ./Jvm/compiler.scm 360 */
obj_t BgL_ez00_1221;
{ /* ./Jvm/compiler.scm 360 */
obj_t BgL_pairz00_2208;
BgL_pairz00_2208 = BgL_l3188z00_1218; 
BgL_ez00_1221 = 
CAR(BgL_pairz00_2208); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_ez00_1221), BgL_envz00_54); } 
{ /* ./Jvm/compiler.scm 360 */
obj_t BgL_arg4043z00_1222;
{ /* ./Jvm/compiler.scm 360 */
obj_t BgL_pairz00_2209;
BgL_pairz00_2209 = BgL_l3188z00_1218; 
BgL_arg4043z00_1222 = 
CDR(BgL_pairz00_2209); } 
{ 
obj_t BgL_l3188z00_3269;
BgL_l3188z00_3269 = BgL_arg4043z00_1222; 
BgL_l3188z00_1218 = BgL_l3188z00_3269; 
goto BgL_forzd2each3189zd2_1219;} } }  else 
{ /* ./Jvm/compiler.scm 360 */((bool_t)1); } } 
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
(obj_t)(BgL_localz00_52), BGl_za2labdoneza2z00zzjvm_compilerz00)))
{ /* ./Jvm/compiler.scm 365 */
BgL_valuez00_bglt BgL_instance3192z00_1225;
BgL_instance3192z00_1225 = 
(((BgL_variablez00_bglt)CREF(BgL_localz00_52))->BgL_valuez00); 
{ 
obj_t BgL_l3194z00_1226;
{ /* ./Jvm/compiler.scm 366 */
obj_t BgL_arg4049z00_1228;
{ /* ./Jvm/compiler.scm 366 */
obj_t BgL_auxz00_3275;
{ /* ./Jvm/compiler.scm 366 */
BgL_sfunz00_bglt BgL_obj1367z00_2211;
BgL_obj1367z00_2211 = 
(BgL_sfunz00_bglt)(BgL_instance3192z00_1225); 
BgL_auxz00_3275 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1367z00_2211))->BgL_argsz00); } 
BgL_arg4049z00_1228 = 
bgl_reverse(BgL_auxz00_3275); } 
BgL_l3194z00_1226 = BgL_arg4049z00_1228; 
BgL_forzd2each3195zd2_1227:
if(
PAIRP(BgL_l3194z00_1226))
{ /* ./Jvm/compiler.scm 366 */
{ /* ./Jvm/compiler.scm 366 */
obj_t BgL_argz00_1231;
{ /* ./Jvm/compiler.scm 366 */
obj_t BgL_pairz00_2213;
BgL_pairz00_2213 = BgL_l3194z00_1226; 
BgL_argz00_1231 = 
CAR(BgL_pairz00_2213); } 
BGl__storez00zzjvm_instrz00(BgL_envz00_54, 
(BgL_localz00_bglt)(BgL_argz00_1231)); } 
{ /* ./Jvm/compiler.scm 366 */
obj_t BgL_arg4059z00_1232;
{ /* ./Jvm/compiler.scm 366 */
obj_t BgL_pairz00_2214;
BgL_pairz00_2214 = BgL_l3194z00_1226; 
BgL_arg4059z00_1232 = 
CDR(BgL_pairz00_2214); } 
{ 
obj_t BgL_l3194z00_3285;
BgL_l3194z00_3285 = BgL_arg4059z00_1232; 
BgL_l3194z00_1226 = BgL_l3194z00_3285; 
goto BgL_forzd2each3195zd2_1227;} } }  else 
{ /* ./Jvm/compiler.scm 366 */((bool_t)1); } } } 
{ /* ./Jvm/compiler.scm 367 */
obj_t BgL_stkz00_1233;
BgL_stkz00_1233 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_54))->BgL_stackz00); 
if(
NULLP(BgL_stkz00_1233))
{ /* ./Jvm/compiler.scm 370 */
obj_t BgL_arg4065z00_1235;
BgL_arg4065z00_1235 = 
(((BgL_variablez00_bglt)CREF(BgL_localz00_52))->BgL_namez00); 
BGl__gotoz00zzjvm_instrz00(BgL_envz00_54, BgL_arg4065z00_1235); }  else 
{ /* ./Jvm/compiler.scm 371 */
obj_t BgL_arg4069z00_1236;
{ /* ./Jvm/compiler.scm 371 */
obj_t BgL_arg4072z00_1237;obj_t BgL_arg4073z00_1238;
BgL_arg4072z00_1237 = 
CNST_TABLE_REF(((long)32)); 
BgL_arg4073z00_1238 = 
(((BgL_variablez00_bglt)CREF(BgL_localz00_52))->BgL_namez00); 
{ /* ./Jvm/compiler.scm 371 */
obj_t BgL_list4075z00_1239;
{ /* ./Jvm/compiler.scm 371 */
obj_t BgL_arg4077z00_1240;
BgL_arg4077z00_1240 = 
MAKE_PAIR(BgL_arg4073z00_1238, BNIL); 
BgL_list4075z00_1239 = 
MAKE_PAIR(BgL_arg4072z00_1237, BgL_arg4077z00_1240); } 
BgL_arg4069z00_1236 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list4075z00_1239); } } 
BGl__gotoz00zzjvm_instrz00(BgL_envz00_54, BgL_arg4069z00_1236); } 
{ /* ./Jvm/compiler.scm 372 */
obj_t BgL_arg4083z00_1241;
{ /* ./Jvm/compiler.scm 372 */
obj_t BgL_arg4086z00_1242;obj_t BgL_arg4087z00_1243;
BgL_arg4086z00_1242 = 
CNST_TABLE_REF(((long)28)); 
BgL_arg4087z00_1243 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_54))->BgL_stackz00); 
BgL_arg4083z00_1241 = 
MAKE_PAIR(BgL_arg4086z00_1242, BgL_arg4087z00_1243); } 
{ /* ./Jvm/compiler.scm 372 */
BgL_envz00_bglt BgL_obj3069z00_2220;obj_t BgL_val3068z00_2221;
BgL_obj3069z00_2220 = BgL_envz00_54; 
BgL_val3068z00_2221 = BgL_arg4083z00_1241; 
return 
((((BgL_envz00_bglt)CREF(BgL_obj3069z00_2220))->BgL_stackz00) = ((obj_t)BgL_val3068z00_2221), BUNSPEC);} } } }  else 
{ /* ./Jvm/compiler.scm 374 */
BgL_valuez00_bglt BgL_instance3198z00_1245;
BgL_instance3198z00_1245 = 
(((BgL_variablez00_bglt)CREF(BgL_localz00_52))->BgL_valuez00); 
BGl_za2labdoneza2z00zzjvm_compilerz00 = 
MAKE_PAIR(
(obj_t)(BgL_localz00_52), BGl_za2labdoneza2z00zzjvm_compilerz00); 
{ /* ./Jvm/compiler.scm 376 */
obj_t BgL_debugzf3zf3_1246;
BgL_debugzf3zf3_1246 = 
BGl_debugzd2forzd2declarezd2varzf3z21zzjvm_externz00(BgL_envz00_54); 
{ /* ./Jvm/compiler.scm 376 */
obj_t BgL_blabz00_1247;
if(
CBOOL(BgL_debugzf3zf3_1246))
{ /* ./Jvm/compiler.scm 377 */
BgL_blabz00_1247 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5874z00zzjvm_compilerz00, BEOA); }  else 
{ /* ./Jvm/compiler.scm 377 */
BgL_blabz00_1247 = 
CNST_TABLE_REF(((long)27)); } 
{ /* ./Jvm/compiler.scm 377 */
obj_t BgL_elabz00_1248;
if(
CBOOL(BgL_debugzf3zf3_1246))
{ /* ./Jvm/compiler.scm 378 */
BgL_elabz00_1248 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5869z00zzjvm_compilerz00, BEOA); }  else 
{ /* ./Jvm/compiler.scm 378 */
BgL_elabz00_1248 = 
CNST_TABLE_REF(((long)27)); } 
{ /* ./Jvm/compiler.scm 378 */

if(
CBOOL(BgL_debugzf3zf3_1246))
{ /* ./Jvm/compiler.scm 379 */
BGl__labelz00zzjvm_instrz00(BgL_envz00_54, BgL_blabz00_1247); }  else 
{ /* ./Jvm/compiler.scm 379 */BFALSE; } 
{ 
obj_t BgL_l3200z00_1249;
{ /* ./Jvm/compiler.scm 385 */
obj_t BgL_arg4095z00_1251;
{ /* ./Jvm/compiler.scm 385 */
obj_t BgL_auxz00_3318;
{ /* ./Jvm/compiler.scm 385 */
BgL_sfunz00_bglt BgL_obj1367z00_2223;
BgL_obj1367z00_2223 = 
(BgL_sfunz00_bglt)(BgL_instance3198z00_1245); 
BgL_auxz00_3318 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1367z00_2223))->BgL_argsz00); } 
BgL_arg4095z00_1251 = 
bgl_reverse(BgL_auxz00_3318); } 
BgL_l3200z00_1249 = BgL_arg4095z00_1251; 
BgL_forzd2each3201zd2_1250:
if(
PAIRP(BgL_l3200z00_1249))
{ /* ./Jvm/compiler.scm 380 */
{ /* ./Jvm/compiler.scm 382 */
obj_t BgL_argz00_1254;
{ /* ./Jvm/compiler.scm 382 */
obj_t BgL_pairz00_2225;
BgL_pairz00_2225 = BgL_l3200z00_1249; 
BgL_argz00_1254 = 
CAR(BgL_pairz00_2225); } 
BGl_envzd2declarezd2newzd2localzd2zzjvm_envz00(BgL_envz00_54, 
(BgL_localz00_bglt)(BgL_argz00_1254)); 
BGl_debugzd2declarezd2varzd2fromzd2zzjvm_externz00(BgL_envz00_54, 
(BgL_localz00_bglt)(BgL_argz00_1254), BgL_blabz00_1247, BgL_elabz00_1248); 
BGl__storez00zzjvm_instrz00(BgL_envz00_54, 
(BgL_localz00_bglt)(BgL_argz00_1254)); } 
{ /* ./Jvm/compiler.scm 380 */
obj_t BgL_arg4107z00_1255;
{ /* ./Jvm/compiler.scm 380 */
obj_t BgL_pairz00_2226;
BgL_pairz00_2226 = BgL_l3200z00_1249; 
BgL_arg4107z00_1255 = 
CDR(BgL_pairz00_2226); } 
{ 
obj_t BgL_l3200z00_3332;
BgL_l3200z00_3332 = BgL_arg4107z00_1255; 
BgL_l3200z00_1249 = BgL_l3200z00_3332; 
goto BgL_forzd2each3201zd2_1250;} } }  else 
{ /* ./Jvm/compiler.scm 380 */((bool_t)1); } } } 
{ /* ./Jvm/compiler.scm 386 */
obj_t BgL_stkz00_1256;
BgL_stkz00_1256 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_54))->BgL_stackz00); 
{ /* ./Jvm/compiler.scm 386 */
obj_t BgL_varsz00_1257;
if(
NULLP(BgL_stkz00_1256))
{ /* ./Jvm/compiler.scm 387 */
BgL_varsz00_1257 = BNIL; }  else 
{ /* ./Jvm/compiler.scm 387 */
obj_t BgL_head3204z00_1295;
BgL_head3204z00_1295 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l3202z00_1296;obj_t BgL_tail3205z00_1297;
BgL_l3202z00_1296 = BgL_stkz00_1256; 
BgL_tail3205z00_1297 = BgL_head3204z00_1295; 
BgL_map3203z00_1298:
if(
NULLP(BgL_l3202z00_1296))
{ /* ./Jvm/compiler.scm 387 */
BgL_varsz00_1257 = 
CDR(BgL_head3204z00_1295); }  else 
{ /* ./Jvm/compiler.scm 387 */
obj_t BgL_newtail3206z00_1300;
{ /* ./Jvm/compiler.scm 387 */
obj_t BgL_arg4195z00_1302;
{ /* ./Jvm/compiler.scm 387 */
obj_t BgL_tyz00_1304;
{ /* ./Jvm/compiler.scm 387 */
obj_t BgL_pairz00_2233;
BgL_pairz00_2233 = BgL_l3202z00_1296; 
BgL_tyz00_1304 = 
CAR(BgL_pairz00_2233); } 
BgL_arg4195z00_1302 = 
BGl_envzd2alloczd2localz00zzjvm_envz00(BgL_envz00_54, BgL_tyz00_1304); } 
BgL_newtail3206z00_1300 = 
MAKE_PAIR(BgL_arg4195z00_1302, BNIL); } 
SET_CDR(BgL_tail3205z00_1297, BgL_newtail3206z00_1300); 
{ /* ./Jvm/compiler.scm 387 */
obj_t BgL_arg4191z00_1301;
{ /* ./Jvm/compiler.scm 387 */
obj_t BgL_pairz00_2238;
BgL_pairz00_2238 = BgL_l3202z00_1296; 
BgL_arg4191z00_1301 = 
CDR(BgL_pairz00_2238); } 
{ 
obj_t BgL_tail3205z00_3346;obj_t BgL_l3202z00_3345;
BgL_l3202z00_3345 = BgL_arg4191z00_1301; 
BgL_tail3205z00_3346 = BgL_newtail3206z00_1300; 
BgL_tail3205z00_1297 = BgL_tail3205z00_3346; 
BgL_l3202z00_1296 = BgL_l3202z00_3345; 
goto BgL_map3203z00_1298;} } } } } 
{ /* ./Jvm/compiler.scm 387 */

{ /* ./Jvm/compiler.scm 389 */
obj_t BgL_arg4112z00_1258;
{ /* ./Jvm/compiler.scm 389 */
obj_t BgL_arg4115z00_1259;obj_t BgL_arg4116z00_1260;
BgL_arg4115z00_1259 = 
CNST_TABLE_REF(((long)32)); 
BgL_arg4116z00_1260 = 
(((BgL_variablez00_bglt)CREF(BgL_localz00_52))->BgL_namez00); 
{ /* ./Jvm/compiler.scm 389 */
obj_t BgL_list4118z00_1261;
{ /* ./Jvm/compiler.scm 389 */
obj_t BgL_arg4120z00_1262;
BgL_arg4120z00_1262 = 
MAKE_PAIR(BgL_arg4116z00_1260, BNIL); 
BgL_list4118z00_1261 = 
MAKE_PAIR(BgL_arg4115z00_1259, BgL_arg4120z00_1262); } 
BgL_arg4112z00_1258 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list4118z00_1261); } } 
BGl__labelz00zzjvm_instrz00(BgL_envz00_54, BgL_arg4112z00_1258); } 
{ 
obj_t BgL_ll3207z00_1263;obj_t BgL_ll3208z00_1264;
BgL_ll3207z00_1263 = BgL_varsz00_1257; 
BgL_ll3208z00_1264 = BgL_stkz00_1256; 
BgL_forzd2each3209zd2_1265:
if(
NULLP(BgL_ll3207z00_1263))
{ /* ./Jvm/compiler.scm 390 */((bool_t)1); }  else 
{ /* ./Jvm/compiler.scm 390 */
{ /* ./Jvm/compiler.scm 390 */
obj_t BgL_vz00_1267;obj_t BgL_tyz00_1268;
{ /* ./Jvm/compiler.scm 390 */
obj_t BgL_pairz00_2241;
BgL_pairz00_2241 = BgL_ll3207z00_1263; 
BgL_vz00_1267 = 
CAR(BgL_pairz00_2241); } 
{ /* ./Jvm/compiler.scm 390 */
obj_t BgL_pairz00_2242;
BgL_pairz00_2242 = BgL_ll3208z00_1264; 
BgL_tyz00_1268 = 
CAR(BgL_pairz00_2242); } 
BGl__store_namez00zzjvm_instrz00(BgL_envz00_54, BgL_vz00_1267, BgL_tyz00_1268); } 
{ /* ./Jvm/compiler.scm 390 */
obj_t BgL_arg4130z00_1269;obj_t BgL_arg4131z00_1270;
{ /* ./Jvm/compiler.scm 390 */
obj_t BgL_pairz00_2243;
BgL_pairz00_2243 = BgL_ll3207z00_1263; 
BgL_arg4130z00_1269 = 
CDR(BgL_pairz00_2243); } 
{ /* ./Jvm/compiler.scm 390 */
obj_t BgL_pairz00_2244;
BgL_pairz00_2244 = BgL_ll3208z00_1264; 
BgL_arg4131z00_1270 = 
CDR(BgL_pairz00_2244); } 
{ 
obj_t BgL_ll3208z00_3361;obj_t BgL_ll3207z00_3360;
BgL_ll3207z00_3360 = BgL_arg4130z00_1269; 
BgL_ll3208z00_3361 = BgL_arg4131z00_1270; 
BgL_ll3208z00_1264 = BgL_ll3208z00_3361; 
BgL_ll3207z00_1263 = BgL_ll3207z00_3360; 
goto BgL_forzd2each3209zd2_1265;} } } } 
{ /* ./Jvm/compiler.scm 393 */
obj_t BgL_arg4137z00_1271;
BgL_arg4137z00_1271 = 
(((BgL_variablez00_bglt)CREF(BgL_localz00_52))->BgL_namez00); 
BGl__labelz00zzjvm_instrz00(BgL_envz00_54, BgL_arg4137z00_1271); } 
if(
NULLP(BgL_stkz00_1256))
{ /* ./Jvm/compiler.scm 396 */
obj_t BgL_arg4142z00_1273;
{ /* ./Jvm/compiler.scm 396 */
BgL_sfunz00_bglt BgL_obj1370z00_2247;
BgL_obj1370z00_2247 = 
(BgL_sfunz00_bglt)(BgL_instance3198z00_1245); 
BgL_arg4142z00_1273 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2247))->BgL_bodyz00); } 
BGl_compilezd2tailzd2zzjvm_tailz00(
(BgL_nodez00_bglt)(BgL_arg4142z00_1273), BgL_envz00_54); }  else 
{ /* ./Jvm/compiler.scm 397 */
obj_t BgL_arg4146z00_1274;
{ /* ./Jvm/compiler.scm 397 */
BgL_sfunz00_bglt BgL_obj1370z00_2248;
BgL_obj1370z00_2248 = 
(BgL_sfunz00_bglt)(BgL_instance3198z00_1245); 
BgL_arg4146z00_1274 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2248))->BgL_bodyz00); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4146z00_1274), BgL_envz00_54); } 
if(
CBOOL(BgL_debugzf3zf3_1246))
{ /* ./Jvm/compiler.scm 398 */
BGl__labelz00zzjvm_instrz00(BgL_envz00_54, BgL_elabz00_1248); }  else 
{ /* ./Jvm/compiler.scm 398 */BFALSE; } 
if(
NULLP(BgL_stkz00_1256))
{ /* ./Jvm/compiler.scm 399 */BFALSE; }  else 
{ /* ./Jvm/compiler.scm 400 */
obj_t BgL_trz00_1276;
{ /* ./Jvm/compiler.scm 400 */
obj_t BgL_pairz00_2251;
BgL_pairz00_2251 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_54))->BgL_stackz00); 
BgL_trz00_1276 = 
CAR(BgL_pairz00_2251); } 
BGl__store_namez00zzjvm_instrz00(BgL_envz00_54, 
CNST_TABLE_REF(((long)33)), BgL_trz00_1276); 
{ 
obj_t BgL_ll3210z00_1277;obj_t BgL_ll3211z00_1278;
{ /* ./Jvm/compiler.scm 404 */
obj_t BgL_arg4154z00_1280;obj_t BgL_arg4155z00_1281;
BgL_arg4154z00_1280 = 
bgl_reverse(BgL_varsz00_1257); 
BgL_arg4155z00_1281 = 
bgl_reverse(BgL_stkz00_1256); 
BgL_ll3210z00_1277 = BgL_arg4154z00_1280; 
BgL_ll3211z00_1278 = BgL_arg4155z00_1281; 
BgL_forzd2each3212zd2_1279:
if(
NULLP(BgL_ll3210z00_1277))
{ /* ./Jvm/compiler.scm 403 */((bool_t)1); }  else 
{ /* ./Jvm/compiler.scm 403 */
{ /* ./Jvm/compiler.scm 403 */
obj_t BgL_vz00_1283;obj_t BgL_tyz00_1284;
{ /* ./Jvm/compiler.scm 403 */
obj_t BgL_pairz00_2253;
BgL_pairz00_2253 = BgL_ll3210z00_1277; 
BgL_vz00_1283 = 
CAR(BgL_pairz00_2253); } 
{ /* ./Jvm/compiler.scm 403 */
obj_t BgL_pairz00_2254;
BgL_pairz00_2254 = BgL_ll3211z00_1278; 
BgL_tyz00_1284 = 
CAR(BgL_pairz00_2254); } 
BGl__load_namez00zzjvm_instrz00(BgL_envz00_54, BgL_vz00_1283, BgL_tyz00_1284); } 
{ /* ./Jvm/compiler.scm 403 */
obj_t BgL_arg4164z00_1285;obj_t BgL_arg4165z00_1286;
{ /* ./Jvm/compiler.scm 403 */
obj_t BgL_pairz00_2255;
BgL_pairz00_2255 = BgL_ll3210z00_1277; 
BgL_arg4164z00_1285 = 
CDR(BgL_pairz00_2255); } 
{ /* ./Jvm/compiler.scm 403 */
obj_t BgL_pairz00_2256;
BgL_pairz00_2256 = BgL_ll3211z00_1278; 
BgL_arg4165z00_1286 = 
CDR(BgL_pairz00_2256); } 
{ 
obj_t BgL_ll3211z00_3393;obj_t BgL_ll3210z00_3392;
BgL_ll3210z00_3392 = BgL_arg4164z00_1285; 
BgL_ll3211z00_3393 = BgL_arg4165z00_1286; 
BgL_ll3211z00_1278 = BgL_ll3211z00_3393; 
BgL_ll3210z00_1277 = BgL_ll3210z00_3392; 
goto BgL_forzd2each3212zd2_1279;} } } } } 
BGl__load_namez00zzjvm_instrz00(BgL_envz00_54, 
CNST_TABLE_REF(((long)33)), BgL_trz00_1276); } 
{ 
obj_t BgL_l3213z00_1288;
{ /* ./Jvm/compiler.scm 407 */
bool_t BgL_auxz00_3396;
BgL_l3213z00_1288 = BgL_stkz00_1256; 
BgL_forzd2each3214zd2_1289:
if(
PAIRP(BgL_l3213z00_1288))
{ /* ./Jvm/compiler.scm 407 */
{ /* ./Jvm/compiler.scm 407 */
obj_t BgL_tyz00_1291;
{ /* ./Jvm/compiler.scm 407 */
obj_t BgL_pairz00_2258;
BgL_pairz00_2258 = BgL_l3213z00_1288; 
BgL_tyz00_1291 = 
CAR(BgL_pairz00_2258); } 
BGl_envzd2freezd2localz00zzjvm_envz00(BgL_envz00_54, BgL_tyz00_1291); } 
{ /* ./Jvm/compiler.scm 407 */
obj_t BgL_arg4181z00_1292;
{ /* ./Jvm/compiler.scm 407 */
obj_t BgL_pairz00_2259;
BgL_pairz00_2259 = BgL_l3213z00_1288; 
BgL_arg4181z00_1292 = 
CDR(BgL_pairz00_2259); } 
{ 
obj_t BgL_l3213z00_3402;
BgL_l3213z00_3402 = BgL_arg4181z00_1292; 
BgL_l3213z00_1288 = BgL_l3213z00_3402; 
goto BgL_forzd2each3214zd2_1289;} } }  else 
{ /* ./Jvm/compiler.scm 407 */
BgL_auxz00_3396 = ((bool_t)1)
; } 
return 
BBOOL(BgL_auxz00_3396);} } } } } } } } } } } 
}



/* compiler-app */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2appzd2zzjvm_compilerz00(BgL_appz00_bglt BgL_ez00_55, BgL_envz00_bglt BgL_envz00_56)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 410 */
{ /* ./Jvm/compiler.scm 411 */
obj_t BgL_nz00_2262;
BgL_nz00_2262 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_55)); 
if(
CBOOL(BgL_nz00_2262))
{ /* ./Jvm/compiler.scm 411 */
BGl__linez00zzjvm_instrz00(BgL_envz00_56, BgL_nz00_2262); }  else 
{ /* ./Jvm/compiler.scm 411 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 413 */
BgL_variablez00_bglt BgL_vz00_1306;
{ /* ./Jvm/compiler.scm 413 */
BgL_varz00_bglt BgL_obj1625z00_2264;
BgL_obj1625z00_2264 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_55))->BgL_funz00); 
BgL_vz00_1306 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2264))->BgL_variablez00); } 
{ /* ./Jvm/compiler.scm 414 */
bool_t BgL_testz00_3412;
{ /* ./Jvm/compiler.scm 414 */
obj_t BgL_obj1300z00_2265;
BgL_obj1300z00_2265 = 
(obj_t)(BgL_vz00_1306); 
BgL_testz00_3412 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1300z00_2265, BGl_localz00zzast_varz00); } 
if(BgL_testz00_3412)
{ /* ./Jvm/compiler.scm 415 */
obj_t BgL_arg4212z00_1308;
BgL_arg4212z00_1308 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_55))->BgL_argsz00); 
return 
BGl_compilezd2labelzd2callz00zzjvm_compilerz00(BgL_vz00_1306, BgL_arg4212z00_1308, BgL_envz00_56);}  else 
{ /* ./Jvm/compiler.scm 416 */
bool_t BgL_testz00_3417;
{ /* ./Jvm/compiler.scm 416 */
obj_t BgL_arg4240z00_1323;
BgL_arg4240z00_1323 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_55))->BgL_argsz00); 
BgL_testz00_3417 = 
CBOOL(
BGl_specialzd2callzf3z21zzjvm_compilerz00(BgL_vz00_1306, BgL_arg4240z00_1323, BgL_envz00_56)); } 
if(BgL_testz00_3417)
{ /* ./Jvm/compiler.scm 416 */
return 
CNST_TABLE_REF(((long)34));}  else 
{ /* ./Jvm/compiler.scm 417 */
obj_t BgL__ortest_3217z00_1310;
{ /* ./Jvm/compiler.scm 417 */
obj_t BgL_arg4236z00_1322;
BgL_arg4236z00_1322 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_55))->BgL_argsz00); 
BgL__ortest_3217z00_1310 = 
PROCEDURE_ENTRY(BGl_specialzd2inlinezd2callzf3zf3zzjvm_inlinez00)(BGl_specialzd2inlinezd2callzf3zf3zzjvm_inlinez00, 
(obj_t)(BgL_vz00_1306), BgL_arg4236z00_1322, 
(obj_t)(BgL_envz00_56), BEOA); } 
if(
CBOOL(BgL__ortest_3217z00_1310))
{ /* ./Jvm/compiler.scm 417 */
return BgL__ortest_3217z00_1310;}  else 
{ /* ./Jvm/compiler.scm 419 */
obj_t BgL_typesz00_1311;
BgL_typesz00_1311 = 
BGl_typezd2argszd2zzjvm_compilerz00(BgL_vz00_1306, BgL_envz00_56); 
{ 
obj_t BgL_ll3218z00_1312;obj_t BgL_ll3219z00_1313;
{ /* ./Jvm/compiler.scm 420 */
obj_t BgL_arg4217z00_1315;
BgL_arg4217z00_1315 = 
(((BgL_appz00_bglt)CREF(BgL_ez00_55))->BgL_argsz00); 
BgL_ll3218z00_1312 = BgL_arg4217z00_1315; 
BgL_ll3219z00_1313 = BgL_typesz00_1311; 
BgL_forzd2each3220zd2_1314:
if(
NULLP(BgL_ll3218z00_1312))
{ /* ./Jvm/compiler.scm 420 */((bool_t)1); }  else 
{ /* ./Jvm/compiler.scm 420 */
{ /* ./Jvm/compiler.scm 421 */
obj_t BgL_ez00_1317;obj_t BgL_tyz00_1318;
{ /* ./Jvm/compiler.scm 421 */
obj_t BgL_pairz00_2271;
BgL_pairz00_2271 = BgL_ll3218z00_1312; 
BgL_ez00_1317 = 
CAR(BgL_pairz00_2271); } 
{ /* ./Jvm/compiler.scm 421 */
obj_t BgL_pairz00_2272;
BgL_pairz00_2272 = BgL_ll3219z00_1313; 
BgL_tyz00_1318 = 
CAR(BgL_pairz00_2272); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_ez00_1317), BgL_envz00_56); 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 422 */
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_56, BgL_tyz00_1318); }  else 
{ /* ./Jvm/compiler.scm 422 */BFALSE; } } 
{ /* ./Jvm/compiler.scm 420 */
obj_t BgL_arg4226z00_1319;obj_t BgL_arg4227z00_1320;
{ /* ./Jvm/compiler.scm 420 */
obj_t BgL_pairz00_2273;
BgL_pairz00_2273 = BgL_ll3218z00_1312; 
BgL_arg4226z00_1319 = 
CDR(BgL_pairz00_2273); } 
{ /* ./Jvm/compiler.scm 420 */
obj_t BgL_pairz00_2274;
BgL_pairz00_2274 = BgL_ll3219z00_1313; 
BgL_arg4227z00_1320 = 
CDR(BgL_pairz00_2274); } 
{ 
obj_t BgL_ll3219z00_3443;obj_t BgL_ll3218z00_3442;
BgL_ll3218z00_3442 = BgL_arg4226z00_1319; 
BgL_ll3219z00_3443 = BgL_arg4227z00_1320; 
BgL_ll3219z00_1313 = BgL_ll3219z00_3443; 
BgL_ll3218z00_1312 = BgL_ll3218z00_3442; 
goto BgL_forzd2each3220zd2_1314;} } } } } 
{ /* ./Jvm/compiler.scm 425 */
obj_t BgL__ortest_3221z00_1321;
BgL__ortest_3221z00_1321 = 
PROCEDURE_ENTRY(BGl_inlinezd2callzf3z21zzjvm_inlinez00)(BGl_inlinezd2callzf3z21zzjvm_inlinez00, 
(obj_t)(BgL_vz00_1306), 
(obj_t)(BgL_envz00_56), BEOA); 
if(
CBOOL(BgL__ortest_3221z00_1321))
{ /* ./Jvm/compiler.scm 425 */
return BgL__ortest_3221z00_1321;}  else 
{ /* ./Jvm/compiler.scm 425 */
return 
BGl_howzd2tozd2callz00zzjvm_compilerz00(BgL_envz00_56, BgL_vz00_1306, BgL_typesz00_1311);} } } } } } } } 
}



/* _compiler-app5427 */
obj_t BGl__compilerzd2app5427zd2zzjvm_compilerz00(obj_t BgL_envz00_2543, obj_t BgL_ez00_2544, obj_t BgL_envz00_2545)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 410 */
return 
BGl_compilerzd2appzd2zzjvm_compilerz00(
(BgL_appz00_bglt)(BgL_ez00_2544), 
(BgL_envz00_bglt)(BgL_envz00_2545));} 
}



/* type-args */
obj_t BGl_typezd2argszd2zzjvm_compilerz00(BgL_variablez00_bglt BgL_vz00_57, BgL_envz00_bglt BgL_envz00_58)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 428 */
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_l3224z00_1326;
{ /* ./Jvm/compiler.scm 431 */
bool_t BgL_testz00_3454;
{ /* ./Jvm/compiler.scm 431 */
BgL_valuez00_bglt BgL_arg4276z00_1341;
BgL_arg4276z00_1341 = 
(((BgL_variablez00_bglt)CREF(BgL_vz00_57))->BgL_valuez00); 
{ /* ./Jvm/compiler.scm 431 */
obj_t BgL_obj1425z00_2276;
BgL_obj1425z00_2276 = 
(obj_t)(BgL_arg4276z00_1341); 
BgL_testz00_3454 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1425z00_2276, BGl_sfunz00zzast_varz00); } } 
if(BgL_testz00_3454)
{ /* ./Jvm/compiler.scm 432 */
BgL_sfunz00_bglt BgL_obj1367z00_2278;
{ /* ./Jvm/compiler.scm 432 */
BgL_valuez00_bglt BgL_auxz00_3458;
BgL_auxz00_3458 = 
(((BgL_variablez00_bglt)CREF(BgL_vz00_57))->BgL_valuez00); 
BgL_obj1367z00_2278 = 
(BgL_sfunz00_bglt)(BgL_auxz00_3458); } 
BgL_l3224z00_1326 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1367z00_2278))->BgL_argsz00); }  else 
{ /* ./Jvm/compiler.scm 433 */
BgL_cfunz00_bglt BgL_obj1445z00_2280;
{ /* ./Jvm/compiler.scm 433 */
BgL_valuez00_bglt BgL_auxz00_3462;
BgL_auxz00_3462 = 
(((BgL_variablez00_bglt)CREF(BgL_vz00_57))->BgL_valuez00); 
BgL_obj1445z00_2280 = 
(BgL_cfunz00_bglt)(BgL_auxz00_3462); } 
BgL_l3224z00_1326 = 
(((BgL_cfunz00_bglt)CREF(BgL_obj1445z00_2280))->BgL_argszd2typezd2); } } 
if(
NULLP(BgL_l3224z00_1326))
{ /* ./Jvm/compiler.scm 430 */
return BNIL;}  else 
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_head3226z00_1328;
BgL_head3226z00_1328 = 
MAKE_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l3224z00_1329;obj_t BgL_tail3227z00_1330;
BgL_l3224z00_1329 = BgL_l3224z00_1326; 
BgL_tail3227z00_1330 = BgL_head3226z00_1328; 
BgL_map3225z00_1331:
if(
NULLP(BgL_l3224z00_1329))
{ /* ./Jvm/compiler.scm 430 */
return 
CDR(BgL_head3226z00_1328);}  else 
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_newtail3228z00_1333;
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_arg4258z00_1335;
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_xz00_1337;
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_pairz00_2286;
BgL_pairz00_2286 = BgL_l3224z00_1329; 
BgL_xz00_1337 = 
CAR(BgL_pairz00_2286); } 
BgL_arg4258z00_1335 = 
BGl_compilezd2typezd2zzjvm_envz00(BgL_xz00_1337, BgL_envz00_58); } 
BgL_newtail3228z00_1333 = 
MAKE_PAIR(BgL_arg4258z00_1335, BNIL); } 
SET_CDR(BgL_tail3227z00_1330, BgL_newtail3228z00_1333); 
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_arg4254z00_1334;
{ /* ./Jvm/compiler.scm 430 */
obj_t BgL_pairz00_2291;
BgL_pairz00_2291 = BgL_l3224z00_1329; 
BgL_arg4254z00_1334 = 
CDR(BgL_pairz00_2291); } 
{ 
obj_t BgL_tail3227z00_3478;obj_t BgL_l3224z00_3477;
BgL_l3224z00_3477 = BgL_arg4254z00_1334; 
BgL_tail3227z00_3478 = BgL_newtail3228z00_1333; 
BgL_tail3227z00_1330 = BgL_tail3227z00_3478; 
BgL_l3224z00_1329 = BgL_l3224z00_3477; 
goto BgL_map3225z00_1331;} } } } } } } 
}



/* how-to-call */
obj_t BGl_howzd2tozd2callz00zzjvm_compilerz00(BgL_envz00_bglt BgL_envz00_59, BgL_variablez00_bglt BgL_varz00_60, obj_t BgL_taz00_61)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 435 */
{ /* ./Jvm/compiler.scm 436 */
BgL_valuez00_bglt BgL_funz00_1342;obj_t BgL_targetz00_1343;obj_t BgL_trz00_1344;
BgL_funz00_1342 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_60))->BgL_valuez00); 
BgL_targetz00_1343 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_59, 
(BgL_globalz00_bglt)(BgL_varz00_60)); 
{ /* ./Jvm/compiler.scm 438 */
BgL_typez00_bglt BgL_arg4306z00_1354;
BgL_arg4306z00_1354 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_60))->BgL_typez00); 
BgL_trz00_1344 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4306z00_1354), BgL_envz00_59); } 
{ /* ./Jvm/compiler.scm 440 */
bool_t BgL_testz00_3485;
{ /* ./Jvm/compiler.scm 440 */
obj_t BgL_obj1489z00_2294;
BgL_obj1489z00_2294 = 
(obj_t)(BgL_funz00_1342); 
BgL_testz00_3485 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1489z00_2294, BGl_cfunz00zzast_varz00); } 
if(BgL_testz00_3485)
{ /* ./Jvm/compiler.scm 441 */
bool_t BgL_testz00_3488;
{ /* ./Jvm/compiler.scm 441 */
obj_t BgL_arg4297z00_1352;
BgL_arg4297z00_1352 = 
(((BgL_variablez00_bglt)CREF(BgL_varz00_60))->BgL_namez00); 
{ /* ./Jvm/compiler.scm 441 */
obj_t BgL_string1z00_2296;
BgL_string1z00_2296 = BgL_arg4297z00_1352; 
BgL_testz00_3488 = 
bigloo_strcmp(BgL_string1z00_2296, BGl_string5875z00zzjvm_compilerz00); } } 
if(BgL_testz00_3488)
{ /* ./Jvm/compiler.scm 441 */
return 
BGl__invokespecial_initz00zzjvm_instrz00(BgL_envz00_59, BgL_targetz00_1343, BgL_taz00_61, BgL_trz00_1344);}  else 
{ /* ./Jvm/compiler.scm 444 */
obj_t BgL_modifiersz00_1347;
{ /* ./Jvm/compiler.scm 444 */
BgL_cfunz00_bglt BgL_obj1450z00_2298;
BgL_obj1450z00_2298 = 
(BgL_cfunz00_bglt)(BgL_funz00_1342); 
BgL_modifiersz00_1347 = 
(((BgL_cfunz00_bglt)CREF(BgL_obj1450z00_2298))->BgL_methodz00); } 
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)35)), BgL_modifiersz00_1347)))
{ /* ./Jvm/compiler.scm 446 */
return 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_59, BgL_targetz00_1343, BgL_taz00_61, BgL_trz00_1344);}  else 
{ /* ./Jvm/compiler.scm 446 */
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)36)), BgL_modifiersz00_1347)))
{ /* ./Jvm/compiler.scm 447 */
return 
BGl__invokeinterfacez00zzjvm_instrz00(BgL_envz00_59, BgL_targetz00_1343, BgL_taz00_61, BgL_trz00_1344);}  else 
{ /* ./Jvm/compiler.scm 447 */
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)37)), BgL_modifiersz00_1347)))
{ /* ./Jvm/compiler.scm 448 */
return 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_59, BgL_targetz00_1343, BgL_taz00_61, BgL_trz00_1344);}  else 
{ /* ./Jvm/compiler.scm 448 */
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)38)), BgL_modifiersz00_1347)))
{ /* ./Jvm/compiler.scm 449 */
return 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_59, BgL_targetz00_1343, BgL_taz00_61, BgL_trz00_1344);}  else 
{ /* ./Jvm/compiler.scm 449 */
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_59, BgL_targetz00_1343, BgL_taz00_61, BgL_trz00_1344);} } } } } }  else 
{ /* ./Jvm/compiler.scm 440 */
return 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_59, BgL_targetz00_1343, BgL_taz00_61, BgL_trz00_1344);} } } } 
}



/* special-call? */
obj_t BGl_specialzd2callzf3z21zzjvm_compilerz00(BgL_variablez00_bglt BgL_varz00_62, obj_t BgL_argsz00_63, BgL_envz00_bglt BgL_envz00_64)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 452 */
{ /* ./Jvm/compiler.scm 456 */
bool_t BgL_testz00_3516;
if(
(
(((BgL_variablez00_bglt)CREF(BgL_varz00_62))->BgL_idz00)==
CNST_TABLE_REF(((long)39))))
{ /* ./Jvm/compiler.scm 456 */
BgL_testz00_3516 = ((bool_t)1)
; }  else 
{ /* ./Jvm/compiler.scm 456 */
BgL_testz00_3516 = 
(
(((BgL_variablez00_bglt)CREF(BgL_varz00_62))->BgL_idz00)==
CNST_TABLE_REF(((long)40)))
; } 
if(BgL_testz00_3516)
{ /* ./Jvm/compiler.scm 456 */
{ /* ./Jvm/compiler.scm 459 */
obj_t BgL_arg4311z00_1357;
BgL_arg4311z00_1357 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_64))->BgL_currentzd2modulezd2); 
BGl__newz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4311z00_1357); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 460 */
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)41)), 
CNST_TABLE_REF(((long)42)), 
CNST_TABLE_REF(((long)25))); }  else 
{ /* ./Jvm/compiler.scm 460 */BFALSE; } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
{ /* ./Jvm/compiler.scm 464 */
obj_t BgL_arg4318z00_1358;
{ /* ./Jvm/compiler.scm 464 */
obj_t BgL_pairz00_2302;
BgL_pairz00_2302 = BgL_argsz00_63; 
BgL_arg4318z00_1358 = 
CAR(BgL_pairz00_2302); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4318z00_1358), BgL_envz00_64); } 
{ /* ./Jvm/compiler.scm 465 */
obj_t BgL_arg4322z00_1359;
BgL_arg4322z00_1359 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)43))); 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4322z00_1359); } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
{ /* ./Jvm/compiler.scm 467 */
obj_t BgL_arg4327z00_1360;
{ /* ./Jvm/compiler.scm 467 */
obj_t BgL_pairz00_2303;
BgL_pairz00_2303 = BgL_argsz00_63; 
{ /* ./Jvm/compiler.scm 467 */
obj_t BgL_pairz00_2306;
BgL_pairz00_2306 = 
CDR(BgL_pairz00_2303); 
BgL_arg4327z00_1360 = 
CAR(BgL_pairz00_2306); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4327z00_1360), BgL_envz00_64); } 
{ /* ./Jvm/compiler.scm 468 */
obj_t BgL_arg4331z00_1361;
BgL_arg4331z00_1361 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)44))); 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4331z00_1361); } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
{ /* ./Jvm/compiler.scm 470 */
obj_t BgL_arg4336z00_1362;
{ /* ./Jvm/compiler.scm 470 */
obj_t BgL_pairz00_2307;
BgL_pairz00_2307 = BgL_argsz00_63; 
{ /* ./Jvm/compiler.scm 470 */
obj_t BgL_pairz00_2312;
{ /* ./Jvm/compiler.scm 470 */
obj_t BgL_pairz00_2311;
BgL_pairz00_2311 = 
CDR(BgL_pairz00_2307); 
BgL_pairz00_2312 = 
CDR(BgL_pairz00_2311); } 
BgL_arg4336z00_1362 = 
CAR(BgL_pairz00_2312); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4336z00_1362), BgL_envz00_64); } 
{ /* ./Jvm/compiler.scm 471 */
obj_t BgL_arg4340z00_1363;
BgL_arg4340z00_1363 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)45))); 
BGl__newarrayz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4340z00_1363); } 
{ /* ./Jvm/compiler.scm 472 */
obj_t BgL_arg4344z00_1364;
BgL_arg4344z00_1364 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)46))); 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4344z00_1364); } 
return BTRUE;}  else 
{ /* ./Jvm/compiler.scm 456 */
if(
(
(((BgL_variablez00_bglt)CREF(BgL_varz00_62))->BgL_idz00)==
CNST_TABLE_REF(((long)47))))
{ /* ./Jvm/compiler.scm 474 */
{ /* ./Jvm/compiler.scm 476 */
obj_t BgL_arg4349z00_1366;
BgL_arg4349z00_1366 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_64))->BgL_currentzd2modulezd2); 
BGl__newz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4349z00_1366); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 477 */
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)41)), 
CNST_TABLE_REF(((long)42)), 
CNST_TABLE_REF(((long)25))); }  else 
{ /* ./Jvm/compiler.scm 477 */BFALSE; } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
{ /* ./Jvm/compiler.scm 481 */
obj_t BgL_arg4356z00_1367;
{ /* ./Jvm/compiler.scm 481 */
obj_t BgL_pairz00_2315;
BgL_pairz00_2315 = BgL_argsz00_63; 
BgL_arg4356z00_1367 = 
CAR(BgL_pairz00_2315); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4356z00_1367), BgL_envz00_64); } 
{ /* ./Jvm/compiler.scm 482 */
obj_t BgL_arg4360z00_1368;
BgL_arg4360z00_1368 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)43))); 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4360z00_1368); } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
{ /* ./Jvm/compiler.scm 484 */
obj_t BgL_arg4365z00_1369;
{ /* ./Jvm/compiler.scm 484 */
obj_t BgL_pairz00_2316;
BgL_pairz00_2316 = BgL_argsz00_63; 
{ /* ./Jvm/compiler.scm 484 */
obj_t BgL_pairz00_2319;
BgL_pairz00_2319 = 
CDR(BgL_pairz00_2316); 
BgL_arg4365z00_1369 = 
CAR(BgL_pairz00_2319); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4365z00_1369), BgL_envz00_64); } 
{ /* ./Jvm/compiler.scm 485 */
obj_t BgL_arg4369z00_1370;
BgL_arg4369z00_1370 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)45))); 
BGl__newarrayz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4369z00_1370); } 
{ /* ./Jvm/compiler.scm 486 */
obj_t BgL_arg4373z00_1371;
BgL_arg4373z00_1371 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)46))); 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4373z00_1371); } 
return BTRUE;}  else 
{ /* ./Jvm/compiler.scm 474 */
if(
(
(((BgL_variablez00_bglt)CREF(BgL_varz00_62))->BgL_idz00)==
CNST_TABLE_REF(((long)48))))
{ /* ./Jvm/compiler.scm 488 */
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)49))); 
{ /* ./Jvm/compiler.scm 491 */
obj_t BgL_arg4379z00_1373;
{ /* ./Jvm/compiler.scm 491 */
obj_t BgL_pairz00_2321;
BgL_pairz00_2321 = BgL_argsz00_63; 
BgL_arg4379z00_1373 = 
CAR(BgL_pairz00_2321); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4379z00_1373), BgL_envz00_64); } 
return 
BGl__aloadz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)45)));}  else 
{ /* ./Jvm/compiler.scm 488 */
if(
(
(((BgL_variablez00_bglt)CREF(BgL_varz00_62))->BgL_idz00)==
CNST_TABLE_REF(((long)50))))
{ /* ./Jvm/compiler.scm 493 */
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)49))); 
{ /* ./Jvm/compiler.scm 496 */
obj_t BgL_arg4386z00_1375;
{ /* ./Jvm/compiler.scm 496 */
obj_t BgL_pairz00_2323;
BgL_pairz00_2323 = BgL_argsz00_63; 
BgL_arg4386z00_1375 = 
CAR(BgL_pairz00_2323); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4386z00_1375), BgL_envz00_64); } 
{ /* ./Jvm/compiler.scm 497 */
obj_t BgL_arg4390z00_1376;
{ /* ./Jvm/compiler.scm 497 */
obj_t BgL_pairz00_2324;
BgL_pairz00_2324 = BgL_argsz00_63; 
{ /* ./Jvm/compiler.scm 497 */
obj_t BgL_pairz00_2327;
BgL_pairz00_2327 = 
CDR(BgL_pairz00_2324); 
BgL_arg4390z00_1376 = 
CAR(BgL_pairz00_2327); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4390z00_1376), BgL_envz00_64); } 
BGl__astorez00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)45))); 
{ /* ./Jvm/compiler.scm 499 */
obj_t BgL_arg4395z00_1377;
BgL_arg4395z00_1377 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)20))); 
return 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4395z00_1377);} }  else 
{ /* ./Jvm/compiler.scm 493 */
if(
(
(((BgL_variablez00_bglt)CREF(BgL_varz00_62))->BgL_idz00)==
CNST_TABLE_REF(((long)51))))
{ /* ./Jvm/compiler.scm 502 */
bool_t BgL_testz00_3624;
{ /* ./Jvm/compiler.scm 502 */
obj_t BgL_arg4431z00_1390;
{ /* ./Jvm/compiler.scm 502 */
obj_t BgL_pairz00_2329;
BgL_pairz00_2329 = BgL_argsz00_63; 
BgL_arg4431z00_1390 = 
CAR(BgL_pairz00_2329); } 
BgL_testz00_3624 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg4431z00_1390, BGl_varz00zzast_nodez00); } 
if(BgL_testz00_3624)
{ /* ./Jvm/compiler.scm 504 */
BgL_variablez00_bglt BgL_vz00_1380;
{ /* ./Jvm/compiler.scm 504 */
BgL_varz00_bglt BgL_obj1625z00_2332;
{ /* ./Jvm/compiler.scm 504 */
obj_t BgL_pairz00_2331;
BgL_pairz00_2331 = BgL_argsz00_63; 
{ /* ./Jvm/compiler.scm 504 */
obj_t BgL_auxz00_3627;
BgL_auxz00_3627 = 
CAR(BgL_pairz00_2331); 
BgL_obj1625z00_2332 = 
(BgL_varz00_bglt)(BgL_auxz00_3627); } } 
BgL_vz00_1380 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2332))->BgL_variablez00); } 
{ /* ./Jvm/compiler.scm 505 */
bool_t BgL_testz00_3631;
{ /* ./Jvm/compiler.scm 505 */
obj_t BgL_obj1240z00_2333;
BgL_obj1240z00_2333 = 
(obj_t)(BgL_vz00_1380); 
BgL_testz00_3631 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1240z00_2333, BGl_globalz00zzast_varz00); } 
if(BgL_testz00_3631)
{ /* ./Jvm/compiler.scm 506 */
obj_t BgL_iz00_1382;
{ /* ./Jvm/compiler.scm 506 */
obj_t BgL_arg4415z00_1385;
BgL_arg4415z00_1385 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_64, 
(BgL_globalz00_bglt)(BgL_vz00_1380)); 
BgL_iz00_1382 = 
BGl_envzd2newzd2getsetz00zzjvm_envz00(BgL_envz00_64, BgL_arg4415z00_1385); } 
{ /* ./Jvm/compiler.scm 507 */
obj_t BgL_arg4402z00_1383;
BgL_arg4402z00_1383 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_64))->BgL_currentzd2modulezd2); 
BGl__newz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4402z00_1383); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 508 */
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)41)), 
CNST_TABLE_REF(((long)42)), 
CNST_TABLE_REF(((long)25))); }  else 
{ /* ./Jvm/compiler.scm 508 */BFALSE; } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_64); 
BGl__pushz00zzjvm_instrz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)9)), BgL_iz00_1382); 
{ /* ./Jvm/compiler.scm 513 */
obj_t BgL_arg4410z00_1384;
BgL_arg4410z00_1384 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_64, 
CNST_TABLE_REF(((long)43))); 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_64, BgL_arg4410z00_1384); } 
return BTRUE;}  else 
{ /* ./Jvm/compiler.scm 515 */
obj_t BgL_objectz00_2337;
BgL_objectz00_2337 = 
(obj_t)(BgL_vz00_1380); 
FAILURE(BGl_string5876z00zzjvm_compilerz00,BGl_string5877z00zzjvm_compilerz00,BgL_objectz00_2337);} } }  else 
{ /* ./Jvm/compiler.scm 503 */
obj_t BgL_arg4427z00_1389;
{ /* ./Jvm/compiler.scm 503 */
obj_t BgL_pairz00_2338;
BgL_pairz00_2338 = BgL_argsz00_63; 
BgL_arg4427z00_1389 = 
CAR(BgL_pairz00_2338); } 
FAILURE(BGl_string5876z00zzjvm_compilerz00,BGl_string5878z00zzjvm_compilerz00,BgL_arg4427z00_1389);} }  else 
{ /* ./Jvm/compiler.scm 500 */
return BFALSE;} } } } } } } 
}



/* compiler-apply */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2applyzd2zzjvm_compilerz00(BgL_appzd2lyzd2_bglt BgL_ez00_65, BgL_envz00_bglt BgL_envz00_66)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 519 */
{ /* ./Jvm/compiler.scm 520 */
obj_t BgL_nz00_2344;
BgL_nz00_2344 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_65)); 
if(
CBOOL(BgL_nz00_2344))
{ /* ./Jvm/compiler.scm 520 */
BGl__linez00zzjvm_instrz00(BgL_envz00_66, BgL_nz00_2344); }  else 
{ /* ./Jvm/compiler.scm 520 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 522 */
BgL_nodez00_bglt BgL_arg4467z00_1405;
BgL_arg4467z00_1405 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_ez00_65))->BgL_funz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4467z00_1405, BgL_envz00_66); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 523 */
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_66, 
CNST_TABLE_REF(((long)52))); }  else 
{ /* ./Jvm/compiler.scm 523 */BFALSE; } 
{ /* ./Jvm/compiler.scm 524 */
BgL_nodez00_bglt BgL_arg4472z00_1406;
BgL_arg4472z00_1406 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_ez00_65))->BgL_argz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4472z00_1406, BgL_envz00_66); } 
{ /* ./Jvm/compiler.scm 525 */
obj_t BgL_arg4476z00_1407;obj_t BgL_arg4477z00_1408;obj_t BgL_arg4478z00_1409;
BgL_arg4476z00_1407 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_66, 
CNST_TABLE_REF(((long)53))); 
BgL_arg4477z00_1408 = 
CNST_TABLE_REF(((long)54)); 
BgL_arg4478z00_1409 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_66, BgL_arg4476z00_1407, BgL_arg4477z00_1408, BgL_arg4478z00_1409);} } 
}



/* _compiler-apply5429 */
obj_t BGl__compilerzd2apply5429zd2zzjvm_compilerz00(obj_t BgL_envz00_2546, obj_t BgL_ez00_2547, obj_t BgL_envz00_2548)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 519 */
return 
BGl_compilerzd2applyzd2zzjvm_compilerz00(
(BgL_appzd2lyzd2_bglt)(BgL_ez00_2547), 
(BgL_envz00_bglt)(BgL_envz00_2548));} 
}



/* compiler-funcall */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2funcallzd2zzjvm_compilerz00(BgL_funcallz00_bglt BgL_ez00_67, BgL_envz00_bglt BgL_envz00_68)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 528 */
{ /* ./Jvm/compiler.scm 529 */
obj_t BgL_nz00_2349;
BgL_nz00_2349 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_67)); 
if(
CBOOL(BgL_nz00_2349))
{ /* ./Jvm/compiler.scm 529 */
BGl__linez00zzjvm_instrz00(BgL_envz00_68, BgL_nz00_2349); }  else 
{ /* ./Jvm/compiler.scm 529 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 533 */
bool_t BgL_testz00_3684;
{ /* ./Jvm/compiler.scm 533 */
bool_t BgL_testz00_3685;
{ /* ./Jvm/compiler.scm 533 */
BgL_nodez00_bglt BgL_arg4622z00_1472;
BgL_arg4622z00_1472 = 
(((BgL_funcallz00_bglt)CREF(BgL_ez00_67))->BgL_funz00); 
{ /* ./Jvm/compiler.scm 533 */
obj_t BgL_obj1640z00_2351;
BgL_obj1640z00_2351 = 
(obj_t)(BgL_arg4622z00_1472); 
BgL_testz00_3685 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1640z00_2351, BGl_varz00zzast_nodez00); } } 
if(BgL_testz00_3685)
{ /* ./Jvm/compiler.scm 534 */
bool_t BgL_testz00_3689;
{ /* ./Jvm/compiler.scm 534 */
BgL_variablez00_bglt BgL_arg4615z00_1470;
{ /* ./Jvm/compiler.scm 534 */
BgL_varz00_bglt BgL_obj1625z00_2353;
{ /* ./Jvm/compiler.scm 534 */
BgL_nodez00_bglt BgL_auxz00_3690;
BgL_auxz00_3690 = 
(((BgL_funcallz00_bglt)CREF(BgL_ez00_67))->BgL_funz00); 
BgL_obj1625z00_2353 = 
(BgL_varz00_bglt)(BgL_auxz00_3690); } 
BgL_arg4615z00_1470 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2353))->BgL_variablez00); } 
{ /* ./Jvm/compiler.scm 534 */
obj_t BgL_obj1240z00_2354;
BgL_obj1240z00_2354 = 
(obj_t)(BgL_arg4615z00_1470); 
BgL_testz00_3689 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1240z00_2354, BGl_globalz00zzast_varz00); } } 
if(BgL_testz00_3689)
{ /* ./Jvm/compiler.scm 535 */
BgL_valuez00_bglt BgL_arg4605z00_1467;
{ /* ./Jvm/compiler.scm 535 */
BgL_variablez00_bglt BgL_arg4608z00_1468;
{ /* ./Jvm/compiler.scm 535 */
BgL_varz00_bglt BgL_obj1625z00_2356;
{ /* ./Jvm/compiler.scm 535 */
BgL_nodez00_bglt BgL_auxz00_3696;
BgL_auxz00_3696 = 
(((BgL_funcallz00_bglt)CREF(BgL_ez00_67))->BgL_funz00); 
BgL_obj1625z00_2356 = 
(BgL_varz00_bglt)(BgL_auxz00_3696); } 
BgL_arg4608z00_1468 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2356))->BgL_variablez00); } 
BgL_arg4605z00_1467 = 
(((BgL_variablez00_bglt)CREF(BgL_arg4608z00_1468))->BgL_valuez00); } 
{ /* ./Jvm/compiler.scm 535 */
obj_t BgL_obj1425z00_2358;
BgL_obj1425z00_2358 = 
(obj_t)(BgL_arg4605z00_1467); 
BgL_testz00_3684 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj1425z00_2358, BGl_sfunz00zzast_varz00); } }  else 
{ /* ./Jvm/compiler.scm 534 */
BgL_testz00_3684 = ((bool_t)0)
; } }  else 
{ /* ./Jvm/compiler.scm 533 */
BgL_testz00_3684 = ((bool_t)0)
; } } 
if(BgL_testz00_3684)
{ /* ./Jvm/compiler.scm 536 */
BgL_variablez00_bglt BgL_vz00_1412;
{ /* ./Jvm/compiler.scm 536 */
BgL_varz00_bglt BgL_obj1625z00_2360;
{ /* ./Jvm/compiler.scm 536 */
BgL_nodez00_bglt BgL_auxz00_3703;
BgL_auxz00_3703 = 
(((BgL_funcallz00_bglt)CREF(BgL_ez00_67))->BgL_funz00); 
BgL_obj1625z00_2360 = 
(BgL_varz00_bglt)(BgL_auxz00_3703); } 
BgL_vz00_1412 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2360))->BgL_variablez00); } 
{ 
obj_t BgL_l3235z00_1413;
{ /* ./Jvm/compiler.scm 538 */
obj_t BgL_arg4484z00_1415;
{ /* ./Jvm/compiler.scm 538 */
obj_t BgL_arg4487z00_1416;
{ /* ./Jvm/compiler.scm 538 */
obj_t BgL_pairz00_2362;
BgL_pairz00_2362 = 
bgl_reverse(
(((BgL_funcallz00_bglt)CREF(BgL_ez00_67))->BgL_argsz00)); 
BgL_arg4487z00_1416 = 
CDR(BgL_pairz00_2362); } 
BgL_arg4484z00_1415 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg4487z00_1416); } 
BgL_l3235z00_1413 = BgL_arg4484z00_1415; 
BgL_forzd2each3236zd2_1414:
if(
PAIRP(BgL_l3235z00_1413))
{ /* ./Jvm/compiler.scm 537 */
{ /* ./Jvm/compiler.scm 537 */
obj_t BgL_ez00_1420;
{ /* ./Jvm/compiler.scm 537 */
obj_t BgL_pairz00_2364;
BgL_pairz00_2364 = BgL_l3235z00_1413; 
BgL_ez00_1420 = 
CAR(BgL_pairz00_2364); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_ez00_1420), BgL_envz00_68); } 
{ /* ./Jvm/compiler.scm 537 */
obj_t BgL_arg4500z00_1421;
{ /* ./Jvm/compiler.scm 537 */
obj_t BgL_pairz00_2365;
BgL_pairz00_2365 = BgL_l3235z00_1413; 
BgL_arg4500z00_1421 = 
CDR(BgL_pairz00_2365); } 
{ 
obj_t BgL_l3235z00_3717;
BgL_l3235z00_3717 = BgL_arg4500z00_1421; 
BgL_l3235z00_1413 = BgL_l3235z00_3717; 
goto BgL_forzd2each3236zd2_1414;} } }  else 
{ /* ./Jvm/compiler.scm 537 */((bool_t)1); } } } 
{ /* ./Jvm/compiler.scm 539 */
obj_t BgL_arg4505z00_1422;obj_t BgL_arg4506z00_1423;obj_t BgL_arg4507z00_1424;
BgL_arg4505z00_1422 = 
BGl_getzd2globalzd2namez00zzjvm_envz00(BgL_envz00_68, 
(BgL_globalz00_bglt)(BgL_vz00_1412)); 
BgL_arg4506z00_1423 = 
BGl_typezd2argszd2zzjvm_compilerz00(BgL_vz00_1412, BgL_envz00_68); 
{ /* ./Jvm/compiler.scm 541 */
BgL_typez00_bglt BgL_arg4512z00_1425;
BgL_arg4512z00_1425 = 
(((BgL_variablez00_bglt)CREF(BgL_vz00_1412))->BgL_typez00); 
BgL_arg4507z00_1424 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4512z00_1425), BgL_envz00_68); } 
return 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4505z00_1422, BgL_arg4506z00_1423, BgL_arg4507z00_1424);} }  else 
{ /* ./Jvm/compiler.scm 533 */
{ /* ./Jvm/compiler.scm 543 */
BgL_nodez00_bglt BgL_arg4520z00_1427;
BgL_arg4520z00_1427 = 
(((BgL_funcallz00_bglt)CREF(BgL_ez00_67))->BgL_funz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4520z00_1427, BgL_envz00_68); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 544 */
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)52))); }  else 
{ /* ./Jvm/compiler.scm 544 */BFALSE; } 
{ /* ./Jvm/compiler.scm 546 */
obj_t BgL_argsz00_1428;
{ /* ./Jvm/compiler.scm 546 */
obj_t BgL_arg4590z00_1461;
{ /* ./Jvm/compiler.scm 546 */
obj_t BgL_pairz00_2370;
{ /* ./Jvm/compiler.scm 546 */
obj_t BgL_auxz00_3731;
{ /* ./Jvm/compiler.scm 546 */
obj_t BgL_pairz00_2369;
BgL_pairz00_2369 = 
(((BgL_funcallz00_bglt)CREF(BgL_ez00_67))->BgL_argsz00); 
BgL_auxz00_3731 = 
CDR(BgL_pairz00_2369); } 
BgL_pairz00_2370 = 
bgl_reverse(BgL_auxz00_3731); } 
BgL_arg4590z00_1461 = 
CDR(BgL_pairz00_2370); } 
BgL_argsz00_1428 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg4590z00_1461); } 
{ 
obj_t BgL_l3237z00_1429;
BgL_l3237z00_1429 = BgL_argsz00_1428; 
BgL_forzd2each3238zd2_1430:
if(
PAIRP(BgL_l3237z00_1429))
{ /* ./Jvm/compiler.scm 547 */
{ /* ./Jvm/compiler.scm 547 */
obj_t BgL_ez00_1432;
{ /* ./Jvm/compiler.scm 547 */
obj_t BgL_pairz00_2372;
BgL_pairz00_2372 = BgL_l3237z00_1429; 
BgL_ez00_1432 = 
CAR(BgL_pairz00_2372); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_ez00_1432), BgL_envz00_68); } 
{ /* ./Jvm/compiler.scm 547 */
obj_t BgL_arg4529z00_1433;
{ /* ./Jvm/compiler.scm 547 */
obj_t BgL_pairz00_2373;
BgL_pairz00_2373 = BgL_l3237z00_1429; 
BgL_arg4529z00_1433 = 
CDR(BgL_pairz00_2373); } 
{ 
obj_t BgL_l3237z00_3743;
BgL_l3237z00_3743 = BgL_arg4529z00_1433; 
BgL_l3237z00_1429 = BgL_l3237z00_3743; 
goto BgL_forzd2each3238zd2_1430;} } }  else 
{ /* ./Jvm/compiler.scm 547 */((bool_t)1); } } 
{ 

{ /* ./Jvm/compiler.scm 548 */
long BgL_aux3242z00_1435;
BgL_aux3242z00_1435 = 
bgl_list_length(BgL_argsz00_1428); 
switch( BgL_aux3242z00_1435) { case ((long)0) : 

{ /* ./Jvm/compiler.scm 549 */
obj_t BgL_arg4535z00_1437;obj_t BgL_arg4536z00_1438;obj_t BgL_arg4537z00_1439;
BgL_arg4535z00_1437 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)57))); 
BgL_arg4536z00_1438 = 
CNST_TABLE_REF(((long)42)); 
BgL_arg4537z00_1439 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4535z00_1437, BgL_arg4536z00_1438, BgL_arg4537z00_1439);} break;case ((long)1) : 

{ /* ./Jvm/compiler.scm 551 */
obj_t BgL_arg4541z00_1440;obj_t BgL_arg4542z00_1441;obj_t BgL_arg4543z00_1442;
BgL_arg4541z00_1440 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)58))); 
BgL_arg4542z00_1441 = 
CNST_TABLE_REF(((long)54)); 
BgL_arg4543z00_1442 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4541z00_1440, BgL_arg4542z00_1441, BgL_arg4543z00_1442);} break;case ((long)2) : 

{ /* ./Jvm/compiler.scm 553 */
obj_t BgL_arg4547z00_1443;obj_t BgL_arg4548z00_1444;obj_t BgL_arg4549z00_1445;
BgL_arg4547z00_1443 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)59))); 
BgL_arg4548z00_1444 = 
CNST_TABLE_REF(((long)60)); 
BgL_arg4549z00_1445 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4547z00_1443, BgL_arg4548z00_1444, BgL_arg4549z00_1445);} break;case ((long)3) : 

{ /* ./Jvm/compiler.scm 555 */
obj_t BgL_arg4553z00_1446;obj_t BgL_arg4555z00_1447;obj_t BgL_arg4556z00_1448;
BgL_arg4553z00_1446 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)61))); 
BgL_arg4555z00_1447 = 
CNST_TABLE_REF(((long)62)); 
BgL_arg4556z00_1448 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4553z00_1446, BgL_arg4555z00_1447, BgL_arg4556z00_1448);} break;case ((long)4) : 

{ /* ./Jvm/compiler.scm 557 */
obj_t BgL_arg4560z00_1449;obj_t BgL_arg4561z00_1450;obj_t BgL_arg4562z00_1451;
BgL_arg4560z00_1449 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)63))); 
BgL_arg4561z00_1450 = 
CNST_TABLE_REF(((long)64)); 
BgL_arg4562z00_1451 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4560z00_1449, BgL_arg4561z00_1450, BgL_arg4562z00_1451);} break;
default: 
{ /* ./Jvm/compiler.scm 560 */
obj_t BgL_arg4570z00_1452;
BgL_arg4570z00_1452 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)7))); 
BGl__getstaticz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4570z00_1452); } 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)56))); 
{ 
obj_t BgL_l3239z00_1453;
BgL_l3239z00_1453 = BgL_argsz00_1428; 
BgL_forzd2each3240zd2_1454:
if(
PAIRP(BgL_l3239z00_1453))
{ /* ./Jvm/compiler.scm 562 */
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)56)), 
CNST_TABLE_REF(((long)54)), 
CNST_TABLE_REF(((long)55))); 
{ /* ./Jvm/compiler.scm 562 */
obj_t BgL_arg4579z00_1457;
{ /* ./Jvm/compiler.scm 562 */
obj_t BgL_pairz00_2376;
BgL_pairz00_2376 = BgL_l3239z00_1453; 
BgL_arg4579z00_1457 = 
CDR(BgL_pairz00_2376); } 
{ 
obj_t BgL_l3239z00_3782;
BgL_l3239z00_3782 = BgL_arg4579z00_1457; 
BgL_l3239z00_1453 = BgL_l3239z00_3782; 
goto BgL_forzd2each3240zd2_1454;} } }  else 
{ /* ./Jvm/compiler.scm 562 */((bool_t)1); } } 
{ /* ./Jvm/compiler.scm 565 */
obj_t BgL_arg4584z00_1458;obj_t BgL_arg4585z00_1459;obj_t BgL_arg4586z00_1460;
BgL_arg4584z00_1458 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_68, 
CNST_TABLE_REF(((long)53))); 
BgL_arg4585z00_1459 = 
CNST_TABLE_REF(((long)54)); 
BgL_arg4586z00_1460 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokevirtualz00zzjvm_instrz00(BgL_envz00_68, BgL_arg4584z00_1458, BgL_arg4585z00_1459, BgL_arg4586z00_1460);} } } } } } } } 
}



/* _compiler-funcall5431 */
obj_t BGl__compilerzd2funcall5431zd2zzjvm_compilerz00(obj_t BgL_envz00_2549, obj_t BgL_ez00_2550, obj_t BgL_envz00_2551)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 528 */
return 
BGl_compilerzd2funcallzd2zzjvm_compilerz00(
(BgL_funcallz00_bglt)(BgL_ez00_2550), 
(BgL_envz00_bglt)(BgL_envz00_2551));} 
}



/* compiler-pragma */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2pragmazd2zzjvm_compilerz00(BgL_pragmaz00_bglt BgL_ez00_69, BgL_envz00_bglt BgL_envz00_70)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 569 */
{ /* ./Jvm/compiler.scm 570 */
obj_t BgL_nz00_2379;
BgL_nz00_2379 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_69)); 
if(
CBOOL(BgL_nz00_2379))
{ /* ./Jvm/compiler.scm 570 */
BGl__linez00zzjvm_instrz00(BgL_envz00_70, BgL_nz00_2379); }  else 
{ /* ./Jvm/compiler.scm 570 */
CNST_TABLE_REF(((long)4)); } } 
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
(((BgL_pragmaz00_bglt)CREF(BgL_ez00_69))->BgL_formatz00), BGl_string5879z00zzjvm_compilerz00))
{ /* ./Jvm/compiler.scm 574 */
obj_t BgL_arg4628z00_1475;obj_t BgL_arg4630z00_1477;
BgL_arg4628z00_1475 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_70, 
CNST_TABLE_REF(((long)65))); 
if(
CBOOL(BGl_za2longislongza2z00zzjvm_envz00))
{ /* ./Jvm/compiler.scm 575 */
BgL_arg4630z00_1477 = 
CNST_TABLE_REF(((long)30)); }  else 
{ /* ./Jvm/compiler.scm 575 */
BgL_arg4630z00_1477 = 
CNST_TABLE_REF(((long)9)); } 
return 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_70, BgL_arg4628z00_1475, BNIL, BgL_arg4630z00_1477);}  else 
{ /* ./Jvm/compiler.scm 577 */
obj_t BgL_arg4636z00_1480;
{ /* ./Jvm/compiler.scm 577 */
obj_t BgL_arg4639z00_1481;obj_t BgL_arg4640z00_1482;
BgL_arg4639z00_1481 = 
(((BgL_pragmaz00_bglt)CREF(BgL_ez00_69))->BgL_formatz00); 
{ /* ./Jvm/compiler.scm 577 */
BgL_externz00_bglt BgL_obj1816z00_2382;
BgL_obj1816z00_2382 = 
(BgL_externz00_bglt)(BgL_ez00_69); 
BgL_arg4640z00_1482 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2382))->BgL_exprza2za2); } 
BgL_arg4636z00_1480 = 
MAKE_PAIR(BgL_arg4639z00_1481, BgL_arg4640z00_1482); } 
FAILURE(BGl_string5880z00zzjvm_compilerz00,BGl_string5881z00zzjvm_compilerz00,BgL_arg4636z00_1480);} } 
}



/* _compiler-pragma5433 */
obj_t BGl__compilerzd2pragma5433zd2zzjvm_compilerz00(obj_t BgL_envz00_2552, obj_t BgL_ez00_2553, obj_t BgL_envz00_2554)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 569 */
return 
BGl_compilerzd2pragmazd2zzjvm_compilerz00(
(BgL_pragmaz00_bglt)(BgL_ez00_2553), 
(BgL_envz00_bglt)(BgL_envz00_2554));} 
}



/* compiler-getfield */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2getfieldzd2zzjvm_compilerz00(BgL_getfieldz00_bglt BgL_ez00_71, BgL_envz00_bglt BgL_envz00_72)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 580 */
{ /* ./Jvm/compiler.scm 581 */
obj_t BgL_nz00_2388;
BgL_nz00_2388 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_71)); 
if(
CBOOL(BgL_nz00_2388))
{ /* ./Jvm/compiler.scm 581 */
BGl__linez00zzjvm_instrz00(BgL_envz00_72, BgL_nz00_2388); }  else 
{ /* ./Jvm/compiler.scm 581 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 583 */
obj_t BgL_arg4651z00_1486;
{ /* ./Jvm/compiler.scm 583 */
obj_t BgL_pairz00_2390;
{ /* ./Jvm/compiler.scm 583 */
BgL_externz00_bglt BgL_obj1816z00_2389;
BgL_obj1816z00_2389 = 
(BgL_externz00_bglt)(BgL_ez00_71); 
BgL_pairz00_2390 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2389))->BgL_exprza2za2); } 
BgL_arg4651z00_1486 = 
CAR(BgL_pairz00_2390); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4651z00_1486), BgL_envz00_72); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 584 */
obj_t BgL_arg4658z00_1488;
{ /* ./Jvm/compiler.scm 584 */
BgL_typez00_bglt BgL_arg4661z00_1489;
BgL_arg4661z00_1489 = 
(((BgL_getfieldz00_bglt)CREF(BgL_ez00_71))->BgL_otypez00); 
BgL_arg4658z00_1488 = 
BGl_compilezd2typezd2nowideningz00zzjvm_envz00(
(obj_t)(BgL_arg4661z00_1489), BgL_envz00_72); } 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_72, BgL_arg4658z00_1488); }  else 
{ /* ./Jvm/compiler.scm 584 */BFALSE; } 
{ /* ./Jvm/compiler.scm 586 */
obj_t BgL_arg4665z00_1490;obj_t BgL_arg4666z00_1491;
{ /* ./Jvm/compiler.scm 586 */
BgL_typez00_bglt BgL_arg4669z00_1492;
BgL_arg4669z00_1492 = 
(((BgL_getfieldz00_bglt)CREF(BgL_ez00_71))->BgL_ftypez00); 
BgL_arg4665z00_1490 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4669z00_1492), BgL_envz00_72); } 
{ /* ./Jvm/compiler.scm 587 */
obj_t BgL_arg4673z00_1493;obj_t BgL_arg4674z00_1494;obj_t BgL_arg4675z00_1495;
BgL_arg4673z00_1493 = 
(((BgL_getfieldz00_bglt)CREF(BgL_ez00_71))->BgL_fnamez00); 
{ /* ./Jvm/compiler.scm 589 */
BgL_typez00_bglt BgL_arg4679z00_1496;
BgL_arg4679z00_1496 = 
(((BgL_getfieldz00_bglt)CREF(BgL_ez00_71))->BgL_ftypez00); 
BgL_arg4674z00_1494 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4679z00_1496), BgL_envz00_72); } 
{ /* ./Jvm/compiler.scm 590 */
BgL_typez00_bglt BgL_arg4683z00_1497;
BgL_arg4683z00_1497 = 
(((BgL_getfieldz00_bglt)CREF(BgL_ez00_71))->BgL_otypez00); 
BgL_arg4675z00_1495 = 
BGl_compilezd2typezd2nowideningz00zzjvm_envz00(
(obj_t)(BgL_arg4683z00_1497), BgL_envz00_72); } 
BgL_arg4666z00_1491 = 
BGl_envzd2declarezd2fieldz00zzjvm_envz00(
(obj_t)(BgL_envz00_72), BgL_arg4673z00_1493, BgL_arg4674z00_1494, BgL_arg4675z00_1495); } 
return 
BGl__getfieldz00zzjvm_instrz00(BgL_envz00_72, BgL_arg4665z00_1490, BgL_arg4666z00_1491);} } 
}



/* _compiler-getfield5435 */
obj_t BGl__compilerzd2getfield5435zd2zzjvm_compilerz00(obj_t BgL_envz00_2555, obj_t BgL_ez00_2556, obj_t BgL_envz00_2557)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 580 */
return 
BGl_compilerzd2getfieldzd2zzjvm_compilerz00(
(BgL_getfieldz00_bglt)(BgL_ez00_2556), 
(BgL_envz00_bglt)(BgL_envz00_2557));} 
}



/* compiler-setfield */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2setfieldzd2zzjvm_compilerz00(BgL_setfieldz00_bglt BgL_ez00_73, BgL_envz00_bglt BgL_envz00_74)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 593 */
{ /* ./Jvm/compiler.scm 594 */
obj_t BgL_nz00_2398;
BgL_nz00_2398 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_73)); 
if(
CBOOL(BgL_nz00_2398))
{ /* ./Jvm/compiler.scm 594 */
BGl__linez00zzjvm_instrz00(BgL_envz00_74, BgL_nz00_2398); }  else 
{ /* ./Jvm/compiler.scm 594 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 596 */
obj_t BgL_arg4688z00_1499;
{ /* ./Jvm/compiler.scm 596 */
obj_t BgL_pairz00_2400;
{ /* ./Jvm/compiler.scm 596 */
BgL_externz00_bglt BgL_obj1816z00_2399;
BgL_obj1816z00_2399 = 
(BgL_externz00_bglt)(BgL_ez00_73); 
BgL_pairz00_2400 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2399))->BgL_exprza2za2); } 
BgL_arg4688z00_1499 = 
CAR(BgL_pairz00_2400); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4688z00_1499), BgL_envz00_74); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 597 */
obj_t BgL_arg4695z00_1501;
{ /* ./Jvm/compiler.scm 597 */
BgL_typez00_bglt BgL_arg4698z00_1502;
BgL_arg4698z00_1502 = 
(((BgL_setfieldz00_bglt)CREF(BgL_ez00_73))->BgL_otypez00); 
BgL_arg4695z00_1501 = 
BGl_compilezd2typezd2nowideningz00zzjvm_envz00(
(obj_t)(BgL_arg4698z00_1502), BgL_envz00_74); } 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_74, BgL_arg4695z00_1501); }  else 
{ /* ./Jvm/compiler.scm 597 */BFALSE; } 
{ /* ./Jvm/compiler.scm 598 */
obj_t BgL_arg4702z00_1503;
{ /* ./Jvm/compiler.scm 598 */
obj_t BgL_pairz00_2403;
{ /* ./Jvm/compiler.scm 598 */
BgL_externz00_bglt BgL_obj1816z00_2402;
BgL_obj1816z00_2402 = 
(BgL_externz00_bglt)(BgL_ez00_73); 
BgL_pairz00_2403 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2402))->BgL_exprza2za2); } 
{ /* ./Jvm/compiler.scm 598 */
obj_t BgL_pairz00_2406;
BgL_pairz00_2406 = 
CDR(BgL_pairz00_2403); 
BgL_arg4702z00_1503 = 
CAR(BgL_pairz00_2406); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4702z00_1503), BgL_envz00_74); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 599 */
obj_t BgL_arg4709z00_1505;
{ /* ./Jvm/compiler.scm 599 */
BgL_typez00_bglt BgL_arg4712z00_1506;
BgL_arg4712z00_1506 = 
(((BgL_setfieldz00_bglt)CREF(BgL_ez00_73))->BgL_ftypez00); 
BgL_arg4709z00_1505 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4712z00_1506), BgL_envz00_74); } 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_74, BgL_arg4709z00_1505); }  else 
{ /* ./Jvm/compiler.scm 599 */BFALSE; } 
{ /* ./Jvm/compiler.scm 600 */
obj_t BgL_arg4716z00_1507;
{ /* ./Jvm/compiler.scm 600 */
obj_t BgL_arg4719z00_1508;obj_t BgL_arg4720z00_1509;obj_t BgL_arg4721z00_1510;
BgL_arg4719z00_1508 = 
(((BgL_setfieldz00_bglt)CREF(BgL_ez00_73))->BgL_fnamez00); 
{ /* ./Jvm/compiler.scm 601 */
BgL_typez00_bglt BgL_arg4725z00_1511;
BgL_arg4725z00_1511 = 
(((BgL_setfieldz00_bglt)CREF(BgL_ez00_73))->BgL_ftypez00); 
BgL_arg4720z00_1509 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4725z00_1511), BgL_envz00_74); } 
{ /* ./Jvm/compiler.scm 602 */
BgL_typez00_bglt BgL_arg4729z00_1512;
BgL_arg4729z00_1512 = 
(((BgL_setfieldz00_bglt)CREF(BgL_ez00_73))->BgL_otypez00); 
BgL_arg4721z00_1510 = 
BGl_compilezd2typezd2nowideningz00zzjvm_envz00(
(obj_t)(BgL_arg4729z00_1512), BgL_envz00_74); } 
BgL_arg4716z00_1507 = 
BGl_envzd2declarezd2fieldz00zzjvm_envz00(
(obj_t)(BgL_envz00_74), BgL_arg4719z00_1508, BgL_arg4720z00_1509, BgL_arg4721z00_1510); } 
return 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_74, BgL_arg4716z00_1507);} } 
}



/* _compiler-setfield5437 */
obj_t BGl__compilerzd2setfield5437zd2zzjvm_compilerz00(obj_t BgL_envz00_2558, obj_t BgL_ez00_2559, obj_t BgL_envz00_2560)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 593 */
return 
BGl_compilerzd2setfieldzd2zzjvm_compilerz00(
(BgL_setfieldz00_bglt)(BgL_ez00_2559), 
(BgL_envz00_bglt)(BgL_envz00_2560));} 
}



/* compiler-new */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2newzd2zzjvm_compilerz00(BgL_newz00_bglt BgL_ez00_75, BgL_envz00_bglt BgL_envz00_76)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 605 */
{ /* ./Jvm/compiler.scm 606 */
obj_t BgL_nz00_2413;
BgL_nz00_2413 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_75)); 
if(
CBOOL(BgL_nz00_2413))
{ /* ./Jvm/compiler.scm 606 */
BGl__linez00zzjvm_instrz00(BgL_envz00_76, BgL_nz00_2413); }  else 
{ /* ./Jvm/compiler.scm 606 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 607 */
obj_t BgL_typez00_1513;
{ /* ./Jvm/compiler.scm 607 */
BgL_typez00_bglt BgL_arg4749z00_1521;
BgL_arg4749z00_1521 = 
BGl_typeofz00zztype_typeofz00(
(BgL_nodez00_bglt)(BgL_ez00_75)); 
BgL_typez00_1513 = 
BGl_compilezd2typezd2nowideningz00zzjvm_envz00(
(obj_t)(BgL_arg4749z00_1521), BgL_envz00_76); } 
BGl__newz00zzjvm_instrz00(BgL_envz00_76, BgL_typez00_1513); 
{ /* ./Jvm/compiler.scm 610 */
bool_t BgL_testz00_3902;
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 610 */
bool_t BgL_testz00_3905;
{ /* ./Jvm/compiler.scm 610 */
BgL_typez00_bglt BgL_arg4745z00_1520;
BgL_arg4745z00_1520 = 
BGl_typeofz00zztype_typeofz00(
(BgL_nodez00_bglt)(BgL_ez00_75)); 
{ /* ./Jvm/compiler.scm 610 */
obj_t BgL_obj2842z00_2415;
BgL_obj2842z00_2415 = 
(obj_t)(BgL_arg4745z00_1520); 
BgL_testz00_3905 = 
BGl_iszd2azf3z21zz__objectz00(BgL_obj2842z00_2415, BGl_jclassz00zzobject_classz00); } } 
if(BgL_testz00_3905)
{ /* ./Jvm/compiler.scm 610 */
BgL_testz00_3902 = ((bool_t)0)
; }  else 
{ /* ./Jvm/compiler.scm 610 */
BgL_testz00_3902 = ((bool_t)1)
; } }  else 
{ /* ./Jvm/compiler.scm 610 */
BgL_testz00_3902 = ((bool_t)0)
; } 
if(BgL_testz00_3902)
{ /* ./Jvm/compiler.scm 610 */
BGl__dupz00zzjvm_instrz00(BgL_envz00_76); 
{ /* ./Jvm/compiler.scm 613 */
obj_t BgL_arg4738z00_1516;obj_t BgL_arg4739z00_1517;obj_t BgL_arg4740z00_1518;
BgL_arg4738z00_1516 = 
BGl_envzd2declarezd2initz00zzjvm_envz00(
(obj_t)(BgL_envz00_76), BgL_typez00_1513); 
BgL_arg4739z00_1517 = 
CNST_TABLE_REF(((long)42)); 
BgL_arg4740z00_1518 = 
CNST_TABLE_REF(((long)25)); 
return 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_76, BgL_arg4738z00_1516, BgL_arg4739z00_1517, BgL_arg4740z00_1518);} }  else 
{ /* ./Jvm/compiler.scm 610 */
return BFALSE;} } } } 
}



/* _compiler-new5439 */
obj_t BGl__compilerzd2new5439zd2zzjvm_compilerz00(obj_t BgL_envz00_2561, obj_t BgL_ez00_2562, obj_t BgL_envz00_2563)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 605 */
return 
BGl_compilerzd2newzd2zzjvm_compilerz00(
(BgL_newz00_bglt)(BgL_ez00_2562), 
(BgL_envz00_bglt)(BgL_envz00_2563));} 
}



/* compiler-valloc */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2valloczd2zzjvm_compilerz00(BgL_vallocz00_bglt BgL_ez00_77, BgL_envz00_bglt BgL_envz00_78)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 616 */
{ /* ./Jvm/compiler.scm 617 */
obj_t BgL_nz00_2418;
BgL_nz00_2418 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_77)); 
if(
CBOOL(BgL_nz00_2418))
{ /* ./Jvm/compiler.scm 617 */
BGl__linez00zzjvm_instrz00(BgL_envz00_78, BgL_nz00_2418); }  else 
{ /* ./Jvm/compiler.scm 617 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 619 */
obj_t BgL_arg4755z00_1523;
{ /* ./Jvm/compiler.scm 619 */
obj_t BgL_pairz00_2420;
{ /* ./Jvm/compiler.scm 619 */
BgL_externz00_bglt BgL_obj1816z00_2419;
BgL_obj1816z00_2419 = 
(BgL_externz00_bglt)(BgL_ez00_77); 
BgL_pairz00_2420 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2419))->BgL_exprza2za2); } 
BgL_arg4755z00_1523 = 
CAR(BgL_pairz00_2420); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4755z00_1523), BgL_envz00_78); } 
{ /* ./Jvm/compiler.scm 620 */
obj_t BgL_arg4762z00_1525;
{ /* ./Jvm/compiler.scm 620 */
BgL_typez00_bglt BgL_arg4765z00_1526;
BgL_arg4765z00_1526 = 
(((BgL_vallocz00_bglt)CREF(BgL_ez00_77))->BgL_ftypez00); 
BgL_arg4762z00_1525 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4765z00_1526), BgL_envz00_78); } 
return 
BGl__newarrayz00zzjvm_instrz00(BgL_envz00_78, BgL_arg4762z00_1525);} } 
}



/* _compiler-valloc5441 */
obj_t BGl__compilerzd2valloc5441zd2zzjvm_compilerz00(obj_t BgL_envz00_2564, obj_t BgL_ez00_2565, obj_t BgL_envz00_2566)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 616 */
return 
BGl_compilerzd2valloczd2zzjvm_compilerz00(
(BgL_vallocz00_bglt)(BgL_ez00_2565), 
(BgL_envz00_bglt)(BgL_envz00_2566));} 
}



/* compiler-vref */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2vrefzd2zzjvm_compilerz00(BgL_vrefz00_bglt BgL_ez00_79, BgL_envz00_bglt BgL_envz00_80)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 623 */
{ /* ./Jvm/compiler.scm 624 */
obj_t BgL_nz00_2424;
BgL_nz00_2424 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_79)); 
if(
CBOOL(BgL_nz00_2424))
{ /* ./Jvm/compiler.scm 624 */
BGl__linez00zzjvm_instrz00(BgL_envz00_80, BgL_nz00_2424); }  else 
{ /* ./Jvm/compiler.scm 624 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 626 */
obj_t BgL_typez00_1528;
{ /* ./Jvm/compiler.scm 626 */
BgL_typez00_bglt BgL_arg4793z00_1536;
BgL_arg4793z00_1536 = 
(((BgL_vrefz00_bglt)CREF(BgL_ez00_79))->BgL_ftypez00); 
BgL_typez00_1528 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4793z00_1536), BgL_envz00_80); } 
{ /* ./Jvm/compiler.scm 627 */
obj_t BgL_arg4770z00_1529;
{ /* ./Jvm/compiler.scm 627 */
obj_t BgL_pairz00_2427;
{ /* ./Jvm/compiler.scm 627 */
BgL_externz00_bglt BgL_obj1816z00_2426;
BgL_obj1816z00_2426 = 
(BgL_externz00_bglt)(BgL_ez00_79); 
BgL_pairz00_2427 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2426))->BgL_exprza2za2); } 
BgL_arg4770z00_1529 = 
CAR(BgL_pairz00_2427); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4770z00_1529), BgL_envz00_80); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 628 */
obj_t BgL_arg4777z00_1531;
{ /* ./Jvm/compiler.scm 628 */
obj_t BgL_arg4780z00_1532;obj_t BgL_arg4781z00_1533;
BgL_arg4780z00_1532 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg4781z00_1533 = 
MAKE_PAIR(BgL_typez00_1528, BNIL); 
BgL_arg4777z00_1531 = 
MAKE_PAIR(BgL_arg4780z00_1532, BgL_arg4781z00_1533); } 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_80, BgL_arg4777z00_1531); }  else 
{ /* ./Jvm/compiler.scm 628 */BFALSE; } 
{ /* ./Jvm/compiler.scm 629 */
obj_t BgL_arg4785z00_1534;
{ /* ./Jvm/compiler.scm 629 */
obj_t BgL_pairz00_2429;
{ /* ./Jvm/compiler.scm 629 */
BgL_externz00_bglt BgL_obj1816z00_2428;
BgL_obj1816z00_2428 = 
(BgL_externz00_bglt)(BgL_ez00_79); 
BgL_pairz00_2429 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2428))->BgL_exprza2za2); } 
{ /* ./Jvm/compiler.scm 629 */
obj_t BgL_pairz00_2432;
BgL_pairz00_2432 = 
CDR(BgL_pairz00_2429); 
BgL_arg4785z00_1534 = 
CAR(BgL_pairz00_2432); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4785z00_1534), BgL_envz00_80); } 
return 
BGl__aloadz00zzjvm_instrz00(BgL_envz00_80, BgL_typez00_1528);} } 
}



/* _compiler-vref5443 */
obj_t BGl__compilerzd2vref5443zd2zzjvm_compilerz00(obj_t BgL_envz00_2567, obj_t BgL_ez00_2568, obj_t BgL_envz00_2569)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 623 */
return 
BGl_compilerzd2vrefzd2zzjvm_compilerz00(
(BgL_vrefz00_bglt)(BgL_ez00_2568), 
(BgL_envz00_bglt)(BgL_envz00_2569));} 
}



/* compiler-vset */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2vsetzd2zzjvm_compilerz00(BgL_vsetz12z12_bglt BgL_ez00_81, BgL_envz00_bglt BgL_envz00_82)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 633 */
{ /* ./Jvm/compiler.scm 634 */
obj_t BgL_nz00_2435;
BgL_nz00_2435 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_81)); 
if(
CBOOL(BgL_nz00_2435))
{ /* ./Jvm/compiler.scm 634 */
BGl__linez00zzjvm_instrz00(BgL_envz00_82, BgL_nz00_2435); }  else 
{ /* ./Jvm/compiler.scm 634 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 636 */
obj_t BgL_typez00_1538;
{ /* ./Jvm/compiler.scm 636 */
BgL_typez00_bglt BgL_arg4829z00_1548;
BgL_arg4829z00_1548 = 
(((BgL_vsetz12z12_bglt)CREF(BgL_ez00_81))->BgL_ftypez00); 
BgL_typez00_1538 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4829z00_1548), BgL_envz00_82); } 
{ /* ./Jvm/compiler.scm 637 */
obj_t BgL_arg4798z00_1539;
{ /* ./Jvm/compiler.scm 637 */
obj_t BgL_pairz00_2438;
{ /* ./Jvm/compiler.scm 637 */
BgL_externz00_bglt BgL_obj1816z00_2437;
BgL_obj1816z00_2437 = 
(BgL_externz00_bglt)(BgL_ez00_81); 
BgL_pairz00_2438 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2437))->BgL_exprza2za2); } 
BgL_arg4798z00_1539 = 
CAR(BgL_pairz00_2438); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4798z00_1539), BgL_envz00_82); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 638 */
obj_t BgL_arg4805z00_1541;
{ /* ./Jvm/compiler.scm 638 */
obj_t BgL_arg4808z00_1542;obj_t BgL_arg4809z00_1543;
BgL_arg4808z00_1542 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg4809z00_1543 = 
MAKE_PAIR(BgL_typez00_1538, BNIL); 
BgL_arg4805z00_1541 = 
MAKE_PAIR(BgL_arg4808z00_1542, BgL_arg4809z00_1543); } 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_82, BgL_arg4805z00_1541); }  else 
{ /* ./Jvm/compiler.scm 638 */BFALSE; } 
{ /* ./Jvm/compiler.scm 639 */
obj_t BgL_arg4813z00_1544;
{ /* ./Jvm/compiler.scm 639 */
obj_t BgL_pairz00_2440;
{ /* ./Jvm/compiler.scm 639 */
BgL_externz00_bglt BgL_obj1816z00_2439;
BgL_obj1816z00_2439 = 
(BgL_externz00_bglt)(BgL_ez00_81); 
BgL_pairz00_2440 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2439))->BgL_exprza2za2); } 
{ /* ./Jvm/compiler.scm 639 */
obj_t BgL_pairz00_2443;
BgL_pairz00_2443 = 
CDR(BgL_pairz00_2440); 
BgL_arg4813z00_1544 = 
CAR(BgL_pairz00_2443); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4813z00_1544), BgL_envz00_82); } 
{ /* ./Jvm/compiler.scm 640 */
obj_t BgL_arg4820z00_1546;
{ /* ./Jvm/compiler.scm 640 */
obj_t BgL_pairz00_2445;
{ /* ./Jvm/compiler.scm 640 */
BgL_externz00_bglt BgL_obj1816z00_2444;
BgL_obj1816z00_2444 = 
(BgL_externz00_bglt)(BgL_ez00_81); 
BgL_pairz00_2445 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2444))->BgL_exprza2za2); } 
{ /* ./Jvm/compiler.scm 640 */
obj_t BgL_pairz00_2450;
{ /* ./Jvm/compiler.scm 640 */
obj_t BgL_pairz00_2449;
BgL_pairz00_2449 = 
CDR(BgL_pairz00_2445); 
BgL_pairz00_2450 = 
CDR(BgL_pairz00_2449); } 
BgL_arg4820z00_1546 = 
CAR(BgL_pairz00_2450); } } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4820z00_1546), BgL_envz00_82); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 641 */
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_82, BgL_typez00_1538); }  else 
{ /* ./Jvm/compiler.scm 641 */BFALSE; } 
return 
BGl__astorez00zzjvm_instrz00(BgL_envz00_82, BgL_typez00_1538);} } 
}



/* _compiler-vset5445 */
obj_t BGl__compilerzd2vset5445zd2zzjvm_compilerz00(obj_t BgL_envz00_2570, obj_t BgL_ez00_2571, obj_t BgL_envz00_2572)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 633 */
return 
BGl_compilerzd2vsetzd2zzjvm_compilerz00(
(BgL_vsetz12z12_bglt)(BgL_ez00_2571), 
(BgL_envz00_bglt)(BgL_envz00_2572));} 
}



/* compiler-vlength */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2vlengthzd2zzjvm_compilerz00(BgL_vlengthz00_bglt BgL_ez00_83, BgL_envz00_bglt BgL_envz00_84)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 645 */
{ /* ./Jvm/compiler.scm 646 */
obj_t BgL_nz00_2453;
BgL_nz00_2453 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_83)); 
if(
CBOOL(BgL_nz00_2453))
{ /* ./Jvm/compiler.scm 646 */
BGl__linez00zzjvm_instrz00(BgL_envz00_84, BgL_nz00_2453); }  else 
{ /* ./Jvm/compiler.scm 646 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 648 */
obj_t BgL_arg4834z00_1550;
{ /* ./Jvm/compiler.scm 648 */
obj_t BgL_pairz00_2455;
{ /* ./Jvm/compiler.scm 648 */
BgL_externz00_bglt BgL_obj1816z00_2454;
BgL_obj1816z00_2454 = 
(BgL_externz00_bglt)(BgL_ez00_83); 
BgL_pairz00_2455 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2454))->BgL_exprza2za2); } 
BgL_arg4834z00_1550 = 
CAR(BgL_pairz00_2455); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4834z00_1550), BgL_envz00_84); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 649 */
obj_t BgL_arg4841z00_1552;
{ /* ./Jvm/compiler.scm 649 */
BgL_typez00_bglt BgL_arg4844z00_1553;
BgL_arg4844z00_1553 = 
(((BgL_vlengthz00_bglt)CREF(BgL_ez00_83))->BgL_vtypez00); 
BgL_arg4841z00_1552 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4844z00_1553), BgL_envz00_84); } 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_84, BgL_arg4841z00_1552); }  else 
{ /* ./Jvm/compiler.scm 649 */BFALSE; } 
return 
BGl__arraylengthz00zzjvm_instrz00(BgL_envz00_84);} 
}



/* _compiler-vlength5447 */
obj_t BGl__compilerzd2vlength5447zd2zzjvm_compilerz00(obj_t BgL_envz00_2573, obj_t BgL_ez00_2574, obj_t BgL_envz00_2575)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 645 */
return 
BGl_compilerzd2vlengthzd2zzjvm_compilerz00(
(BgL_vlengthz00_bglt)(BgL_ez00_2574), 
(BgL_envz00_bglt)(BgL_envz00_2575));} 
}



/* compiler-isa */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2isazd2zzjvm_compilerz00(BgL_isaz00_bglt BgL_ez00_85, BgL_envz00_bglt BgL_envz00_86)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 653 */
{ /* ./Jvm/compiler.scm 654 */
obj_t BgL_nz00_2459;
BgL_nz00_2459 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_85)); 
if(
CBOOL(BgL_nz00_2459))
{ /* ./Jvm/compiler.scm 654 */
BGl__linez00zzjvm_instrz00(BgL_envz00_86, BgL_nz00_2459); }  else 
{ /* ./Jvm/compiler.scm 654 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 656 */
obj_t BgL_arg4850z00_1555;
{ /* ./Jvm/compiler.scm 656 */
obj_t BgL_pairz00_2461;
{ /* ./Jvm/compiler.scm 656 */
BgL_externz00_bglt BgL_obj1816z00_2460;
BgL_obj1816z00_2460 = 
(BgL_externz00_bglt)(BgL_ez00_85); 
BgL_pairz00_2461 = 
(((BgL_externz00_bglt)CREF(BgL_obj1816z00_2460))->BgL_exprza2za2); } 
BgL_arg4850z00_1555 = 
CAR(BgL_pairz00_2461); } 
BGl_compilezd2exprzd2zzjvm_exprz00(
(BgL_nodez00_bglt)(BgL_arg4850z00_1555), BgL_envz00_86); } 
{ /* ./Jvm/compiler.scm 657 */
obj_t BgL_arg4857z00_1557;
{ /* ./Jvm/compiler.scm 657 */
BgL_typez00_bglt BgL_arg4860z00_1558;
BgL_arg4860z00_1558 = 
(((BgL_isaz00_bglt)CREF(BgL_ez00_85))->BgL_classz00); 
BgL_arg4857z00_1557 = 
BGl_compilezd2typezd2zzjvm_envz00(
(obj_t)(BgL_arg4860z00_1558), BgL_envz00_86); } 
return 
BGl__instanceofz00zzjvm_instrz00(BgL_envz00_86, BgL_arg4857z00_1557);} } 
}



/* _compiler-isa5449 */
obj_t BGl__compilerzd2isa5449zd2zzjvm_compilerz00(obj_t BgL_envz00_2576, obj_t BgL_ez00_2577, obj_t BgL_envz00_2578)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 653 */
return 
BGl_compilerzd2isazd2zzjvm_compilerz00(
(BgL_isaz00_bglt)(BgL_ez00_2577), 
(BgL_envz00_bglt)(BgL_envz00_2578));} 
}



/* compiler-cast-null */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2castzd2nullz00zzjvm_compilerz00(BgL_castzd2nullzd2_bglt BgL_ez00_87, BgL_envz00_bglt BgL_envz00_88)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 660 */
{ /* ./Jvm/compiler.scm 661 */
obj_t BgL_nz00_2465;
BgL_nz00_2465 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_87)); 
if(
CBOOL(BgL_nz00_2465))
{ /* ./Jvm/compiler.scm 661 */
BGl__linez00zzjvm_instrz00(BgL_envz00_88, BgL_nz00_2465); }  else 
{ /* ./Jvm/compiler.scm 661 */
CNST_TABLE_REF(((long)4)); } } 
return 
BGl__aconst_nullz00zzjvm_instrz00(BgL_envz00_88);} 
}



/* _compiler-cast-null */
obj_t BGl__compilerzd2castzd2nullz00zzjvm_compilerz00(obj_t BgL_envz00_2579, obj_t BgL_ez00_2580, obj_t BgL_envz00_2581)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 660 */
return 
BGl_compilerzd2castzd2nullz00zzjvm_compilerz00(
(BgL_castzd2nullzd2_bglt)(BgL_ez00_2580), 
(BgL_envz00_bglt)(BgL_envz00_2581));} 
}



/* compiler-cast */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2castzd2zzjvm_compilerz00(BgL_castz00_bglt BgL_ez00_89, BgL_envz00_bglt BgL_envz00_90, obj_t BgL_compz00_91)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 665 */
{ /* ./Jvm/compiler.scm 666 */
obj_t BgL_nz00_2470;
BgL_nz00_2470 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_89)); 
if(
CBOOL(BgL_nz00_2470))
{ /* ./Jvm/compiler.scm 666 */
BGl__linez00zzjvm_instrz00(BgL_envz00_90, BgL_nz00_2470); }  else 
{ /* ./Jvm/compiler.scm 666 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 667 */
BgL_nodez00_bglt BgL_arg4867z00_2467;
BgL_arg4867z00_2467 = 
(((BgL_castz00_bglt)CREF(BgL_ez00_89))->BgL_argz00); 
return 
PROCEDURE_ENTRY(BgL_compz00_91)(BgL_compz00_91, 
(obj_t)(BgL_arg4867z00_2467), 
(obj_t)(BgL_envz00_90), BEOA);} } 
}



/* _compiler-cast5452 */
obj_t BGl__compilerzd2cast5452zd2zzjvm_compilerz00(obj_t BgL_envz00_2582, obj_t BgL_ez00_2583, obj_t BgL_envz00_2584, obj_t BgL_compz00_2585)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 665 */
return 
BGl_compilerzd2castzd2zzjvm_compilerz00(
(BgL_castz00_bglt)(BgL_ez00_2583), 
(BgL_envz00_bglt)(BgL_envz00_2584), BgL_compz00_2585);} 
}



/* compiler-setexit */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2setexitzd2zzjvm_compilerz00(BgL_setzd2exzd2itz00_bglt BgL_ez00_92, BgL_envz00_bglt BgL_envz00_93, obj_t BgL_compz00_94)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 671 */
{ /* ./Jvm/compiler.scm 672 */
obj_t BgL_nz00_2474;
BgL_nz00_2474 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_92)); 
if(
CBOOL(BgL_nz00_2474))
{ /* ./Jvm/compiler.scm 672 */
BGl__linez00zzjvm_instrz00(BgL_envz00_93, BgL_nz00_2474); }  else 
{ /* ./Jvm/compiler.scm 672 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 674 */
BgL_variablez00_bglt BgL_localz00_1562;
{ /* ./Jvm/compiler.scm 674 */
BgL_varz00_bglt BgL_obj1625z00_2476;
BgL_obj1625z00_2476 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_ez00_92))->BgL_varz00); 
BgL_localz00_1562 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2476))->BgL_variablez00); } 
{ /* ./Jvm/compiler.scm 675 */
obj_t BgL_arg4872z00_1563;obj_t BgL_arg4874z00_1565;
BgL_arg4872z00_1563 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_93, 
CNST_TABLE_REF(((long)66))); 
BgL_arg4874z00_1565 = 
CNST_TABLE_REF(((long)55)); 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_93, BgL_arg4872z00_1563, BNIL, BgL_arg4874z00_1565); } 
{ /* ./Jvm/compiler.scm 676 */
obj_t BgL_arg4878z00_1566;
BgL_arg4878z00_1566 = 
BGl_envzd2declarezd2newzd2localzd2zzjvm_envz00(BgL_envz00_93, 
(BgL_localz00_bglt)(BgL_localz00_1562)); 
BGl__storez00zzjvm_instrz00(BgL_envz00_93, 
(BgL_localz00_bglt)(BgL_arg4878z00_1566)); } 
{ /* ./Jvm/compiler.scm 677 */
obj_t BgL_begz00_1567;obj_t BgL_endz00_1568;obj_t BgL_labz00_1569;obj_t BgL_contz00_1570;
BgL_begz00_1567 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5882z00zzjvm_compilerz00, BEOA); 
BgL_endz00_1568 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5883z00zzjvm_compilerz00, BEOA); 
BgL_labz00_1569 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5884z00zzjvm_compilerz00, BEOA); 
BgL_contz00_1570 = 
PROCEDURE_ENTRY(BGl_gensymz00zz__r4_symbols_6_4z00)(BGl_gensymz00zz__r4_symbols_6_4z00, BGl_string5870z00zzjvm_compilerz00, BEOA); 
{ /* ./Jvm/compiler.scm 681 */
obj_t BgL_arg4882z00_1571;
BgL_arg4882z00_1571 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_93, 
CNST_TABLE_REF(((long)67))); 
BGl__handlerz00zzjvm_instrz00(BgL_envz00_93, BgL_begz00_1567, BgL_endz00_1568, BgL_labz00_1569, BgL_arg4882z00_1571); } 
BGl__labelz00zzjvm_instrz00(BgL_envz00_93, BgL_begz00_1567); 
{ /* ./Jvm/compiler.scm 683 */
BgL_nodez00_bglt BgL_arg4887z00_1572;
BgL_arg4887z00_1572 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_ez00_92))->BgL_bodyz00); 
PROCEDURE_ENTRY(BgL_compz00_94)(BgL_compz00_94, 
(obj_t)(BgL_arg4887z00_1572), 
(obj_t)(BgL_envz00_93), BEOA); } 
BGl__labelz00zzjvm_instrz00(BgL_envz00_93, BgL_endz00_1568); 
{ /* ./Jvm/compiler.scm 685 */
obj_t BgL_stackz00_1573;
BgL_stackz00_1573 = 
(((BgL_envz00_bglt)CREF(BgL_envz00_93))->BgL_stackz00); 
BGl__gotoz00zzjvm_instrz00(BgL_envz00_93, BgL_contz00_1570); 
BGl__labelz00zzjvm_instrz00(BgL_envz00_93, BgL_labz00_1569); 
{ /* ./Jvm/compiler.scm 688 */
BgL_envz00_bglt BgL_obj3069z00_2479;obj_t BgL_val3068z00_2480;
BgL_obj3069z00_2479 = BgL_envz00_93; 
BgL_val3068z00_2480 = 
CNST_TABLE_REF(((long)42)); 
((((BgL_envz00_bglt)CREF(BgL_obj3069z00_2479))->BgL_stackz00) = ((obj_t)BgL_val3068z00_2480), BUNSPEC); } 
{ /* ./Jvm/compiler.scm 689 */
BgL_variablez00_bglt BgL_arg4895z00_1574;
{ /* ./Jvm/compiler.scm 689 */
BgL_varz00_bglt BgL_obj1625z00_2482;
BgL_obj1625z00_2482 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_ez00_92))->BgL_varz00); 
BgL_arg4895z00_1574 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2482))->BgL_variablez00); } 
BGl__loadz00zzjvm_instrz00(BgL_envz00_93, 
(BgL_localz00_bglt)(BgL_arg4895z00_1574)); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 691 */
obj_t BgL_arg4903z00_1576;
BgL_arg4903z00_1576 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_93, 
CNST_TABLE_REF(((long)68))); 
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_93, BgL_arg4903z00_1576); }  else 
{ /* ./Jvm/compiler.scm 691 */BFALSE; } 
{ /* ./Jvm/compiler.scm 692 */
obj_t BgL_arg4907z00_1577;obj_t BgL_arg4908z00_1578;obj_t BgL_arg4909z00_1579;
BgL_arg4907z00_1577 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_93, 
CNST_TABLE_REF(((long)69))); 
BgL_arg4908z00_1578 = 
CNST_TABLE_REF(((long)54)); 
BgL_arg4909z00_1579 = 
CNST_TABLE_REF(((long)55)); 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_93, BgL_arg4907z00_1577, BgL_arg4908z00_1578, BgL_arg4909z00_1579); } 
{ /* ./Jvm/compiler.scm 695 */
BgL_envz00_bglt BgL_obj3069z00_2483;obj_t BgL_val3068z00_2484;
BgL_obj3069z00_2483 = BgL_envz00_93; 
BgL_val3068z00_2484 = BgL_stackz00_1573; 
((((BgL_envz00_bglt)CREF(BgL_obj3069z00_2483))->BgL_stackz00) = ((obj_t)BgL_val3068z00_2484), BUNSPEC); } 
return 
BGl__labelz00zzjvm_instrz00(BgL_envz00_93, BgL_contz00_1570);} } } } 
}



/* _compiler-setexit5454 */
obj_t BGl__compilerzd2setexit5454zd2zzjvm_compilerz00(obj_t BgL_envz00_2586, obj_t BgL_ez00_2587, obj_t BgL_envz00_2588, obj_t BgL_compz00_2589)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 671 */
return 
BGl_compilerzd2setexitzd2zzjvm_compilerz00(
(BgL_setzd2exzd2itz00_bglt)(BgL_ez00_2587), 
(BgL_envz00_bglt)(BgL_envz00_2588), BgL_compz00_2589);} 
}



/* compiler-jump-exit */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2jumpzd2exitz00zzjvm_compilerz00(BgL_jumpzd2exzd2itz00_bglt BgL_ez00_95, BgL_envz00_bglt BgL_envz00_96)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 699 */
{ /* ./Jvm/compiler.scm 700 */
obj_t BgL_nz00_2487;
BgL_nz00_2487 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_95)); 
if(
CBOOL(BgL_nz00_2487))
{ /* ./Jvm/compiler.scm 700 */
BGl__linez00zzjvm_instrz00(BgL_envz00_96, BgL_nz00_2487); }  else 
{ /* ./Jvm/compiler.scm 700 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 702 */
BgL_nodez00_bglt BgL_arg4925z00_1582;
BgL_arg4925z00_1582 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_ez00_95))->BgL_exitz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4925z00_1582, BgL_envz00_96); } 
{ /* ./Jvm/compiler.scm 703 */
BgL_nodez00_bglt BgL_arg4929z00_1583;
BgL_arg4929z00_1583 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_ez00_95))->BgL_valuez00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4929z00_1583, BgL_envz00_96); } 
{ /* ./Jvm/compiler.scm 704 */
obj_t BgL_arg4933z00_1584;obj_t BgL_arg4934z00_1585;obj_t BgL_arg4935z00_1586;
BgL_arg4933z00_1584 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_96, 
CNST_TABLE_REF(((long)70))); 
BgL_arg4934z00_1585 = 
CNST_TABLE_REF(((long)54)); 
BgL_arg4935z00_1586 = 
CNST_TABLE_REF(((long)55)); 
return 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_96, BgL_arg4933z00_1584, BgL_arg4934z00_1585, BgL_arg4935z00_1586);} } 
}



/* _compiler-jump-exit5456 */
obj_t BGl__compilerzd2jumpzd2exit5456z00zzjvm_compilerz00(obj_t BgL_envz00_2590, obj_t BgL_ez00_2591, obj_t BgL_envz00_2592)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 699 */
return 
BGl_compilerzd2jumpzd2exitz00zzjvm_compilerz00(
(BgL_jumpzd2exzd2itz00_bglt)(BgL_ez00_2591), 
(BgL_envz00_bglt)(BgL_envz00_2592));} 
}



/* compiler-fail */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2failzd2zzjvm_compilerz00(BgL_failz00_bglt BgL_ez00_97, BgL_envz00_bglt BgL_envz00_98)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 707 */
{ /* ./Jvm/compiler.scm 708 */
obj_t BgL_nz00_2492;
BgL_nz00_2492 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_97)); 
if(
CBOOL(BgL_nz00_2492))
{ /* ./Jvm/compiler.scm 708 */
BGl__linez00zzjvm_instrz00(BgL_envz00_98, BgL_nz00_2492); }  else 
{ /* ./Jvm/compiler.scm 708 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 710 */
BgL_nodez00_bglt BgL_arg4940z00_1588;
BgL_arg4940z00_1588 = 
(((BgL_failz00_bglt)CREF(BgL_ez00_97))->BgL_procz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4940z00_1588, BgL_envz00_98); } 
{ /* ./Jvm/compiler.scm 711 */
BgL_nodez00_bglt BgL_arg4944z00_1589;
BgL_arg4944z00_1589 = 
(((BgL_failz00_bglt)CREF(BgL_ez00_97))->BgL_msgz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4944z00_1589, BgL_envz00_98); } 
{ /* ./Jvm/compiler.scm 712 */
BgL_nodez00_bglt BgL_arg4948z00_1590;
BgL_arg4948z00_1590 = 
(((BgL_failz00_bglt)CREF(BgL_ez00_97))->BgL_objz00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4948z00_1590, BgL_envz00_98); } 
{ /* ./Jvm/compiler.scm 713 */
obj_t BgL_arg4952z00_1591;obj_t BgL_arg4953z00_1592;obj_t BgL_arg4954z00_1593;
BgL_arg4952z00_1591 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_98, 
CNST_TABLE_REF(((long)71))); 
BgL_arg4953z00_1592 = 
CNST_TABLE_REF(((long)60)); 
BgL_arg4954z00_1593 = 
CNST_TABLE_REF(((long)55)); 
BGl__invokestaticz00zzjvm_instrz00(BgL_envz00_98, BgL_arg4952z00_1591, BgL_arg4953z00_1592, BgL_arg4954z00_1593); } 
return 
BGl__athrowz00zzjvm_instrz00(BgL_envz00_98);} 
}



/* _compiler-fail5458 */
obj_t BGl__compilerzd2fail5458zd2zzjvm_compilerz00(obj_t BgL_envz00_2593, obj_t BgL_ez00_2594, obj_t BgL_envz00_2595)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 707 */
return 
BGl_compilerzd2failzd2zzjvm_compilerz00(
(BgL_failz00_bglt)(BgL_ez00_2594), 
(BgL_envz00_bglt)(BgL_envz00_2595));} 
}



/* compiler-make-box */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2makezd2boxz00zzjvm_compilerz00(BgL_makezd2boxzd2_bglt BgL_ez00_99, BgL_envz00_bglt BgL_envz00_100)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 717 */
{ /* ./Jvm/compiler.scm 718 */
obj_t BgL_nz00_2498;
BgL_nz00_2498 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_99)); 
if(
CBOOL(BgL_nz00_2498))
{ /* ./Jvm/compiler.scm 718 */
BGl__linez00zzjvm_instrz00(BgL_envz00_100, BgL_nz00_2498); }  else 
{ /* ./Jvm/compiler.scm 718 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 720 */
obj_t BgL_arg4960z00_1595;
BgL_arg4960z00_1595 = 
BGl_compilezd2typezd2zzjvm_envz00(
CNST_TABLE_REF(((long)72)), BgL_envz00_100); 
BGl__newz00zzjvm_instrz00(BgL_envz00_100, BgL_arg4960z00_1595); } 
BGl__dupz00zzjvm_instrz00(BgL_envz00_100); 
{ /* ./Jvm/compiler.scm 722 */
BgL_nodez00_bglt BgL_arg4965z00_1596;
BgL_arg4965z00_1596 = 
(((BgL_makezd2boxzd2_bglt)CREF(BgL_ez00_99))->BgL_valuez00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg4965z00_1596, BgL_envz00_100); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 724 */
obj_t BgL_arg4969z00_1597;obj_t BgL_arg4970z00_1598;obj_t BgL_arg4971z00_1599;
BgL_arg4969z00_1597 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_100, 
CNST_TABLE_REF(((long)73))); 
BgL_arg4970z00_1598 = 
CNST_TABLE_REF(((long)54)); 
BgL_arg4971z00_1599 = 
CNST_TABLE_REF(((long)25)); 
return 
BGl__invokespecialz00zzjvm_instrz00(BgL_envz00_100, BgL_arg4969z00_1597, BgL_arg4970z00_1598, BgL_arg4971z00_1599);}  else 
{ /* ./Jvm/compiler.scm 725 */
obj_t BgL_arg4976z00_1600;
BgL_arg4976z00_1600 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_100, 
CNST_TABLE_REF(((long)74))); 
return 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_100, BgL_arg4976z00_1600);} } 
}



/* _compiler-make-box5460 */
obj_t BGl__compilerzd2makezd2box5460z00zzjvm_compilerz00(obj_t BgL_envz00_2596, obj_t BgL_ez00_2597, obj_t BgL_envz00_2598)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 717 */
return 
BGl_compilerzd2makezd2boxz00zzjvm_compilerz00(
(BgL_makezd2boxzd2_bglt)(BgL_ez00_2597), 
(BgL_envz00_bglt)(BgL_envz00_2598));} 
}



/* compiler-box-ref */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2boxzd2refz00zzjvm_compilerz00(BgL_boxzd2refzd2_bglt BgL_ez00_101, BgL_envz00_bglt BgL_envz00_102)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 728 */
{ /* ./Jvm/compiler.scm 729 */
obj_t BgL_nz00_2502;
BgL_nz00_2502 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_101)); 
if(
CBOOL(BgL_nz00_2502))
{ /* ./Jvm/compiler.scm 729 */
BGl__linez00zzjvm_instrz00(BgL_envz00_102, BgL_nz00_2502); }  else 
{ /* ./Jvm/compiler.scm 729 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 731 */
BgL_variablez00_bglt BgL_arg4981z00_1602;
{ /* ./Jvm/compiler.scm 731 */
BgL_varz00_bglt BgL_obj1625z00_2504;
BgL_obj1625z00_2504 = 
(((BgL_boxzd2refzd2_bglt)CREF(BgL_ez00_101))->BgL_varz00); 
BgL_arg4981z00_1602 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2504))->BgL_variablez00); } 
BGl__loadz00zzjvm_instrz00(BgL_envz00_102, 
(BgL_localz00_bglt)(BgL_arg4981z00_1602)); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 732 */
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_102, 
CNST_TABLE_REF(((long)75))); }  else 
{ /* ./Jvm/compiler.scm 732 */BFALSE; } 
{ /* ./Jvm/compiler.scm 733 */
obj_t BgL_arg4989z00_1604;obj_t BgL_arg4990z00_1605;
BgL_arg4989z00_1604 = 
CNST_TABLE_REF(((long)45)); 
BgL_arg4990z00_1605 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_102, 
CNST_TABLE_REF(((long)74))); 
return 
BGl__getfieldz00zzjvm_instrz00(BgL_envz00_102, BgL_arg4989z00_1604, BgL_arg4990z00_1605);} } 
}



/* _compiler-box-ref5462 */
obj_t BGl__compilerzd2boxzd2ref5462z00zzjvm_compilerz00(obj_t BgL_envz00_2599, obj_t BgL_ez00_2600, obj_t BgL_envz00_2601)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 728 */
return 
BGl_compilerzd2boxzd2refz00zzjvm_compilerz00(
(BgL_boxzd2refzd2_bglt)(BgL_ez00_2600), 
(BgL_envz00_bglt)(BgL_envz00_2601));} 
}



/* compiler-box-set! */
BGL_EXPORTED_DEF obj_t BGl_compilerzd2boxzd2setz12z12zzjvm_compilerz00(BgL_boxzd2setz12zc0_bglt BgL_ez00_103, BgL_envz00_bglt BgL_envz00_104)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 736 */
{ /* ./Jvm/compiler.scm 737 */
obj_t BgL_nz00_2507;
BgL_nz00_2507 = 
BGl_getzd2linezd2numberz00zzjvm_externz00(
(BgL_nodez00_bglt)(BgL_ez00_103)); 
if(
CBOOL(BgL_nz00_2507))
{ /* ./Jvm/compiler.scm 737 */
BGl__linez00zzjvm_instrz00(BgL_envz00_104, BgL_nz00_2507); }  else 
{ /* ./Jvm/compiler.scm 737 */
CNST_TABLE_REF(((long)4)); } } 
{ /* ./Jvm/compiler.scm 738 */
BgL_variablez00_bglt BgL_arg4995z00_1606;
{ /* ./Jvm/compiler.scm 738 */
BgL_varz00_bglt BgL_obj1625z00_2509;
BgL_obj1625z00_2509 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_ez00_103))->BgL_varz00); 
BgL_arg4995z00_1606 = 
(((BgL_varz00_bglt)CREF(BgL_obj1625z00_2509))->BgL_variablez00); } 
BGl__loadz00zzjvm_instrz00(BgL_envz00_104, 
(BgL_localz00_bglt)(BgL_arg4995z00_1606)); } 
if(
CBOOL(BGl_za2purifyza2z00zzengine_paramz00))
{ /* ./Jvm/compiler.scm 739 */
BGl__checkcastz00zzjvm_instrz00(BgL_envz00_104, 
CNST_TABLE_REF(((long)75))); }  else 
{ /* ./Jvm/compiler.scm 739 */BFALSE; } 
{ /* ./Jvm/compiler.scm 740 */
BgL_nodez00_bglt BgL_arg5003z00_1608;
BgL_arg5003z00_1608 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_ez00_103))->BgL_valuez00); 
BGl_compilezd2exprzd2zzjvm_exprz00(BgL_arg5003z00_1608, BgL_envz00_104); } 
{ /* ./Jvm/compiler.scm 741 */
obj_t BgL_arg5007z00_1609;
BgL_arg5007z00_1609 = 
BGl_jlibzd2declarezd2zzjvm_envz00(BgL_envz00_104, 
CNST_TABLE_REF(((long)74))); 
return 
BGl__putfieldz00zzjvm_instrz00(BgL_envz00_104, BgL_arg5007z00_1609);} } 
}



/* _compiler-box-set!5464 */
obj_t BGl__compilerzd2boxzd2setz125464z12zzjvm_compilerz00(obj_t BgL_envz00_2602, obj_t BgL_ez00_2603, obj_t BgL_envz00_2604)
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 736 */
return 
BGl_compilerzd2boxzd2setz12z12zzjvm_compilerz00(
(BgL_boxzd2setz12zc0_bglt)(BgL_ez00_2603), 
(BgL_envz00_bglt)(BgL_envz00_2604));} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzjvm_compilerz00()
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 8 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzjvm_compilerz00()
{ AN_OBJECT;
{ /* ./Jvm/compiler.scm 8 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zztype_typeofz00(((long)852), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)44246), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzengine_paramz00(((long)2473), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzobject_classz00(((long)30791), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzforeign_jtypez00(((long)33635), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_lispz00(((long)16895), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_externz00(((long)3672), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_envz00(((long)58889), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_instrz00(((long)18045), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_inlinez00(((long)20777), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_tailz00(((long)9504), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_exprz00(((long)25872), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_effectz00(((long)54912), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
BGl_modulezd2initializa7ationz75zzjvm_predicatez00(((long)50624), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00)); 
return 
BGl_modulezd2initializa7ationz75zztools_shapez00(((long)30833), 
BSTRING_TO_STRING(BGl_string5885z00zzjvm_compilerz00));} 
}

